﻿from typing import List, Optional, Dict, Iterable
import aspose.pycore
import aspose.pydrawing
import aspose.slides
import aspose.slides.animation
import aspose.slides.charts
import aspose.slides.dom.ole
import aspose.slides.effects
import aspose.slides.export
import aspose.slides.export.web
import aspose.slides.export.xaml
import aspose.slides.importing
import aspose.slides.ink
import aspose.slides.lowcode
import aspose.slides.mathtext
import aspose.slides.slideshow
import aspose.slides.smartart
import aspose.slides.spreadsheet
import aspose.slides.theme
import aspose.slides.util
import aspose.slides.vba
import aspose.slides.warnings

class AxesCompositionNotCombinableException:
    def __init__(self):
        ...

    def __init__(self, message: string):
        ...

    ...

class AxesManager:
    '''Provides access to chart axes.'''
    @property
    def horizontal_axis(self) -> IAxis:
        ...

    @property
    def secondary_horizontal_axis(self) -> IAxis:
        ...

    @property
    def vertical_axis(self) -> IAxis:
        ...

    @property
    def secondary_vertical_axis(self) -> IAxis:
        ...

    @property
    def series_axis(self) -> IAxis:
        ...

    ...

class Axis:
    '''Encapsulates the object that represents a chart's axis.'''
    def set_category_axis_type_automatically(self) -> None:
        '''Sets IAxis.CategoryAxisType property with a value that is automatically determined based on axis data.'''
        ...

    @property
    def chart(self) -> IChart:
        ...

    @property
    def axis_between_categories(self) -> bool:
        ...

    @axis_between_categories.setter
    def axis_between_categories(self, value: bool):
        ...

    @property
    def category_axis_type(self) -> CategoryAxisType:
        ...

    @category_axis_type.setter
    def category_axis_type(self, value: CategoryAxisType):
        ...

    @property
    def cross_at(self) -> float:
        ...

    @cross_at.setter
    def cross_at(self, value: float):
        ...

    @property
    def display_unit(self) -> DisplayUnitType:
        ...

    @display_unit.setter
    def display_unit(self, value: DisplayUnitType):
        ...

    @property
    def actual_max_value(self) -> float:
        ...

    @property
    def actual_min_value(self) -> float:
        ...

    @property
    def actual_major_unit(self) -> float:
        ...

    @property
    def actual_minor_unit(self) -> float:
        ...

    @property
    def actual_major_unit_scale(self) -> TimeUnitType:
        ...

    @property
    def actual_minor_unit_scale(self) -> TimeUnitType:
        ...

    @property
    def is_automatic_max_value(self) -> bool:
        ...

    @is_automatic_max_value.setter
    def is_automatic_max_value(self, value: bool):
        ...

    @property
    def max_value(self) -> float:
        ...

    @max_value.setter
    def max_value(self, value: float):
        ...

    @property
    def minor_unit(self) -> float:
        ...

    @minor_unit.setter
    def minor_unit(self, value: float):
        ...

    @property
    def is_automatic_minor_unit(self) -> bool:
        ...

    @is_automatic_minor_unit.setter
    def is_automatic_minor_unit(self, value: bool):
        ...

    @property
    def major_unit(self) -> float:
        ...

    @major_unit.setter
    def major_unit(self, value: float):
        ...

    @property
    def is_automatic_major_unit(self) -> bool:
        ...

    @is_automatic_major_unit.setter
    def is_automatic_major_unit(self, value: bool):
        ...

    @property
    def is_automatic_min_value(self) -> bool:
        ...

    @is_automatic_min_value.setter
    def is_automatic_min_value(self, value: bool):
        ...

    @property
    def min_value(self) -> float:
        ...

    @min_value.setter
    def min_value(self, value: float):
        ...

    @property
    def is_logarithmic(self) -> bool:
        ...

    @is_logarithmic.setter
    def is_logarithmic(self, value: bool):
        ...

    @property
    def log_base(self) -> float:
        ...

    @log_base.setter
    def log_base(self, value: float):
        ...

    @property
    def is_plot_order_reversed(self) -> bool:
        ...

    @is_plot_order_reversed.setter
    def is_plot_order_reversed(self, value: bool):
        ...

    @property
    def is_visible(self) -> bool:
        ...

    @is_visible.setter
    def is_visible(self, value: bool):
        ...

    @property
    def major_tick_mark(self) -> TickMarkType:
        ...

    @major_tick_mark.setter
    def major_tick_mark(self, value: TickMarkType):
        ...

    @property
    def minor_tick_mark(self) -> TickMarkType:
        ...

    @minor_tick_mark.setter
    def minor_tick_mark(self, value: TickMarkType):
        ...

    @property
    def tick_label_position(self) -> TickLabelPositionType:
        ...

    @tick_label_position.setter
    def tick_label_position(self, value: TickLabelPositionType):
        ...

    @property
    def major_unit_scale(self) -> TimeUnitType:
        ...

    @major_unit_scale.setter
    def major_unit_scale(self, value: TimeUnitType):
        ...

    @property
    def minor_unit_scale(self) -> TimeUnitType:
        ...

    @minor_unit_scale.setter
    def minor_unit_scale(self, value: TimeUnitType):
        ...

    @property
    def base_unit_scale(self) -> TimeUnitType:
        ...

    @base_unit_scale.setter
    def base_unit_scale(self, value: TimeUnitType):
        ...

    @property
    def minor_grid_lines_format(self) -> IChartLinesFormat:
        ...

    @property
    def major_grid_lines_format(self) -> IChartLinesFormat:
        ...

    @property
    def show_minor_grid_lines(self) -> bool:
        ...

    @property
    def show_major_grid_lines(self) -> bool:
        ...

    @property
    def format(self) -> IAxisFormat:
        ...

    @property
    def text_format(self) -> IChartTextFormat:
        ...

    @property
    def title(self) -> IChartTitle:
        ...

    @property
    def cross_type(self) -> CrossesType:
        ...

    @cross_type.setter
    def cross_type(self, value: CrossesType):
        ...

    @property
    def position(self) -> AxisPositionType:
        ...

    @position.setter
    def position(self, value: AxisPositionType):
        ...

    @property
    def has_title(self) -> bool:
        ...

    @has_title.setter
    def has_title(self, value: bool):
        ...

    @property
    def number_format(self) -> string:
        ...

    @number_format.setter
    def number_format(self, value: string):
        ...

    @property
    def is_number_format_linked_to_source(self) -> bool:
        ...

    @is_number_format_linked_to_source.setter
    def is_number_format_linked_to_source(self, value: bool):
        ...

    @property
    def tick_label_rotation_angle(self) -> float:
        ...

    @tick_label_rotation_angle.setter
    def tick_label_rotation_angle(self, value: float):
        ...

    @property
    def tick_label_spacing(self) -> int:
        ...

    @tick_label_spacing.setter
    def tick_label_spacing(self, value: int):
        ...

    @property
    def is_automatic_tick_label_spacing(self) -> bool:
        ...

    @is_automatic_tick_label_spacing.setter
    def is_automatic_tick_label_spacing(self, value: bool):
        ...

    @property
    def tick_marks_spacing(self) -> int:
        ...

    @tick_marks_spacing.setter
    def tick_marks_spacing(self, value: int):
        ...

    @property
    def is_automatic_tick_marks_spacing(self) -> bool:
        ...

    @is_automatic_tick_marks_spacing.setter
    def is_automatic_tick_marks_spacing(self, value: bool):
        ...

    @property
    def label_offset(self) -> int:
        ...

    @label_offset.setter
    def label_offset(self, value: int):
        ...

    @property
    def aggregation_type(self) -> AxisAggregationType:
        ...

    @aggregation_type.setter
    def aggregation_type(self, value: AxisAggregationType):
        ...

    @property
    def bin_width(self) -> float:
        ...

    @bin_width.setter
    def bin_width(self, value: float):
        ...

    @property
    def number_of_bins(self) -> int:
        ...

    @number_of_bins.setter
    def number_of_bins(self, value: int):
        ...

    @property
    def is_overflow_bin(self) -> bool:
        ...

    @is_overflow_bin.setter
    def is_overflow_bin(self, value: bool):
        ...

    @property
    def is_automatic_overflow_bin(self) -> bool:
        ...

    @is_automatic_overflow_bin.setter
    def is_automatic_overflow_bin(self, value: bool):
        ...

    @property
    def overflow_bin(self) -> float:
        ...

    @overflow_bin.setter
    def overflow_bin(self, value: float):
        ...

    @property
    def is_underflow_bin(self) -> bool:
        ...

    @is_underflow_bin.setter
    def is_underflow_bin(self, value: bool):
        ...

    @property
    def is_automatic_underflow_bin(self) -> bool:
        ...

    @is_automatic_underflow_bin.setter
    def is_automatic_underflow_bin(self, value: bool):
        ...

    @property
    def underflow_bin(self) -> float:
        ...

    @underflow_bin.setter
    def underflow_bin(self, value: float):
        ...

    @property
    def as_i_formatted_text_container(self) -> IFormattedTextContainer:
        ...

    @property
    def as_i_chart_component(self) -> IChartComponent:
        ...

    @property
    def as_i_slide_component(self) -> ISlideComponent:
        ...

    @property
    def slide(self) -> IBaseSlide:
        ...

    @property
    def as_i_presentation_component(self) -> IPresentationComponent:
        ...

    @property
    def presentation(self) -> IPresentation:
        ...

    ...

class AxisFormat:
    '''Represents chart format properties.'''
    @property
    def fill(self) -> IFillFormat:
        ...

    @property
    def line(self) -> ILineFormat:
        ...

    @property
    def effect(self) -> IEffectFormat:
        ...

    ...

class BaseChartValue:
    '''Represents a value of a chart.'''
    @property
    def data_source_type(self) -> DataSourceType:
        ...

    @data_source_type.setter
    def data_source_type(self, value: DataSourceType):
        ...

    @property
    def data(self) -> any:
        ...

    @data.setter
    def data(self, value: any):
        ...

    ...

class CannotCombine2DAnd3DChartsException:
    def __init__(self):
        ...

    def __init__(self, message: string):
        ...

    ...

class Chart(aspose.slides.GraphicalObject):
    '''Represents an graphic chart on a slide.'''
    @overload
    def get_thumbnail(self) -> aspose.pydrawing.Bitmap:
        '''Returns shape thumbnail.
                    ShapeThumbnailBounds.Shape shape thumbnail bounds type is used by default.
        :returns: Shape thumbnail.'''
        ...

    @overload
    def get_thumbnail(self, bounds: ShapeThumbnailBounds, scale_x: float, scale_y: float) -> aspose.pydrawing.Bitmap:
        ...

    @overload
    def get_image(self) -> IImage:
        '''Returns shape thumbnail.
                    ShapeThumbnailBounds.Shape shape thumbnail bounds type is used by default.
        :returns: Shape thumbnail.'''
        ...

    @overload
    def get_image(self, bounds: ShapeThumbnailBounds, scale_x: float, scale_y: float) -> IImage:
        ...

    @overload
    def write_as_svg(self, stream: System.IO.Stream) -> None:
        '''Saves content of Shape as SVG file.
        :param stream: Target stream'''
        ...

    @overload
    def write_as_svg(self, stream: System.IO.Stream, svg_options: aspose.slides.export.ISVGOptions) -> None:
        '''Saves content of Shape as SVG file.
        :param stream: Target stream
        :param svg_options: SVG generation options'''
        ...

    def remove_placeholder(self) -> None:
        '''Defines that this shape isn't a placeholder.'''
        ...

    def add_placeholder(self, placeholder_to_copy_from: IPlaceholder) -> IPlaceholder:
        ...

    def get_base_placeholder(self) -> IShape:
        '''Returns a basic placeholder shape (shape from the layout and/or master slide that the current shape is inherited from).'''
        ...

    def validate_chart_layout(self) -> None:
        '''Calculates actual values of chart elements. The actual values include position of elements that implement IActualLayout interface 
                    (IActualLayout.ActualX, IActualLayout.ActualY, IActualLayout.ActualWidth, IActualLayout.ActualHeight)
                    and actual axes values (IAxis.ActualMaxValue, IAxis.ActualMinValue, IAxis.ActualMajorUnit, IAxis.ActualMinorUnit, 
                    IAxis.ActualMajorUnitScale, IAxis.ActualMinorUnitScale)'''
        ...

    def create_theme_effective(self) -> aspose.slides.theme.IThemeEffectiveData:
        '''Returns an effective theme for this chart.'''
        ...

    @property
    def is_text_holder(self) -> bool:
        ...

    @property
    def placeholder(self) -> IPlaceholder:
        ...

    @property
    def custom_data(self) -> ICustomData:
        ...

    @property
    def raw_frame(self) -> IShapeFrame:
        ...

    @raw_frame.setter
    def raw_frame(self, value: IShapeFrame):
        ...

    @property
    def frame(self) -> IShapeFrame:
        ...

    @frame.setter
    def frame(self, value: IShapeFrame):
        ...

    @property
    def line_format(self) -> ILineFormat:
        ...

    @property
    def three_d_format(self) -> IThreeDFormat:
        ...

    @property
    def effect_format(self) -> IEffectFormat:
        ...

    @property
    def fill_format(self) -> IFillFormat:
        ...

    @property
    def hyperlink_click(self) -> IHyperlink:
        ...

    @hyperlink_click.setter
    def hyperlink_click(self, value: IHyperlink):
        ...

    @property
    def hyperlink_mouse_over(self) -> IHyperlink:
        ...

    @hyperlink_mouse_over.setter
    def hyperlink_mouse_over(self, value: IHyperlink):
        ...

    @property
    def hyperlink_manager(self) -> IHyperlinkManager:
        ...

    @property
    def hidden(self) -> bool:
        ...

    @hidden.setter
    def hidden(self, value: bool):
        ...

    @property
    def z_order_position(self) -> int:
        ...

    @property
    def connection_site_count(self) -> int:
        ...

    @property
    def rotation(self) -> float:
        ...

    @rotation.setter
    def rotation(self, value: float):
        ...

    @property
    def x(self) -> float:
        ...

    @x.setter
    def x(self, value: float):
        ...

    @property
    def y(self) -> float:
        ...

    @y.setter
    def y(self, value: float):
        ...

    @property
    def width(self) -> float:
        ...

    @width.setter
    def width(self, value: float):
        ...

    @property
    def height(self) -> float:
        ...

    @height.setter
    def height(self, value: float):
        ...

    @property
    def black_white_mode(self) -> BlackWhiteMode:
        ...

    @black_white_mode.setter
    def black_white_mode(self, value: BlackWhiteMode):
        ...

    @property
    def unique_id(self) -> int:
        ...

    @property
    def office_interop_shape_id(self) -> int:
        ...

    @property
    def alternative_text(self) -> string:
        ...

    @alternative_text.setter
    def alternative_text(self, value: string):
        ...

    @property
    def alternative_text_title(self) -> string:
        ...

    @alternative_text_title.setter
    def alternative_text_title(self, value: string):
        ...

    @property
    def name(self) -> string:
        ...

    @name.setter
    def name(self, value: string):
        ...

    @property
    def is_decorative(self) -> bool:
        ...

    @is_decorative.setter
    def is_decorative(self, value: bool):
        ...

    @property
    def shape_lock(self) -> IGraphicalObjectLock:
        ...

    @property
    def is_grouped(self) -> bool:
        ...

    @property
    def parent_group(self) -> IGroupShape:
        ...

    @property
    def slide(self) -> IBaseSlide:
        ...

    @property
    def presentation(self) -> IPresentation:
        ...

    @property
    def graphical_object_lock(self) -> IGraphicalObjectLock:
        ...

    @property
    def plot_visible_cells_only(self) -> bool:
        ...

    @plot_visible_cells_only.setter
    def plot_visible_cells_only(self, value: bool):
        ...

    @property
    def display_blanks_as(self) -> DisplayBlanksAsType:
        ...

    @display_blanks_as.setter
    def display_blanks_as(self, value: DisplayBlanksAsType):
        ...

    @property
    def chart_data(self) -> IChartData:
        ...

    @property
    def has_title(self) -> bool:
        ...

    @has_title.setter
    def has_title(self, value: bool):
        ...

    @property
    def chart_title(self) -> IChartTitle:
        ...

    @property
    def has_data_table(self) -> bool:
        ...

    @has_data_table.setter
    def has_data_table(self, value: bool):
        ...

    @property
    def has_legend(self) -> bool:
        ...

    @has_legend.setter
    def has_legend(self, value: bool):
        ...

    @property
    def legend(self) -> ILegend:
        ...

    @property
    def chart_data_table(self) -> IDataTable:
        ...

    @property
    def style(self) -> StyleType:
        ...

    @style.setter
    def style(self, value: StyleType):
        ...

    @property
    def type(self) -> ChartType:
        ...

    @type.setter
    def type(self, value: ChartType):
        ...

    @property
    def plot_area(self) -> IChartPlotArea:
        ...

    @property
    def rotation_3d(self) -> IRotation3D:
        ...

    @property
    def back_wall(self) -> IChartWall:
        ...

    @property
    def side_wall(self) -> IChartWall:
        ...

    @property
    def floor(self) -> IChartWall:
        ...

    @property
    def text_format(self) -> IChartTextFormat:
        ...

    @property
    def theme_manager(self) -> aspose.slides.theme.IOverrideThemeManager:
        ...

    @property
    def user_shapes(self) -> IGroupShape:
        ...

    @property
    def axes(self) -> IAxesManager:
        ...

    @property
    def show_data_labels_over_maximum(self) -> bool:
        ...

    @show_data_labels_over_maximum.setter
    def show_data_labels_over_maximum(self, value: bool):
        ...

    @property
    def has_rounded_corners(self) -> bool:
        ...

    @has_rounded_corners.setter
    def has_rounded_corners(self, value: bool):
        ...

    @property
    def as_i_formatted_text_container(self) -> IFormattedTextContainer:
        ...

    @property
    def as_i_themeable(self) -> aspose.slides.theme.IThemeable:
        ...

    @property
    def as_i_hyperlink_container(self) -> IHyperlinkContainer:
        ...

    @property
    def as_i_presentation_component(self) -> IPresentationComponent:
        ...

    @property
    def as_i_shape(self) -> IShape:
        ...

    @property
    def as_i_graphical_object(self) -> IGraphicalObject:
        ...

    @property
    def as_i_override_themeable(self) -> aspose.slides.theme.IOverrideThemeable:
        ...

    @property
    def as_i_chart_component(self) -> IChartComponent:
        ...

    @property
    def chart(self) -> IChart:
        ...

    ...

class ChartCategory:
    '''Represents chart categories.'''
    def remove(self) -> None:
        '''Removes category from chart.'''
        ...

    @property
    def use_cell(self) -> bool:
        ...

    @property
    def as_cell(self) -> IChartDataCell:
        ...

    @as_cell.setter
    def as_cell(self, value: IChartDataCell):
        ...

    @property
    def as_literal(self) -> any:
        ...

    @as_literal.setter
    def as_literal(self, value: any):
        ...

    @property
    def value(self) -> any:
        ...

    @value.setter
    def value(self, value: any):
        ...

    @property
    def grouping_levels(self) -> IChartCategoryLevelsManager:
        ...

    ...

class ChartCategoryCollection:
    '''Represents collection of :py:class:`aspose.slides.charts.ChartCategory`'''
    @overload
    def add(self, chart_data_cell: IChartDataCell) -> IChartCategory:
        '''If category exists in collection, return it. Else creates new chart category from 
                    :py:class:`aspose.slides.charts.IChartDataCell` and adds it to the collection.
        :param chart_data_cell: Cell used to create chart category.
        :returns: Added or existing category.'''
        ...

    @overload
    def add(self, value: any) -> IChartCategory:
        '''Creates new :py:class:`aspose.slides.charts.ChartCategory` from value and adds it to the collection.
        :param value: The value.
        :returns: Added :py:class:`aspose.slides.charts.IChartCategory`.'''
        ...

    def index_of(self, value: IChartCategory) -> int:
        '''Searches for the specified :py:class:`aspose.slides.charts.ChartCategory` and returns the zero-based index of the first occurrence within the entire Collection.
        :param value: Chart category.
        :returns: The zero-based index of the first occurrence of value within the entire CollectionBase, if found; otherwise, -1.'''
        ...

    def remove(self, value: IChartCategory) -> None:
        '''Removes the specified value.
        :param value: The value.'''
        ...

    def remove_at(self, index: int) -> None:
        '''Removes the element at the given index.
        :param index: Index of a category to remove.'''
        ...

    def clear(self) -> None:
        '''Removes all elements from the collection.'''
        ...

    @property
    def use_cells(self) -> bool:
        ...

    @use_cells.setter
    def use_cells(self, value: bool):
        ...

    @property
    def grouping_level_count(self) -> int:
        ...

    @property
    def as_i_collection(self) -> list:
        ...

    @property
    def as_i_enumerable(self) -> collections.abc.Iterable:
        ...

    def __getitem__(self, key: int) -> IChartCategory
        '''Gets the element at the specified index.'''
        ...

    ...

class ChartCategoryLevelsManager:
    '''Managed container of the values of the chart category levels.'''
    def set_grouping_item(self, level: int, value: any) -> None:
        '''Sets grouping item for defined level.'''
        ...

    def delete_grouping_item(self, level: int) -> None:
        '''Delete grouping item for defined level.'''
        ...

    def __getitem__(self, key: int) -> IChartDataCell
        '''Returns IChartDataCell object for defined level.'''
        ...

    ...

class ChartCellCollection:
    '''Represents collection of a cells with data.'''
    @overload
    def add(self, cell: IChartDataCell) -> None:
        '''Add new cell to the collection.
        :param cell: New cell to add.'''
        ...

    @overload
    def add(self, value: any) -> None:
        '''Creates :py:class:`aspose.slides.charts.ChartDataCell` from specified value and adds it to the collection.
        :param value: The value.'''
        ...

    def get_cells_address(self) -> string:
        '''Returns address of the set of cells in workbook.'''
        ...

    def get_concatenated_values_from_cells(self) -> string:
        '''Concatenation string from all cells string values.'''
        ...

    def remove_at(self, index: int) -> None:
        '''Removes a cell from the collection by index.
        :param index: Index of a cell to remove.'''
        ...

    @property
    def count(self) -> int:
        ...

    @property
    def as_i_enumerable(self) -> collections.abc.Iterable:
        ...

    def __getitem__(self, key: int) -> IChartDataCell
        '''Returns a cell (IChartDataCell) by index.'''
        ...

    ...

class ChartData:
    '''Represents data used for a chart plotting.'''
    @overload
    def set_external_workbook(self, workbook_path: string) -> None:
        '''Sets external workbook as a data source for the chart. Chart data will be updated from the target workbook.
        :param workbook_path: Path to the target workbook'''
        ...

    @overload
    def set_external_workbook(self, workbook_path: string, update_chart_data: bool) -> None:
        '''Sets external workbook as a data source for the chart.
        :param workbook_path: Path to the target workbook
        :param update_chart_data: If value is false only workbook path will be updated. 
                     Chart data won't be loaded and updated from the target workbook. Can be used when target workbook doesn't exist or it's not available.
                     If value is true chart data will be updated from the target workbook.'''
        ...

    def get_range(self) -> string:
        '''Gets chart data range.
        :returns: Cells data range formula. E.g: "Sheet1!$A$1:$C$4"'''
        ...

    def set_range(self, formula: string) -> None:
        '''Set chart data range. Series and categories will be updated based on new data range.
                    If amount of series in data range greater than count of series in the chart data then additional series with the same type
                    as a last series in the current collection will be added to the end of the collection.
        :param formula: The cells data range formula. E.g: "Sheet1!$A$1:$C$4" , "SomeSheetName!A1:B100", "Sheet1!$A$1:$B$5;Sheet1!$D$1:$D$5".'''
        ...

    def switch_row_column(self) -> None:
        '''Swap the data over the axis.
                    Data being charted on the X axis will move to the Y axis and vice versa.'''
        ...

    @property
    def chart_data_workbook(self) -> IChartDataWorkbook:
        ...

    @property
    def series(self) -> IChartSeriesCollection:
        ...

    @property
    def series_groups(self) -> IChartSeriesGroupCollection:
        ...

    @property
    def categories(self) -> IChartCategoryCollection:
        ...

    @property
    def use_secondary_categories(self) -> bool:
        ...

    @use_secondary_categories.setter
    def use_secondary_categories(self, value: bool):
        ...

    @property
    def secondary_categories(self) -> IChartCategoryCollection:
        ...

    @property
    def data_source_type(self) -> ChartDataSourceType:
        ...

    @property
    def external_workbook_path(self) -> string:
        ...

    ...

class ChartDataCell:
    '''Represents cell for chart data.'''
    def calculate(self, update_values: bool) -> None:
        '''If the cell contains a formula, the value will be updated base on that formula.
        :param update_values: If false, no actual calculation will be performed. Use true for possible exceptions check.'''
        ...

    @property
    def row(self) -> int:
        ...

    @property
    def column(self) -> int:
        ...

    @property
    def value(self) -> any:
        ...

    @value.setter
    def value(self, value: any):
        ...

    @property
    def formula(self) -> string:
        ...

    @formula.setter
    def formula(self, value: string):
        ...

    @property
    def r1c1_formula(self) -> string:
        ...

    @r1c1_formula.setter
    def r1c1_formula(self, value: string):
        ...

    @property
    def chart_data_worksheet(self) -> IChartDataWorksheet:
        ...

    @property
    def is_hidden(self) -> bool:
        ...

    @property
    def custom_number_format(self) -> string:
        ...

    @custom_number_format.setter
    def custom_number_format(self, value: string):
        ...

    @property
    def preset_number_format(self) -> int:
        ...

    @preset_number_format.setter
    def preset_number_format(self, value: int):
        ...

    ...

class ChartDataPoint:
    '''Represents series data point.'''
    def remove(self) -> None:
        '''Removes DataPoint from chart series.'''
        ...

    def get_automatic_data_point_color(self) -> aspose.pydrawing.Color:
        '''Returns an automatic color of data point based on series index, data point index, ParentSeriesGroup.IsColorVaried property and chart style.
                    This color is used by default if FillType equals NotDefined.'''
        ...

    @property
    def x_value(self) -> IStringOrDoubleChartValue:
        ...

    @property
    def y_value(self) -> IDoubleChartValue:
        ...

    @property
    def bubble_size(self) -> IDoubleChartValue:
        ...

    @property
    def value(self) -> IDoubleChartValue:
        ...

    @property
    def size_value(self) -> IDoubleChartValue:
        ...

    @property
    def color_value(self) -> IDoubleChartValue:
        ...

    @property
    def error_bars_custom_values(self) -> IErrorBarsCustomValues:
        ...

    @property
    def label(self) -> IDataLabel:
        ...

    @property
    def is_bubble_3d(self) -> bool:
        ...

    @is_bubble_3d.setter
    def is_bubble_3d(self, value: bool):
        ...

    @property
    def explosion(self) -> int:
        ...

    @explosion.setter
    def explosion(self, value: int):
        ...

    @property
    def format(self) -> IFormat:
        ...

    @format.setter
    def format(self, value: IFormat):
        ...

    @property
    def marker(self) -> IMarker:
        ...

    @property
    def set_as_total(self) -> bool:
        ...

    @set_as_total.setter
    def set_as_total(self, value: bool):
        ...

    @property
    def related_legend_entry(self) -> ILegendEntryProperties:
        ...

    @property
    def data_point_levels(self) -> IChartDataPointLevelsManager:
        ...

    @property
    def index(self) -> int:
        ...

    @property
    def invert_if_negative(self) -> bool:
        ...

    @invert_if_negative.setter
    def invert_if_negative(self, value: bool):
        ...

    @property
    def actual_x(self) -> float:
        ...

    @property
    def actual_y(self) -> float:
        ...

    @property
    def actual_width(self) -> float:
        ...

    @property
    def actual_height(self) -> float:
        ...

    @property
    def as_i_actual_layout(self) -> IActualLayout:
        ...

    ...

class ChartDataPointCollection:
    '''Represents collection of a series data point.'''
    @overload
    def add_data_point_for_stock_series(self, value: IChartDataCell) -> IChartDataPoint:
        '''Creates the new data point and adds it to the end of collection.
                    Applicable for series which chartType is one of Stock subtypes
                    (see also :py:func:`Aspose.Slides.Charts.ChartTypeCharacterizer.IsChartTypeStock(Aspose.Slides.Chart.` method).
        :param value: Data point Value.
        :returns: New data point.'''
        ...

    @overload
    def add_data_point_for_stock_series(self, value: float) -> IChartDataPoint:
        '''Creates the new data point and adds it to the end of collection.
                    Applicable for series which chartType is one of Stock subtypes 
                    (see also :py:func:`Aspose.Slides.Charts.ChartTypeCharacterizer.IsChartTypeStock(Aspose.Slides.Chart.` method).
        :param value: Data point Value.
        :returns: New data point.'''
        ...

    @overload
    def add_data_point_for_line_series(self, value: IChartDataCell) -> IChartDataPoint:
        '''Creates the new data point and adds it to the end of collection.
                    Applicable for series which chartType is one of Line subtypes (see also :py:func:`Aspose.Slides.Charts.ChartTypeCharacterizer.IsChartTypeLine(Aspose.Slides.Chart.` method).
        :param value: Data point Value.
        :returns: New data point.'''
        ...

    @overload
    def add_data_point_for_line_series(self, value: float) -> IChartDataPoint:
        '''Creates the new data point and adds it to the end of collection.
                    Applicable for series which chartType is one of Line subtypes (see also :py:func:`Aspose.Slides.Charts.ChartTypeCharacterizer.IsChartTypeLine(Aspose.Slides.Chart.` method).
        :param value: Data point Value.
        :returns: New data point.'''
        ...

    @overload
    def add_data_point_for_scatter_series(self, x_value: IChartDataCell, y_value: IChartDataCell) -> IChartDataPoint:
        '''Creates the new data point and adds it to the end of collection.
                    Applicable for series which chartType is one of Scatter subtypes (see also :py:func:`Aspose.Slides.Charts.ChartTypeCharacterizer.IsChartTypeScatter(Aspose.Slides.Chart.` method).
        :param x_value: Data point XValue
        :param y_value: Data point YValue
        :returns: New data point.'''
        ...

    @overload
    def add_data_point_for_scatter_series(self, x_value: float, y_value: IChartDataCell) -> IChartDataPoint:
        '''Creates the new data point and adds it to the end of collection.
                    Applicable for series which chartType is one of Scatter subtypes (see also :py:func:`Aspose.Slides.Charts.ChartTypeCharacterizer.IsChartTypeScatter(Aspose.Slides.Chart.` method).
        :param x_value: Data point XValue
        :param y_value: Data point YValue
        :returns: New data point.'''
        ...

    @overload
    def add_data_point_for_scatter_series(self, x_value: string, y_value: IChartDataCell) -> IChartDataPoint:
        '''Creates the new data point and adds it to the end of collection.
                    Applicable for series which chartType is one of Scatter subtypes (see also :py:func:`Aspose.Slides.Charts.ChartTypeCharacterizer.IsChartTypeScatter(Aspose.Slides.Chart.` method).
        :param x_value: Data point XValue
        :param y_value: Data point YValue
        :returns: New data point.'''
        ...

    @overload
    def add_data_point_for_scatter_series(self, x_value: IChartDataCell, y_value: float) -> IChartDataPoint:
        '''Creates the new data point and adds it to the end of collection.
                    Applicable for series which chartType is one of Scatter subtypes (see also :py:func:`Aspose.Slides.Charts.ChartTypeCharacterizer.IsChartTypeScatter(Aspose.Slides.Chart.` method).
        :param x_value: Data point XValue
        :param y_value: Data point YValue
        :returns: New data point.'''
        ...

    @overload
    def add_data_point_for_scatter_series(self, x_value: float, y_value: float) -> IChartDataPoint:
        '''Creates the new data point and adds it to the end of collection.
                    Applicable for series which chartType is one of Scatter subtypes (see also :py:func:`Aspose.Slides.Charts.ChartTypeCharacterizer.IsChartTypeScatter(Aspose.Slides.Chart.` method).
        :param x_value: Data point XValue
        :param y_value: Data point YValue
        :returns: New data point.'''
        ...

    @overload
    def add_data_point_for_scatter_series(self, x_value: string, y_value: float) -> IChartDataPoint:
        '''Creates the new data point and adds it to the end of collection.
                    Applicable for series which chartType is one of Scatter subtypes (see also :py:func:`Aspose.Slides.Charts.ChartTypeCharacterizer.IsChartTypeScatter(Aspose.Slides.Chart.` method).
        :param x_value: Data point XValue
        :param y_value: Data point YValue
        :returns: New data point.'''
        ...

    @overload
    def add_data_point_for_radar_series(self, value: IChartDataCell) -> IChartDataPoint:
        '''Creates the new data point and adds it to the end of collection.
                    Applicable for series which chartType is one of Radar subtypes (see also :py:func:`Aspose.Slides.Charts.ChartTypeCharacterizer.IsChartTypeRadar(Aspose.Slides.Chart.` method).
        :param value: Data point Value
        :returns: New data point.'''
        ...

    @overload
    def add_data_point_for_radar_series(self, value: float) -> IChartDataPoint:
        '''Creates the new data point and adds it to the end of collection.
                    Applicable for series which chartType is one of Radar subtypes (see also :py:func:`Aspose.Slides.Charts.ChartTypeCharacterizer.IsChartTypeRadar(Aspose.Slides.Chart.` method).
        :param value: Data point Value
        :returns: New data point.'''
        ...

    @overload
    def add_data_point_for_bar_series(self, value: IChartDataCell) -> IChartDataPoint:
        '''Creates the new data point and adds it to the end of collection.
                    Applicable for series which chartType is one of Column or Bar subtypes (see also :py:func:`Aspose.Slides.Charts.ChartTypeCharacterizer.IsChartTypeColumn(Aspose.Slides.Chart.` and :py:func:`Aspose.Slides.Charts.ChartTypeCharacterizer.IsChartTypeBar(Aspose.Slides.Chart.` method).
        :param value: Data point Value
        :returns: New data point.'''
        ...

    @overload
    def add_data_point_for_bar_series(self, value: float) -> IChartDataPoint:
        '''Creates the new data point and adds it to the end of collection.
                    Applicable for series which chartType is one of Column or Bar subtypes (see also :py:func:`Aspose.Slides.Charts.ChartTypeCharacterizer.IsChartTypeColumn(Aspose.Slides.Chart.` and :py:func:`Aspose.Slides.Charts.ChartTypeCharacterizer.IsChartTypeBar(Aspose.Slides.Chart.` method).
        :param value: Data point Value
        :returns: New data point.'''
        ...

    @overload
    def add_data_point_for_area_series(self, value: IChartDataCell) -> IChartDataPoint:
        '''Creates the new data point and adds it to the end of collection.
                    Applicable for series which chartType is one of Area subtypes (see also :py:func:`Aspose.Slides.Charts.ChartTypeCharacterizer.IsChartTypeArea(Aspose.Slides.Chart.` method).
        :param value: Data point Value
        :returns: New data point.'''
        ...

    @overload
    def add_data_point_for_area_series(self, value: float) -> IChartDataPoint:
        '''Creates the new data point and adds it to the end of collection.
                    Applicable for series which chartType is one of Area subtypes (see also :py:func:`Aspose.Slides.Charts.ChartTypeCharacterizer.IsChartTypeArea(Aspose.Slides.Chart.` method).
        :param value: Data point Value
        :returns: New data point.'''
        ...

    @overload
    def add_data_point_for_pie_series(self, value: IChartDataCell) -> IChartDataPoint:
        '''Creates the new data point and adds it to the end of collection.
                    Applicable for series which chartType is one of Pie subtypes (see also :py:func:`Aspose.Slides.Charts.ChartTypeCharacterizer.IsChartTypePie(Aspose.Slides.Chart.` method).
        :param value: Data point Value
        :returns: New data point.'''
        ...

    @overload
    def add_data_point_for_pie_series(self, value: float) -> IChartDataPoint:
        '''Creates the new data point and adds it to the end of collection.
                    Applicable for series which chartType is one of Pie subtypes (see also :py:func:`Aspose.Slides.Charts.ChartTypeCharacterizer.IsChartTypePie(Aspose.Slides.Chart.` method).
        :param value: Data point Value
        :returns: New data point.'''
        ...

    @overload
    def add_data_point_for_doughnut_series(self, value: IChartDataCell) -> IChartDataPoint:
        '''Creates the new data point and adds it to the end of collection.
                    Applicable for series which chartType is one of Doughnut subtypes (see also :py:func:`Aspose.Slides.Charts.ChartTypeCharacterizer.IsChartTypeDoughnut(Aspose.Slides.Chart.` method).
        :param value: Data point Value
        :returns: New data point.'''
        ...

    @overload
    def add_data_point_for_doughnut_series(self, value: float) -> IChartDataPoint:
        '''Creates the new data point and adds it to the end of collection.
                    Applicable for series which chartType is one of Doughnut subtypes (see also :py:func:`Aspose.Slides.Charts.ChartTypeCharacterizer.IsChartTypeDoughnut(Aspose.Slides.Chart.` method).
        :param value: Data point Value
        :returns: New data point.'''
        ...

    @overload
    def add_data_point_for_bubble_series(self, x_value: IChartDataCell, y_value: IChartDataCell, bubble_size: IChartDataCell) -> IChartDataPoint:
        '''Creates the new data point and adds it to the end of collection.
                    Applicable for series which chartType is one of Bubble subtypes (see also :py:func:`Aspose.Slides.Charts.ChartTypeCharacterizer.IsChartTypeBubble(Aspose.Slides.Chart.` method).
        :param x_value: Data point XValue
        :param y_value: Data point YValue
        :param bubble_size: Data point BubbleSize
        :returns: New data point.'''
        ...

    @overload
    def add_data_point_for_bubble_series(self, x_value: float, y_value: IChartDataCell, bubble_size: IChartDataCell) -> IChartDataPoint:
        '''Creates the new data point and adds it to the end of collection.
                    Applicable for series which chartType is one of Bubble subtypes (see also :py:func:`Aspose.Slides.Charts.ChartTypeCharacterizer.IsChartTypeBubble(Aspose.Slides.Chart.` method).
        :param x_value: Data point XValue
        :param y_value: Data point YValue
        :param bubble_size: Data point BubbleSize
        :returns: New data point.'''
        ...

    @overload
    def add_data_point_for_bubble_series(self, x_value: string, y_value: IChartDataCell, bubble_size: IChartDataCell) -> IChartDataPoint:
        '''Creates the new data point and adds it to the end of collection.
                    Applicable for series which chartType is one of Bubble subtypes (see also :py:func:`Aspose.Slides.Charts.ChartTypeCharacterizer.IsChartTypeBubble(Aspose.Slides.Chart.` method).
        :param x_value: Data point XValue
        :param y_value: Data point YValue
        :param bubble_size: Data point BubbleSize
        :returns: New data point.'''
        ...

    @overload
    def add_data_point_for_bubble_series(self, x_value: IChartDataCell, y_value: float, bubble_size: IChartDataCell) -> IChartDataPoint:
        '''Creates the new data point and adds it to the end of collection.
                    Applicable for series which chartType is one of Bubble subtypes (see also :py:func:`Aspose.Slides.Charts.ChartTypeCharacterizer.IsChartTypeBubble(Aspose.Slides.Chart.` method).
        :param x_value: Data point XValue
        :param y_value: Data point YValue
        :param bubble_size: Data point BubbleSize
        :returns: New data point.'''
        ...

    @overload
    def add_data_point_for_bubble_series(self, x_value: float, y_value: float, bubble_size: IChartDataCell) -> IChartDataPoint:
        '''Creates the new data point and adds it to the end of collection.
                    Applicable for series which chartType is one of Bubble subtypes (see also :py:func:`Aspose.Slides.Charts.ChartTypeCharacterizer.IsChartTypeBubble(Aspose.Slides.Chart.` method).
        :param x_value: Data point XValue
        :param y_value: Data point YValue
        :param bubble_size: Data point BubbleSize
        :returns: New data point.'''
        ...

    @overload
    def add_data_point_for_bubble_series(self, x_value: string, y_value: float, bubble_size: IChartDataCell) -> IChartDataPoint:
        '''Creates the new data point and adds it to the end of collection.
                    Applicable for series which chartType is one of Bubble subtypes (see also :py:func:`Aspose.Slides.Charts.ChartTypeCharacterizer.IsChartTypeBubble(Aspose.Slides.Chart.` method).
        :param x_value: Data point XValue
        :param y_value: Data point YValue
        :param bubble_size: Data point BubbleSize
        :returns: New data point.'''
        ...

    @overload
    def add_data_point_for_bubble_series(self, x_value: IChartDataCell, y_value: IChartDataCell, bubble_size: float) -> IChartDataPoint:
        '''Creates the new data point and adds it to the end of collection.
                    Applicable for series which chartType is one of Bubble subtypes (see also :py:func:`Aspose.Slides.Charts.ChartTypeCharacterizer.IsChartTypeBubble(Aspose.Slides.Chart.` method).
        :param x_value: Data point XValue
        :param y_value: Data point YValue
        :param bubble_size: Data point BubbleSize
        :returns: New data point.'''
        ...

    @overload
    def add_data_point_for_bubble_series(self, x_value: float, y_value: IChartDataCell, bubble_size: float) -> IChartDataPoint:
        '''Creates the new data point and adds it to the end of collection.
                    Applicable for series which chartType is one of Bubble subtypes (see also :py:func:`Aspose.Slides.Charts.ChartTypeCharacterizer.IsChartTypeBubble(Aspose.Slides.Chart.` method).
        :param x_value: Data point XValue
        :param y_value: Data point YValue
        :param bubble_size: Data point BubbleSize
        :returns: New data point.'''
        ...

    @overload
    def add_data_point_for_bubble_series(self, x_value: string, y_value: IChartDataCell, bubble_size: float) -> IChartDataPoint:
        '''Creates the new data point and adds it to the end of collection.
                    Applicable for series which chartType is one of Bubble subtypes (see also :py:func:`Aspose.Slides.Charts.ChartTypeCharacterizer.IsChartTypeBubble(Aspose.Slides.Chart.` method).
        :param x_value: Data point XValue
        :param y_value: Data point YValue
        :param bubble_size: Data point BubbleSize
        :returns: New data point.'''
        ...

    @overload
    def add_data_point_for_bubble_series(self, x_value: IChartDataCell, y_value: float, bubble_size: float) -> IChartDataPoint:
        '''Creates the new data point and adds it to the end of collection.
                    Applicable for series which chartType is one of Bubble subtypes (see also :py:func:`Aspose.Slides.Charts.ChartTypeCharacterizer.IsChartTypeBubble(Aspose.Slides.Chart.` method).
        :param x_value: Data point XValue
        :param y_value: Data point YValue
        :param bubble_size: Data point BubbleSize
        :returns: New data point.'''
        ...

    @overload
    def add_data_point_for_bubble_series(self, x_value: float, y_value: float, bubble_size: float) -> IChartDataPoint:
        '''Creates the new data point and adds it to the end of collection.
                    Applicable for series which chartType is one of Bubble subtypes (see also :py:func:`Aspose.Slides.Charts.ChartTypeCharacterizer.IsChartTypeBubble(Aspose.Slides.Chart.` method).
        :param x_value: Data point XValue
        :param y_value: Data point YValue
        :param bubble_size: Data point BubbleSize
        :returns: New data point.'''
        ...

    @overload
    def add_data_point_for_bubble_series(self, x_value: string, y_value: float, bubble_size: float) -> IChartDataPoint:
        '''Creates the new data point and adds it to the end of collection.
                    Applicable for series which chartType is one of Bubble subtypes (see also :py:func:`Aspose.Slides.Charts.ChartTypeCharacterizer.IsChartTypeBubble(Aspose.Slides.Chart.` method).
        :param x_value: Data point XValue
        :param y_value: Data point YValue
        :param bubble_size: Data point BubbleSize
        :returns: New data point.'''
        ...

    @overload
    def add_data_point_for_surface_series(self, value: IChartDataCell) -> IChartDataPoint:
        '''Creates the new data point and adds it to the end of collection.
                    Applicable for series which chartType is one of Surface subtypes (see also :py:func:`Aspose.Slides.Charts.ChartTypeCharacterizer.IsChartTypeSurface(Aspose.Slides.Chart.` method).
        :param value: Data point Value
        :returns: New data point.'''
        ...

    @overload
    def add_data_point_for_surface_series(self, value: float) -> IChartDataPoint:
        '''Creates the new data point and adds it to the end of collection.
                    Applicable for series which chartType is one of Surface subtypes (see also :py:func:`Aspose.Slides.Charts.ChartTypeCharacterizer.IsChartTypeSurface(Aspose.Slides.Chart.` method).
        :param value: Data point Value
        :returns: New data point.'''
        ...

    def get_or_create_data_point_by_idx(self, index: int) -> IChartDataPoint:
        '''If collection already contains data point with index ``index`` then returns this data point.
                    If collection doesn't contains data point with index ``index``==N
                    (when number of data points in this collection is less or equal then N)
                    then adds deficient data points and returns last (which has requested index).
                    For example, collection indexes are {0, 1, 2}, and requested index is 5.
                    Then method adds deficient data points: {0, 1, 2, 3, 4, 5}. And returns data point with index 5.
        :param index: Index.
        :returns: Returns data point with requested index.'''
        ...

    def add_data_point_for_sunburst_series(self, size_value: IChartDataCell) -> IChartDataPoint:
        '''Creates the new data point and adds it to the end of collection.
                    Applicable for series which chart type is Sunburst.
        :param size_value: Data point SizeValue
        :returns: New data point.'''
        ...

    def add_data_point_for_treemap_series(self, size_value: IChartDataCell) -> IChartDataPoint:
        '''Creates the new data point and adds it to the end of collection.
                    Applicable for series which chart type is Treemap.
        :param size_value: Data point SizeValue
        :returns: New data point.'''
        ...

    def add_data_point_for_box_and_whisker_series(self, value: IChartDataCell) -> IChartDataPoint:
        '''Creates the new data point and adds it to the end of collection.
                    Applicable for series which chart type is BoxAndWhisker.
        :param value: Data point Value
        :returns: New data point.'''
        ...

    def add_data_point_for_waterfall_series(self, value: IChartDataCell) -> IChartDataPoint:
        '''Creates the new data point and adds it to the end of collection.
                    Applicable for series which chart type is Waterfall.
        :param value: Data point Value
        :returns: New data point.'''
        ...

    def add_data_point_for_histogram_series(self, value: IChartDataCell) -> IChartDataPoint:
        '''Creates the new data point and adds it to the end of collection.
                    Applicable for series which chart type is Histogram.
        :param value: Data point Value
        :returns: New data point.'''
        ...

    def add_data_point_for_funnel_series(self, value: IChartDataCell) -> IChartDataPoint:
        '''Creates the new data point and adds it to the end of collection.
                    Applicable for series which chart type is Funnel.
        :param value: Data point Value
        :returns: New data point.'''
        ...

    def add_data_point_for_map_series(self, value: IChartDataCell) -> IChartDataPoint:
        '''Creates the new data point and adds it to the end of collection.
                     Applicable for series which chart type is Map.
        :param value: Data point ColorValue
        :returns: New data point.'''
        ...

    def clear(self) -> None:
        '''Removes all elements from the collection.'''
        ...

    def remove(self, value: IChartDataPoint) -> None:
        '''Removes the specified value.
        :param value: The value.'''
        ...

    def remove_at(self, index: int) -> None:
        '''Removes the element at the given index.
        :param index: Index of a data point to remove.'''
        ...

    @property
    def data_source_type_for_x_values(self) -> DataSourceType:
        ...

    @data_source_type_for_x_values.setter
    def data_source_type_for_x_values(self, value: DataSourceType):
        ...

    @property
    def data_source_type_for_y_values(self) -> DataSourceType:
        ...

    @data_source_type_for_y_values.setter
    def data_source_type_for_y_values(self, value: DataSourceType):
        ...

    @property
    def data_source_type_for_bubble_sizes(self) -> DataSourceType:
        ...

    @data_source_type_for_bubble_sizes.setter
    def data_source_type_for_bubble_sizes(self, value: DataSourceType):
        ...

    @property
    def data_source_type_for_values(self) -> DataSourceType:
        ...

    @data_source_type_for_values.setter
    def data_source_type_for_values(self, value: DataSourceType):
        ...

    @property
    def data_source_type_for_error_bars_custom_values(self) -> IDataSourceTypeForErrorBarsCustomValues:
        ...

    @property
    def as_i_collection(self) -> list:
        ...

    @property
    def as_i_enumerable(self) -> collections.abc.Iterable:
        ...

    def __getitem__(self, key: int) -> IChartDataPoint
        '''Returns the series data point by index (its serial number in this collection).'''
        ...

    ...

class ChartDataPointLevel:
    '''Represents data point level. Applies for Treemap and Sunburst chart.'''
    @property
    def format(self) -> IFormat:
        ...

    @property
    def label(self) -> IDataLabel:
        ...

    ...

class ChartDataPointLevelsManager:
    '''Container of data point levels. Applied for Treeamp and Sunburst series.
                Data point levels indexing is zero-based.'''
    @property
    def count(self) -> int:
        ...

    def __getitem__(self, key: int) -> IChartDataPointLevel
        '''Returns IChartDataPointLevel object for defined level.'''
        ...

    ...

class ChartDataWorkbook:
    '''Provides access to embedded Excel workbook'''
    @overload
    def get_cell(self, worksheet_name: string, row: int, column: int) -> IChartDataCell:
        '''Gets the cell that can be used for chart series or categories
        :param worksheet_name: Name of the worksheet.
        :param row: The row.
        :param column: The column.
        :returns: Cell object'''
        ...

    @overload
    def get_cell(self, worksheet_index: int, row: int, column: int) -> IChartDataCell:
        '''Gets the cell that can be used for chart series or categories
        :param worksheet_index: Index of the worksheet.
        :param row: The row.
        :param column: The column.
        :returns: Cell object'''
        ...

    @overload
    def get_cell(self, worksheet_index: int, cell_name: string) -> IChartDataCell:
        '''Gets the cell that can be used for chart series or categories
        :param worksheet_index: Index of the worksheet.
        :param cell_name: Name of the cell.
        :returns: Cell object'''
        ...

    @overload
    def get_cell(self, worksheet_index: int, cell_name: string, value: any) -> IChartDataCell:
        '''Gets the cell that can be used for chart series or categories
        :param worksheet_index: Index of the worksheet.
        :param cell_name: Name of the cell.
        :param value: The value.
        :returns: Cell object'''
        ...

    @overload
    def get_cell(self, worksheet_index: int, row: int, column: int, value: any) -> IChartDataCell:
        '''Gets the cell that can be used for chart series or categories
        :param worksheet_index: Index of the worksheet.
        :param row: The row.
        :param column: The column.
        :param value: The value.
        :returns: Cell object'''
        ...

    def get_cell_collection(self, formula: string, skip_hidden_cells: bool) -> IChartCellCollection:
        '''Gets the set of cells.
        :param formula: Excel formula like "Sheet1!$A$2:$A$5".
        :param skip_hidden_cells: If true then method returns collection without hidden cells.'''
        ...

    def clear(self, sheet_index: int) -> None:
        '''Clear all cells values on sheet
        :param sheet_index: Index of sheet'''
        ...

    def calculate_formulas(self) -> None:
        '''Calculates all formulas in the workbook and updates corresponding cells values.'''
        ...

    @property
    def worksheets(self) -> IChartDataWorksheetCollection:
        ...

    ...

class ChartDataWorksheet:
    '''Represents worksheet associated with :py:class:`aspose.slides.charts.IChartDataCell`'''
    @property
    def name(self) -> string:
        ...

    @property
    def index(self) -> int:
        ...

    ...

class ChartDataWorksheetCollection:
    '''Represents the collection of worksheets of chart data workbook.'''
    @property
    def as_i_collection(self) -> list:
        ...

    @property
    def as_i_enumerable(self) -> collections.abc.Iterable:
        ...

    def __getitem__(self, key: int) -> IChartDataWorksheet
        '''Returns the worksheet by index.'''
        ...

    ...

class ChartLinesFormat:
    '''Represents gridlines format properties.'''
    @property
    def line(self) -> ILineFormat:
        ...

    @property
    def effect(self) -> IEffectFormat:
        ...

    ...

class ChartPlotArea:
    '''Represents rectangle where chart should be plotted.'''
    @property
    def format(self) -> IFormat:
        ...

    @property
    def x(self) -> float:
        ...

    @x.setter
    def x(self, value: float):
        ...

    @property
    def y(self) -> float:
        ...

    @y.setter
    def y(self, value: float):
        ...

    @property
    def width(self) -> float:
        ...

    @width.setter
    def width(self, value: float):
        ...

    @property
    def height(self) -> float:
        ...

    @height.setter
    def height(self, value: float):
        ...

    @property
    def right(self) -> float:
        ...

    @property
    def bottom(self) -> float:
        ...

    @property
    def chart(self) -> IChart:
        ...

    @property
    def is_location_autocalculated(self) -> bool:
        ...

    @property
    def layout_target_type(self) -> LayoutTargetType:
        ...

    @layout_target_type.setter
    def layout_target_type(self, value: LayoutTargetType):
        ...

    @property
    def actual_x(self) -> float:
        ...

    @property
    def actual_y(self) -> float:
        ...

    @property
    def actual_width(self) -> float:
        ...

    @property
    def actual_height(self) -> float:
        ...

    @property
    def as_i_layoutable(self) -> ILayoutable:
        ...

    @property
    def as_i_actual_layout(self) -> IActualLayout:
        ...

    @property
    def as_i_chart_component(self) -> IChartComponent:
        ...

    @property
    def as_i_slide_component(self) -> ISlideComponent:
        ...

    @property
    def slide(self) -> IBaseSlide:
        ...

    @property
    def as_i_presentation_component(self) -> IPresentationComponent:
        ...

    @property
    def presentation(self) -> IPresentation:
        ...

    ...

class ChartPortionFormat(aspose.slides.BasePortionFormat):
    '''This class contains the chart portion formatting properties used in charts.
                Unlike :py:class:`aspose.slides.IPortionFormatEffectiveData`, all properties of this class are writeable.'''
    @property
    def as_i_presentation_component(self) -> IPresentationComponent:
        ...

    @property
    def line_format(self) -> ILineFormat:
        ...

    @property
    def fill_format(self) -> IFillFormat:
        ...

    @property
    def effect_format(self) -> IEffectFormat:
        ...

    @property
    def highlight_color(self) -> IColorFormat:
        ...

    @property
    def underline_line_format(self) -> ILineFormat:
        ...

    @property
    def underline_fill_format(self) -> IFillFormat:
        ...

    @property
    def font_bold(self) -> NullableBool:
        ...

    @font_bold.setter
    def font_bold(self, value: NullableBool):
        ...

    @property
    def font_italic(self) -> NullableBool:
        ...

    @font_italic.setter
    def font_italic(self, value: NullableBool):
        ...

    @property
    def kumimoji(self) -> NullableBool:
        ...

    @kumimoji.setter
    def kumimoji(self, value: NullableBool):
        ...

    @property
    def normalise_height(self) -> NullableBool:
        ...

    @normalise_height.setter
    def normalise_height(self, value: NullableBool):
        ...

    @property
    def proof_disabled(self) -> NullableBool:
        ...

    @proof_disabled.setter
    def proof_disabled(self, value: NullableBool):
        ...

    @property
    def font_underline(self) -> TextUnderlineType:
        ...

    @font_underline.setter
    def font_underline(self, value: TextUnderlineType):
        ...

    @property
    def text_cap_type(self) -> TextCapType:
        ...

    @text_cap_type.setter
    def text_cap_type(self, value: TextCapType):
        ...

    @property
    def strikethrough_type(self) -> TextStrikethroughType:
        ...

    @strikethrough_type.setter
    def strikethrough_type(self, value: TextStrikethroughType):
        ...

    @property
    def is_hard_underline_line(self) -> NullableBool:
        ...

    @is_hard_underline_line.setter
    def is_hard_underline_line(self, value: NullableBool):
        ...

    @property
    def is_hard_underline_fill(self) -> NullableBool:
        ...

    @is_hard_underline_fill.setter
    def is_hard_underline_fill(self, value: NullableBool):
        ...

    @property
    def font_height(self) -> float:
        ...

    @font_height.setter
    def font_height(self, value: float):
        ...

    @property
    def latin_font(self) -> IFontData:
        ...

    @latin_font.setter
    def latin_font(self, value: IFontData):
        ...

    @property
    def east_asian_font(self) -> IFontData:
        ...

    @east_asian_font.setter
    def east_asian_font(self, value: IFontData):
        ...

    @property
    def complex_script_font(self) -> IFontData:
        ...

    @complex_script_font.setter
    def complex_script_font(self, value: IFontData):
        ...

    @property
    def symbol_font(self) -> IFontData:
        ...

    @symbol_font.setter
    def symbol_font(self, value: IFontData):
        ...

    @property
    def escapement(self) -> float:
        ...

    @escapement.setter
    def escapement(self, value: float):
        ...

    @property
    def kerning_minimal_size(self) -> float:
        ...

    @kerning_minimal_size.setter
    def kerning_minimal_size(self, value: float):
        ...

    @property
    def language_id(self) -> string:
        ...

    @language_id.setter
    def language_id(self, value: string):
        ...

    @property
    def alternative_language_id(self) -> string:
        ...

    @alternative_language_id.setter
    def alternative_language_id(self, value: string):
        ...

    @property
    def spacing(self) -> float:
        ...

    @spacing.setter
    def spacing(self, value: float):
        ...

    @property
    def slide(self) -> IBaseSlide:
        ...

    @property
    def presentation(self) -> IPresentation:
        ...

    @property
    def as_i_base_portion_format(self) -> IBasePortionFormat:
        ...

    ...

class ChartSeries:
    '''Represents a chart series.'''
    def get_automatic_series_color(self) -> aspose.pydrawing.Color:
        '''Returns an automatic color of series based on series index and chart style. This color is used by default if FillType equals NotDefined.'''
        ...

    @property
    def chart(self) -> IChart:
        ...

    @property
    def explosion(self) -> int:
        ...

    @explosion.setter
    def explosion(self, value: int):
        ...

    @property
    def smooth(self) -> bool:
        ...

    @smooth.setter
    def smooth(self, value: bool):
        ...

    @property
    def name(self) -> IStringChartValue:
        ...

    @property
    def data_points(self) -> IChartDataPointCollection:
        ...

    @property
    def type(self) -> ChartType:
        ...

    @type.setter
    def type(self, value: ChartType):
        ...

    @property
    def plot_on_second_axis(self) -> bool:
        ...

    @plot_on_second_axis.setter
    def plot_on_second_axis(self, value: bool):
        ...

    @property
    def parent_series_group(self) -> IChartSeriesGroup:
        ...

    @property
    def format(self) -> IFormat:
        ...

    @property
    def order(self) -> int:
        ...

    @order.setter
    def order(self, value: int):
        ...

    @property
    def labels(self) -> IDataLabelCollection:
        ...

    @property
    def trend_lines(self) -> ITrendlineCollection:
        ...

    @property
    def error_bars_x_format(self) -> IErrorBarsFormat:
        ...

    @property
    def error_bars_y_format(self) -> IErrorBarsFormat:
        ...

    @property
    def related_legend_entry(self) -> ILegendEntryProperties:
        ...

    @property
    def number_format_of_values(self) -> string:
        ...

    @number_format_of_values.setter
    def number_format_of_values(self, value: string):
        ...

    @property
    def number_format_of_x_values(self) -> string:
        ...

    @number_format_of_x_values.setter
    def number_format_of_x_values(self, value: string):
        ...

    @property
    def number_format_of_y_values(self) -> string:
        ...

    @number_format_of_y_values.setter
    def number_format_of_y_values(self, value: string):
        ...

    @property
    def number_format_of_bubble_sizes(self) -> string:
        ...

    @number_format_of_bubble_sizes.setter
    def number_format_of_bubble_sizes(self, value: string):
        ...

    @property
    def marker(self) -> IMarker:
        ...

    @property
    def bar_3d_shape(self) -> ChartShapeType:
        ...

    @bar_3d_shape.setter
    def bar_3d_shape(self, value: ChartShapeType):
        ...

    @property
    def invert_if_negative(self) -> bool:
        ...

    @invert_if_negative.setter
    def invert_if_negative(self, value: bool):
        ...

    @property
    def inverted_solid_fill_color(self) -> IColorFormat:
        ...

    @property
    def show_inner_points(self) -> bool:
        ...

    @show_inner_points.setter
    def show_inner_points(self, value: bool):
        ...

    @property
    def show_outlier_points(self) -> bool:
        ...

    @show_outlier_points.setter
    def show_outlier_points(self, value: bool):
        ...

    @property
    def show_mean_markers(self) -> bool:
        ...

    @show_mean_markers.setter
    def show_mean_markers(self, value: bool):
        ...

    @property
    def show_mean_line(self) -> bool:
        ...

    @show_mean_line.setter
    def show_mean_line(self, value: bool):
        ...

    @property
    def quartile_method(self) -> QuartileMethodType:
        ...

    @quartile_method.setter
    def quartile_method(self, value: QuartileMethodType):
        ...

    @property
    def show_connector_lines(self) -> bool:
        ...

    @show_connector_lines.setter
    def show_connector_lines(self, value: bool):
        ...

    @property
    def parent_label_layout(self) -> ParentLabelLayoutType:
        ...

    @parent_label_layout.setter
    def parent_label_layout(self, value: ParentLabelLayoutType):
        ...

    @property
    def has_up_down_bars(self) -> bool:
        ...

    @property
    def gap_width(self) -> int:
        ...

    @property
    def gap_depth(self) -> int:
        ...

    @property
    def first_slice_angle(self) -> int:
        ...

    @property
    def doughnut_hole_size(self) -> int:
        ...

    @property
    def overlap(self) -> int:
        ...

    @property
    def second_pie_size(self) -> int:
        ...

    @property
    def has_series_lines(self) -> bool:
        ...

    @property
    def bubble_size_representation(self) -> BubbleSizeRepresentationType:
        ...

    @property
    def pie_split_position(self) -> float:
        ...

    @property
    def pie_split_by(self) -> PieSplitType:
        ...

    @property
    def pie_split_custom_points(self) -> IPieSplitCustomPointCollection:
        ...

    @property
    def is_color_varied(self) -> bool:
        ...

    @property
    def bubble_size_scale(self) -> int:
        ...

    @property
    def as_i_chart_component(self) -> IChartComponent:
        ...

    @property
    def as_i_slide_component(self) -> ISlideComponent:
        ...

    @property
    def slide(self) -> IBaseSlide:
        ...

    @property
    def as_i_presentation_component(self) -> IPresentationComponent:
        ...

    @property
    def presentation(self) -> IPresentation:
        ...

    ...

class ChartSeriesCollection:
    '''Represents collection of  :py:class:`aspose.slides.charts.ChartSeries`'''
    @overload
    def add(self, type: ChartType) -> IChartSeries:
        '''Creates new chart series and adds it to the collection.
        :param type: Type of series
        :returns: New chart series.'''
        ...

    @overload
    def add(self, cell_with_series_name: IChartDataCell, type: ChartType) -> IChartSeries:
        '''Creates new chart series from :py:class:`aspose.slides.charts.ChartDataCell` and adds it to the collection.
        :param cell_with_series_name: Cell which contain series name.
        :param type: Type set type of series
        :returns: Added chart series or series that already is in collection.'''
        ...

    @overload
    def add(self, cells_with_series_name: IChartCellCollection, type: ChartType) -> IChartSeries:
        '''Creates new chart series from :py:class:`aspose.slides.charts.ChartCellCollection` and adds it to the collection.
        :param cells_with_series_name: Cells which contain series name.
        :param type: Type set type of series
        :returns: Added chart series or series that already is in collection.'''
        ...

    @overload
    def add(self, name: string, type: ChartType) -> IChartSeries:
        '''Creates new chart series from value and adds it to the collection.
        :param name: Series name.
        :param type: Type set type of series
        :returns: Added chart series.'''
        ...

    def insert(self, index: int, type: ChartType) -> IChartSeries:
        '''Creates new chart series and inserts it into the collection.'''
        ...

    def index_of(self, value: IChartSeries) -> int:
        '''Searches for the specified :py:class:`aspose.slides.charts.ChartSeries` and returns the zero-based index of the first occurrence within the entire Collection
        :param value: Chart series value.
        :returns: The zero-based index of the first occurrence of value within the entire CollectionBase, if found; otherwise, -1.'''
        ...

    def remove(self, value: IChartSeries) -> None:
        '''Removes the specified value.
        :param value: The value.'''
        ...

    def remove_at(self, index: int) -> None:
        '''Removes an ActiveX control stored at specified position from the collection.
        :param index: Index of a control to remove.'''
        ...

    def clear(self) -> None:
        '''Removes all controls from the collection.'''
        ...

    @property
    def as_i_collection(self) -> list:
        ...

    @property
    def as_i_enumerable(self) -> collections.abc.Iterable:
        ...

    def __getitem__(self, key: int) -> IChartSeries
        '''Gets the element at the specified index.'''
        ...

    ...

class ChartSeriesGroup:
    '''Represents group of series.'''
    @property
    def type(self) -> CombinableSeriesTypesGroup:
        ...

    @property
    def plot_on_second_axis(self) -> bool:
        ...

    @property
    def series(self) -> IChartSeriesReadonlyCollection:
        ...

    @property
    def up_down_bars(self) -> IUpDownBarsManager:
        ...

    @property
    def gap_width(self) -> int:
        ...

    @gap_width.setter
    def gap_width(self, value: int):
        ...

    @property
    def gap_depth(self) -> int:
        ...

    @gap_depth.setter
    def gap_depth(self, value: int):
        ...

    @property
    def first_slice_angle(self) -> int:
        ...

    @first_slice_angle.setter
    def first_slice_angle(self, value: int):
        ...

    @property
    def doughnut_hole_size(self) -> int:
        ...

    @doughnut_hole_size.setter
    def doughnut_hole_size(self, value: int):
        ...

    @property
    def overlap(self) -> int:
        ...

    @overlap.setter
    def overlap(self, value: int):
        ...

    @property
    def second_pie_size(self) -> int:
        ...

    @second_pie_size.setter
    def second_pie_size(self, value: int):
        ...

    @property
    def bubble_size_representation(self) -> BubbleSizeRepresentationType:
        ...

    @bubble_size_representation.setter
    def bubble_size_representation(self, value: BubbleSizeRepresentationType):
        ...

    @property
    def pie_split_position(self) -> float:
        ...

    @pie_split_position.setter
    def pie_split_position(self, value: float):
        ...

    @property
    def pie_split_by(self) -> PieSplitType:
        ...

    @pie_split_by.setter
    def pie_split_by(self, value: PieSplitType):
        ...

    @property
    def is_color_varied(self) -> bool:
        ...

    @is_color_varied.setter
    def is_color_varied(self, value: bool):
        ...

    @property
    def has_series_lines(self) -> bool:
        ...

    @has_series_lines.setter
    def has_series_lines(self, value: bool):
        ...

    @property
    def hi_low_lines_format(self) -> IChartLinesFormat:
        ...

    @property
    def bubble_size_scale(self) -> int:
        ...

    @bubble_size_scale.setter
    def bubble_size_scale(self, value: int):
        ...

    @property
    def pie_split_custom_points(self) -> IPieSplitCustomPointCollection:
        ...

    @property
    def chart(self) -> IChart:
        ...

    @property
    def as_i_chart_component(self) -> IChartComponent:
        ...

    @property
    def as_i_slide_component(self) -> ISlideComponent:
        ...

    @property
    def slide(self) -> IBaseSlide:
        ...

    @property
    def as_i_presentation_component(self) -> IPresentationComponent:
        ...

    @property
    def presentation(self) -> IPresentation:
        ...

    def __getitem__(self, key: int) -> IChartSeries
        '''Gets the element at the specified index.'''
        ...

    ...

class ChartTextFormat:
    '''Specifies default text formatting for chart text elements.'''
    def copy_to(self, dest_text_frame: ITextFrame) -> None:
        ...

    def copy_from(self, source_text_frame: ITextFrame) -> None:
        ...

    @property
    def text_block_format(self) -> IChartTextBlockFormat:
        ...

    @property
    def paragraph_format(self) -> IChartParagraphFormat:
        ...

    @property
    def portion_format(self) -> IChartPortionFormat:
        ...

    ...

class ChartTitle:
    '''Represents chart title properties.'''
    def add_text_frame_for_overriding(self, text: string) -> ITextFrame:
        '''Initialize TextFrameForOverriding with the text in paramener "text".
                    If TextFrameForOverriding is already initialized then simply changes its text.
        :param text: Text for a new TextFrameForOverriding.'''
        ...

    @property
    def x(self) -> float:
        ...

    @x.setter
    def x(self, value: float):
        ...

    @property
    def y(self) -> float:
        ...

    @y.setter
    def y(self, value: float):
        ...

    @property
    def width(self) -> float:
        ...

    @width.setter
    def width(self, value: float):
        ...

    @property
    def height(self) -> float:
        ...

    @height.setter
    def height(self, value: float):
        ...

    @property
    def right(self) -> float:
        ...

    @property
    def bottom(self) -> float:
        ...

    @property
    def overlay(self) -> bool:
        ...

    @overlay.setter
    def overlay(self, value: bool):
        ...

    @property
    def format(self) -> IFormat:
        ...

    @property
    def text_frame_for_overriding(self) -> ITextFrame:
        ...

    @property
    def text_format(self) -> IChartTextFormat:
        ...

    @property
    def chart(self) -> IChart:
        ...

    @property
    def as_i_layoutable(self) -> ILayoutable:
        ...

    @property
    def as_i_overridable_text(self) -> IOverridableText:
        ...

    @property
    def as_i_slide_component(self) -> ISlideComponent:
        ...

    @property
    def slide(self) -> IBaseSlide:
        ...

    @property
    def as_i_presentation_component(self) -> IPresentationComponent:
        ...

    @property
    def presentation(self) -> IPresentation:
        ...

    @property
    def as_i_formatted_text_container(self) -> IFormattedTextContainer:
        ...

    ...

class ChartTypeCharacterizer:
    '''Helper for getting additional information about charts and series by its ChartType.'''
    @staticmethod
    def is_bar_3d_chart(chart_type: ChartType) -> bool:
        '''Return true if chartType is one of bar3DChart subtypes (3D columns or bars).'''
        ...

    @staticmethod
    def is_2d_chart(chart_type: ChartType) -> bool:
        '''Return true if ``chartType`` is one of 2D chart types.'''
        ...

    @staticmethod
    def is_3d_chart(chart_type: ChartType) -> bool:
        '''Return true if ``chartType`` is one of 3D chart types.'''
        ...

    @staticmethod
    def is_chart_type_column(chart_type: ChartType) -> bool:
        '''Return true if chartType is one of Column subtypes.
                    Subtypes set corresponds to the appropriate set in PowerPoint (see "Change Chart Type" dialog in PowerPoint):
                    :py:attr:`aspose.slides.charts.ChartType.CLUSTERED_COLUMN`,
                    :py:attr:`aspose.slides.charts.ChartType.CLUSTERED_COLUMN_3D`,
                    :py:attr:`aspose.slides.charts.ChartType.CLUSTERED_CONE`,
                    :py:attr:`aspose.slides.charts.ChartType.CLUSTERED_CYLINDER`,
                    :py:attr:`aspose.slides.charts.ChartType.CLUSTERED_PYRAMID`,
                    :py:attr:`aspose.slides.charts.ChartType.PERCENTS_STACKED_COLUMN`,
                    :py:attr:`aspose.slides.charts.ChartType.PERCENTS_STACKED_COLUMN_3D`,
                    :py:attr:`aspose.slides.charts.ChartType.PERCENTS_STACKED_CONE`,
                    :py:attr:`aspose.slides.charts.ChartType.PERCENTS_STACKED_CYLINDER`,
                    :py:attr:`aspose.slides.charts.ChartType.PERCENTS_STACKED_PYRAMID`,
                    :py:attr:`aspose.slides.charts.ChartType.STACKED_COLUMN`,
                    :py:attr:`aspose.slides.charts.ChartType.STACKED_COLUMN_3D`,
                    :py:attr:`aspose.slides.charts.ChartType.STACKED_CONE`,
                    :py:attr:`aspose.slides.charts.ChartType.STACKED_CYLINDER`,
                    :py:attr:`aspose.slides.charts.ChartType.STACKED_PYRAMID`,
                    :py:attr:`aspose.slides.charts.ChartType.COLUMN_3D`,
                    :py:attr:`aspose.slides.charts.ChartType.CYLINDER_3D`,
                    :py:attr:`aspose.slides.charts.ChartType.CONE_3D`,
                    :py:attr:`aspose.slides.charts.ChartType.PYRAMID_3D`.'''
        ...

    @staticmethod
    def is_chart_type_line(chart_type: ChartType) -> bool:
        '''Return true if chartType is one of Line subtypes.
                    Subtypes set corresponds to the appropriate set in PowerPoint (see "Change Chart Type" dialog in PowerPoint):
                    :py:attr:`aspose.slides.charts.ChartType.LINE`,
                    :py:attr:`aspose.slides.charts.ChartType.LINE_WITH_MARKERS`,
                    :py:attr:`aspose.slides.charts.ChartType.PERCENTS_STACKED_LINE`,
                    :py:attr:`aspose.slides.charts.ChartType.PERCENTS_STACKED_LINE_WITH_MARKERS`,
                    :py:attr:`aspose.slides.charts.ChartType.STACKED_LINE`,
                    :py:attr:`aspose.slides.charts.ChartType.STACKED_LINE_WITH_MARKERS`,
                    :py:attr:`aspose.slides.charts.ChartType.LINE_3D`.'''
        ...

    @staticmethod
    def is_chart_type_pie(chart_type: ChartType) -> bool:
        '''Return true if chartType is one of Pie subtypes.
                    Subtypes set corresponds to the appropriate set in PowerPoint (see "Change Chart Type" dialog in PowerPoint):
                    :py:attr:`aspose.slides.charts.ChartType.BAR_OF_PIE`,
                    :py:attr:`aspose.slides.charts.ChartType.EXPLODED_PIE`,
                    :py:attr:`aspose.slides.charts.ChartType.EXPLODED_PIE_3D`,
                    :py:attr:`aspose.slides.charts.ChartType.PIE`,
                    :py:attr:`aspose.slides.charts.ChartType.PIE_3D`,
                    :py:attr:`aspose.slides.charts.ChartType.PIE_OF_PIE`.'''
        ...

    @staticmethod
    def is_chart_type_bar(chart_type: ChartType) -> bool:
        '''Return true if chartType is one of Bar subtypes.
                    Subtypes set corresponds to the appropriate set in PowerPoint (see "Change Chart Type" dialog in PowerPoint):
                    :py:attr:`aspose.slides.charts.ChartType.CLUSTERED_BAR`,
                    :py:attr:`aspose.slides.charts.ChartType.CLUSTERED_BAR_3D`,
                    :py:attr:`aspose.slides.charts.ChartType.PERCENTS_STACKED_BAR`,
                    :py:attr:`aspose.slides.charts.ChartType.PERCENTS_STACKED_BAR_3D`,
                    :py:attr:`aspose.slides.charts.ChartType.STACKED_BAR`,
                    :py:attr:`aspose.slides.charts.ChartType.STACKED_BAR_3D`,
                    :py:attr:`aspose.slides.charts.ChartType.CLUSTERED_HORIZONTAL_CONE`,
                    :py:attr:`aspose.slides.charts.ChartType.CLUSTERED_HORIZONTAL_CYLINDER`,
                    :py:attr:`aspose.slides.charts.ChartType.CLUSTERED_HORIZONTAL_PYRAMID`,
                    :py:attr:`aspose.slides.charts.ChartType.STACKED_HORIZONTAL_CONE`,
                    :py:attr:`aspose.slides.charts.ChartType.STACKED_HORIZONTAL_CYLINDER`,
                    :py:attr:`aspose.slides.charts.ChartType.STACKED_HORIZONTAL_PYRAMID`,
                    :py:attr:`aspose.slides.charts.ChartType.PERCENTS_STACKED_HORIZONTAL_CONE`,
                    :py:attr:`aspose.slides.charts.ChartType.PERCENTS_STACKED_HORIZONTAL_CYLINDER`,
                    :py:attr:`aspose.slides.charts.ChartType.PERCENTS_STACKED_HORIZONTAL_PYRAMID`.'''
        ...

    @staticmethod
    def is_chart_type_area(chart_type: ChartType) -> bool:
        '''Return true if chartType is one of Area subtypes.
                    Subtypes set corresponds to the appropriate set in PowerPoint (see "Change Chart Type" dialog in PowerPoint):
                    :py:attr:`aspose.slides.charts.ChartType.AREA`,
                    :py:attr:`aspose.slides.charts.ChartType.PERCENTS_STACKED_AREA`,
                    :py:attr:`aspose.slides.charts.ChartType.PERCENTS_STACKED_AREA_3D`,
                    :py:attr:`aspose.slides.charts.ChartType.STACKED_AREA`,
                    :py:attr:`aspose.slides.charts.ChartType.STACKED_AREA_3D`,
                    :py:attr:`aspose.slides.charts.ChartType.AREA_3D`.'''
        ...

    @staticmethod
    def is_chart_type_scatter(chart_type: ChartType) -> bool:
        '''Return true if chartType is one of Scatter subtypes.
                    Subtypes set corresponds to the appropriate set in PowerPoint (see "Change Chart Type" dialog in PowerPoint):
                    :py:attr:`aspose.slides.charts.ChartType.SCATTER_WITH_MARKERS`,
                    :py:attr:`aspose.slides.charts.ChartType.SCATTER_WITH_SMOOTH_LINES`,
                    :py:attr:`aspose.slides.charts.ChartType.SCATTER_WITH_SMOOTH_LINES_AND_MARKERS`,
                    :py:attr:`aspose.slides.charts.ChartType.SCATTER_WITH_STRAIGHT_LINES`,
                    :py:attr:`aspose.slides.charts.ChartType.SCATTER_WITH_STRAIGHT_LINES_AND_MARKERS`.'''
        ...

    @staticmethod
    def is_chart_type_stock(chart_type: ChartType) -> bool:
        '''Return true if chartType is one of Stock subtypes.
                    Subtypes set corresponds to the appropriate set in PowerPoint (see "Change Chart Type" dialog in PowerPoint):
                    :py:attr:`aspose.slides.charts.ChartType.HIGH_LOW_CLOSE`,
                    :py:attr:`aspose.slides.charts.ChartType.OPEN_HIGH_LOW_CLOSE`,
                    :py:attr:`aspose.slides.charts.ChartType.VOLUME_HIGH_LOW_CLOSE`,
                    :py:attr:`aspose.slides.charts.ChartType.VOLUME_OPEN_HIGH_LOW_CLOSE`.'''
        ...

    @staticmethod
    def is_chart_type_surface(chart_type: ChartType) -> bool:
        '''Return true if chartType is one of Surface subtypes.
                    Subtypes set corresponds to the appropriate set in PowerPoint (see "Change Chart Type" dialog in PowerPoint):
                    :py:attr:`aspose.slides.charts.ChartType.SURFACE_3D`,
                    :py:attr:`aspose.slides.charts.ChartType.WIREFRAME_SURFACE_3D`,
                    :py:attr:`aspose.slides.charts.ChartType.CONTOUR`,
                    :py:attr:`aspose.slides.charts.ChartType.WIREFRAME_CONTOUR`.'''
        ...

    @staticmethod
    def is_chart_type_doughnut(chart_type: ChartType) -> bool:
        '''Return true if chartType is one of Doughnut subtypes.
                    Subtypes set corresponds to the appropriate set in PowerPoint (see "Change Chart Type" dialog in PowerPoint):
                    :py:attr:`aspose.slides.charts.ChartType.DOUGHNUT`,
                    :py:attr:`aspose.slides.charts.ChartType.EXPLODED_DOUGHNUT`.'''
        ...

    @staticmethod
    def is_chart_type_bubble(chart_type: ChartType) -> bool:
        '''Return true if chartType is one of Bubble subtypes.
                    Subtypes set corresponds to the appropriate set in PowerPoint (see "Change Chart Type" dialog in PowerPoint):
                    :py:attr:`aspose.slides.charts.ChartType.BUBBLE`,
                    :py:attr:`aspose.slides.charts.ChartType.BUBBLE_WITH_3D`.'''
        ...

    @staticmethod
    def is_chart_type_radar(chart_type: ChartType) -> bool:
        '''Return true if chartType is one of Radar subtypes.
                    Subtypes set corresponds to the appropriate set in PowerPoint (see "Change Chart Type" dialog in PowerPoint):
                    :py:attr:`aspose.slides.charts.ChartType.FILLED_RADAR`,
                    :py:attr:`aspose.slides.charts.ChartType.RADAR`,
                    :py:attr:`aspose.slides.charts.ChartType.RADAR_WITH_MARKERS`.'''
        ...

    @staticmethod
    def is_series_uses_x_value_coordinate(series_type: ChartType) -> bool:
        '''Returns if specified series type uses X value coordinates.
        :param series_type: Series type.
        :returns: True if uses otherwise false.'''
        ...

    @staticmethod
    def is_series_uses_y_value_coordinate(series_type: ChartType) -> bool:
        '''Returns if specified series type uses Y value coordinates.
        :param series_type: Series type.
        :returns: True if uses otherwise false.'''
        ...

    @staticmethod
    def is_series_uses_value_coordinate(series_type: ChartType) -> bool:
        '''Returns if specified series type uses value coordinates.
        :param series_type: Series type.
        :returns: True if uses otherwise false.'''
        ...

    @staticmethod
    def is_series_uses_bubble_size_coordinate(series_type: ChartType) -> bool:
        '''Returns if bubble size coordinates can be used for specified series type.
        :param series_type: Series type.
        :returns: True if can be used, otherwise false.'''
        ...

    @staticmethod
    def has_series_trend_lines(series_type: ChartType) -> bool:
        '''Returns if there are series trend lines for specified series type.
        :param series_type: Series type.
        :returns: True if present otherwise false.'''
        ...

    @staticmethod
    def is_error_bars_x_allowed(series_type: ChartType) -> bool:
        '''Returns if error bars X allowed for specified series type.
        :param series_type: Series type.
        :returns: True if allowed, otherwise false.'''
        ...

    @staticmethod
    def is_error_bars_y_allowed(series_type: ChartType) -> bool:
        '''Returns if error bars Y allowed for specified series type.
        :param series_type: Series type.
        :returns: True if allowed, otherwise false.'''
        ...

    ...

class ChartWall:
    '''Represents walls on 3d charts.'''
    @property
    def thickness(self) -> int:
        ...

    @thickness.setter
    def thickness(self, value: int):
        ...

    @property
    def format(self) -> IFormat:
        ...

    @property
    def picture_type(self) -> PictureType:
        ...

    @picture_type.setter
    def picture_type(self, value: PictureType):
        ...

    ...

class DataLabel:
    '''Represents a series labels.'''
    def __init__(self, parent_immediate: IChartDataPoint):
        '''Creates a new instance of DataLabel class.
        :param parent_immediate: Parent ChartDataPoint.'''
        ...

    def hide(self) -> None:
        '''Make data label hidden by setting all Show*-flags (ShowValue, ...) to false state.
                    IsVisible will be false after this.'''
        ...

    def get_actual_label_text(self) -> string:
        '''Returns actual label text based on DataLabelFormat settings or TextFrameForOverriding.Text value.'''
        ...

    def add_text_frame_for_overriding(self, text: string) -> ITextFrame:
        '''Initialize TextFrameForOverriding with the text in paramener "text".
                    If TextFrameForOverriding is already initialized then simply changes its text.
        :param text: Text for a new TextFrameForOverriding.'''
        ...

    @property
    def chart(self) -> IChart:
        ...

    @property
    def is_visible(self) -> bool:
        ...

    @property
    def text_frame_for_overriding(self) -> ITextFrame:
        ...

    @property
    def text_format(self) -> IChartTextFormat:
        ...

    @property
    def x(self) -> float:
        ...

    @x.setter
    def x(self, value: float):
        ...

    @property
    def y(self) -> float:
        ...

    @y.setter
    def y(self, value: float):
        ...

    @property
    def width(self) -> float:
        ...

    @width.setter
    def width(self, value: float):
        ...

    @property
    def height(self) -> float:
        ...

    @height.setter
    def height(self, value: float):
        ...

    @property
    def right(self) -> float:
        ...

    @property
    def bottom(self) -> float:
        ...

    @property
    def data_label_format(self) -> IDataLabelFormat:
        ...

    @property
    def value_from_cell(self) -> IChartDataCell:
        ...

    @value_from_cell.setter
    def value_from_cell(self, value: IChartDataCell):
        ...

    @property
    def actual_x(self) -> float:
        ...

    @property
    def actual_y(self) -> float:
        ...

    @property
    def actual_width(self) -> float:
        ...

    @property
    def actual_height(self) -> float:
        ...

    @property
    def as_i_layoutable(self) -> ILayoutable:
        ...

    @property
    def as_i_overridable_text(self) -> IOverridableText:
        ...

    @property
    def as_i_actual_layout(self) -> IActualLayout:
        ...

    @property
    def as_i_slide_component(self) -> ISlideComponent:
        ...

    @property
    def slide(self) -> IBaseSlide:
        ...

    @property
    def as_i_presentation_component(self) -> IPresentationComponent:
        ...

    @property
    def presentation(self) -> IPresentation:
        ...

    @property
    def as_i_formatted_text_container(self) -> IFormattedTextContainer:
        ...

    ...

class DataLabelCollection:
    '''Represents a series labels.'''
    def hide(self) -> None:
        '''Make data label hidden by default by setting all Show*-flags (ShowValue, ...) of the 
                    DefaultDataLabelFormat property to false state.
                    IsVisible will be false after this.'''
        ...

    def index_of(self, value: IDataLabel) -> int:
        '''Returns an index of the specified DataLabel in the collection.
        :param value: DataLabel to find.
        :returns: Index of a DataLabel or -1 if DataLabel not from this collection.'''
        ...

    @property
    def chart(self) -> IChart:
        ...

    @property
    def is_visible(self) -> bool:
        ...

    @property
    def count_of_visible_data_labels(self) -> int:
        ...

    @property
    def count(self) -> int:
        ...

    @property
    def default_data_label_format(self) -> IDataLabelFormat:
        ...

    @property
    def leader_lines_format(self) -> IChartLinesFormat:
        ...

    @property
    def parent_series(self) -> IChartSeries:
        ...

    @property
    def as_i_chart_component(self) -> IChartComponent:
        ...

    @property
    def as_i_enumerable(self) -> collections.abc.Iterable:
        ...

    @property
    def as_i_slide_component(self) -> ISlideComponent:
        ...

    @property
    def slide(self) -> IBaseSlide:
        ...

    @property
    def as_i_presentation_component(self) -> IPresentationComponent:
        ...

    @property
    def presentation(self) -> IPresentation:
        ...

    def __getitem__(self, key: int) -> IDataLabel
        '''Gets the data label for the data point with the specified index.'''
        ...

    ...

class DataLabelFormat(aspose.slides.PVIObject):
    '''Represents formatting options for DataLabel.'''
    @property
    def as_i_presentation_component(self) -> IPresentationComponent:
        ...

    @property
    def is_number_format_linked_to_source(self) -> bool:
        ...

    @is_number_format_linked_to_source.setter
    def is_number_format_linked_to_source(self, value: bool):
        ...

    @property
    def number_format(self) -> string:
        ...

    @number_format.setter
    def number_format(self, value: string):
        ...

    @property
    def format(self) -> IFormat:
        ...

    @property
    def position(self) -> LegendDataLabelPosition:
        ...

    @position.setter
    def position(self, value: LegendDataLabelPosition):
        ...

    @property
    def show_legend_key(self) -> bool:
        ...

    @show_legend_key.setter
    def show_legend_key(self, value: bool):
        ...

    @property
    def show_value(self) -> bool:
        ...

    @show_value.setter
    def show_value(self, value: bool):
        ...

    @property
    def show_category_name(self) -> bool:
        ...

    @show_category_name.setter
    def show_category_name(self, value: bool):
        ...

    @property
    def show_series_name(self) -> bool:
        ...

    @show_series_name.setter
    def show_series_name(self, value: bool):
        ...

    @property
    def show_percentage(self) -> bool:
        ...

    @show_percentage.setter
    def show_percentage(self, value: bool):
        ...

    @property
    def show_bubble_size(self) -> bool:
        ...

    @show_bubble_size.setter
    def show_bubble_size(self, value: bool):
        ...

    @property
    def show_leader_lines(self) -> bool:
        ...

    @show_leader_lines.setter
    def show_leader_lines(self, value: bool):
        ...

    @property
    def show_label_value_from_cell(self) -> bool:
        ...

    @show_label_value_from_cell.setter
    def show_label_value_from_cell(self, value: bool):
        ...

    @property
    def show_label_as_data_callout(self) -> bool:
        ...

    @show_label_as_data_callout.setter
    def show_label_as_data_callout(self, value: bool):
        ...

    @property
    def separator(self) -> string:
        ...

    @separator.setter
    def separator(self, value: string):
        ...

    @property
    def text_format(self) -> IChartTextFormat:
        ...

    @property
    def chart(self) -> IChart:
        ...

    @property
    def slide(self) -> IBaseSlide:
        ...

    @property
    def presentation(self) -> IPresentation:
        ...

    @property
    def as_i_formatted_text_container(self) -> IFormattedTextContainer:
        ...

    @property
    def as_i_chart_component(self) -> IChartComponent:
        ...

    @property
    def as_i_slide_component(self) -> ISlideComponent:
        ...

    ...

class DataSourceTypeForErrorBarsCustomValues:
    '''Specifies types of values in ChartDataPoint.ErrorBarsCustomValues properties list'''
    def __init__(self):
        ...

    @property
    def data_source_type_for_x_minus_values(self) -> DataSourceType:
        ...

    @data_source_type_for_x_minus_values.setter
    def data_source_type_for_x_minus_values(self, value: DataSourceType):
        ...

    @property
    def data_source_type_for_x_plus_values(self) -> DataSourceType:
        ...

    @data_source_type_for_x_plus_values.setter
    def data_source_type_for_x_plus_values(self, value: DataSourceType):
        ...

    @property
    def data_source_type_for_y_minus_values(self) -> DataSourceType:
        ...

    @data_source_type_for_y_minus_values.setter
    def data_source_type_for_y_minus_values(self, value: DataSourceType):
        ...

    @property
    def data_source_type_for_y_plus_values(self) -> DataSourceType:
        ...

    @data_source_type_for_y_plus_values.setter
    def data_source_type_for_y_plus_values(self, value: DataSourceType):
        ...

    ...

class DataTable:
    '''Represents data table properties.'''
    @property
    def format(self) -> IFormat:
        ...

    @property
    def has_border_horizontal(self) -> bool:
        ...

    @has_border_horizontal.setter
    def has_border_horizontal(self, value: bool):
        ...

    @property
    def has_border_outline(self) -> bool:
        ...

    @has_border_outline.setter
    def has_border_outline(self, value: bool):
        ...

    @property
    def has_border_vertical(self) -> bool:
        ...

    @has_border_vertical.setter
    def has_border_vertical(self, value: bool):
        ...

    @property
    def show_legend_key(self) -> bool:
        ...

    @show_legend_key.setter
    def show_legend_key(self, value: bool):
        ...

    @property
    def chart(self) -> IChart:
        ...

    @property
    def text_format(self) -> IChartTextFormat:
        ...

    @property
    def as_i_formatted_text_container(self) -> IFormattedTextContainer:
        ...

    @property
    def as_i_chart_component(self) -> IChartComponent:
        ...

    @property
    def as_i_slide_component(self) -> ISlideComponent:
        ...

    @property
    def slide(self) -> IBaseSlide:
        ...

    @property
    def as_i_presentation_component(self) -> IPresentationComponent:
        ...

    @property
    def presentation(self) -> IPresentation:
        ...

    ...

class DoubleChartValue(BaseChartValue):
    '''Represent double value which can be stored in pptx presentation document in two ways:
                1) in cell/cells of workbook related to chart;
                2) as literal value.'''
    def to_double(self) -> float:
        '''Converts to :py:class:`float`.
        :returns: Returns LiteralDouble if DataSourceType equals DoubleLiterals.
                    If DataSourceType equals Worksheet returns successfully converted to double cell value, otherwise returns NaN.'''
        ...

    @property
    def data_source_type(self) -> DataSourceType:
        ...

    @data_source_type.setter
    def data_source_type(self, value: DataSourceType):
        ...

    @property
    def data(self) -> any:
        ...

    @data.setter
    def data(self, value: any):
        ...

    @property
    def as_cell(self) -> IChartDataCell:
        ...

    @as_cell.setter
    def as_cell(self, value: IChartDataCell):
        ...

    @property
    def as_literal_double(self) -> float:
        ...

    @as_literal_double.setter
    def as_literal_double(self, value: float):
        ...

    @property
    def as_i_single_cell_chart_value(self) -> ISingleCellChartValue:
        ...

    @property
    def as_i_base_chart_value(self) -> IBaseChartValue:
        ...

    ...

class ErrorBarsCustomValues:
    '''Specifies the errors bar values. It shall be used only when the Error bars value type is Custom.'''
    @property
    def x_minus(self) -> IDoubleChartValue:
        ...

    @property
    def y_minus(self) -> IDoubleChartValue:
        ...

    @property
    def x_plus(self) -> IDoubleChartValue:
        ...

    @property
    def y_plus(self) -> IDoubleChartValue:
        ...

    ...

class ErrorBarsFormat:
    '''Represents error bars of chart series. ErrorBars custom values are in IChartDataPointCollection
                (in :py:attr:`aspose.slides.charts.IChartDataPoint.error_bars_custom_values` property).'''
    @property
    def type(self) -> ErrorBarType:
        ...

    @type.setter
    def type(self, value: ErrorBarType):
        ...

    @property
    def value_type(self) -> ErrorBarValueType:
        ...

    @value_type.setter
    def value_type(self, value: ErrorBarValueType):
        ...

    @property
    def has_end_cap(self) -> bool:
        ...

    @has_end_cap.setter
    def has_end_cap(self, value: bool):
        ...

    @property
    def value(self) -> float:
        ...

    @value.setter
    def value(self, value: float):
        ...

    @property
    def format(self) -> IFormat:
        ...

    @format.setter
    def format(self, value: IFormat):
        ...

    @property
    def chart(self) -> IChart:
        ...

    @property
    def is_visible(self) -> bool:
        ...

    @is_visible.setter
    def is_visible(self, value: bool):
        ...

    @property
    def as_i_chart_component(self) -> IChartComponent:
        ...

    @property
    def as_i_slide_component(self) -> ISlideComponent:
        ...

    @property
    def slide(self) -> IBaseSlide:
        ...

    @property
    def as_i_presentation_component(self) -> IPresentationComponent:
        ...

    @property
    def presentation(self) -> IPresentation:
        ...

    ...

class Format(aspose.slides.PVIObject):
    '''Represents chart format properties.'''
    @property
    def as_i_presentation_component(self) -> IPresentationComponent:
        ...

    @property
    def fill(self) -> IFillFormat:
        ...

    @property
    def line(self) -> ILineFormat:
        ...

    @property
    def effect(self) -> IEffectFormat:
        ...

    @property
    def effect_3d(self) -> IThreeDFormat:
        ...

    @property
    def slide(self) -> IBaseSlide:
        ...

    @property
    def presentation(self) -> IPresentation:
        ...

    ...

class IActualLayout:
    @property
    def actual_x(self) -> float:
        ...

    @property
    def actual_y(self) -> float:
        ...

    @property
    def actual_width(self) -> float:
        ...

    @property
    def actual_height(self) -> float:
        ...

    ...

class IAxesManager:
    @property
    def horizontal_axis(self) -> IAxis:
        ...

    @property
    def secondary_horizontal_axis(self) -> IAxis:
        ...

    @property
    def vertical_axis(self) -> IAxis:
        ...

    @property
    def secondary_vertical_axis(self) -> IAxis:
        ...

    @property
    def series_axis(self) -> IAxis:
        ...

    ...

class IAxis:
    def set_category_axis_type_automatically(self) -> None:
        ...

    @property
    def axis_between_categories(self) -> bool:
        ...

    @axis_between_categories.setter
    def axis_between_categories(self, value: bool):
        ...

    @property
    def cross_at(self) -> float:
        ...

    @cross_at.setter
    def cross_at(self, value: float):
        ...

    @property
    def display_unit(self) -> DisplayUnitType:
        ...

    @display_unit.setter
    def display_unit(self, value: DisplayUnitType):
        ...

    @property
    def actual_max_value(self) -> float:
        ...

    @property
    def actual_min_value(self) -> float:
        ...

    @property
    def actual_major_unit(self) -> float:
        ...

    @property
    def actual_minor_unit(self) -> float:
        ...

    @property
    def actual_major_unit_scale(self) -> TimeUnitType:
        ...

    @property
    def actual_minor_unit_scale(self) -> TimeUnitType:
        ...

    @property
    def is_automatic_max_value(self) -> bool:
        ...

    @is_automatic_max_value.setter
    def is_automatic_max_value(self, value: bool):
        ...

    @property
    def max_value(self) -> float:
        ...

    @max_value.setter
    def max_value(self, value: float):
        ...

    @property
    def minor_unit(self) -> float:
        ...

    @minor_unit.setter
    def minor_unit(self, value: float):
        ...

    @property
    def is_automatic_minor_unit(self) -> bool:
        ...

    @is_automatic_minor_unit.setter
    def is_automatic_minor_unit(self, value: bool):
        ...

    @property
    def major_unit(self) -> float:
        ...

    @major_unit.setter
    def major_unit(self, value: float):
        ...

    @property
    def is_automatic_major_unit(self) -> bool:
        ...

    @is_automatic_major_unit.setter
    def is_automatic_major_unit(self, value: bool):
        ...

    @property
    def is_automatic_min_value(self) -> bool:
        ...

    @is_automatic_min_value.setter
    def is_automatic_min_value(self, value: bool):
        ...

    @property
    def min_value(self) -> float:
        ...

    @min_value.setter
    def min_value(self, value: float):
        ...

    @property
    def is_logarithmic(self) -> bool:
        ...

    @is_logarithmic.setter
    def is_logarithmic(self, value: bool):
        ...

    @property
    def log_base(self) -> float:
        ...

    @log_base.setter
    def log_base(self, value: float):
        ...

    @property
    def is_plot_order_reversed(self) -> bool:
        ...

    @is_plot_order_reversed.setter
    def is_plot_order_reversed(self, value: bool):
        ...

    @property
    def is_visible(self) -> bool:
        ...

    @is_visible.setter
    def is_visible(self, value: bool):
        ...

    @property
    def major_tick_mark(self) -> TickMarkType:
        ...

    @major_tick_mark.setter
    def major_tick_mark(self, value: TickMarkType):
        ...

    @property
    def minor_tick_mark(self) -> TickMarkType:
        ...

    @minor_tick_mark.setter
    def minor_tick_mark(self, value: TickMarkType):
        ...

    @property
    def tick_label_position(self) -> TickLabelPositionType:
        ...

    @tick_label_position.setter
    def tick_label_position(self, value: TickLabelPositionType):
        ...

    @property
    def major_unit_scale(self) -> TimeUnitType:
        ...

    @major_unit_scale.setter
    def major_unit_scale(self, value: TimeUnitType):
        ...

    @property
    def minor_unit_scale(self) -> TimeUnitType:
        ...

    @minor_unit_scale.setter
    def minor_unit_scale(self, value: TimeUnitType):
        ...

    @property
    def base_unit_scale(self) -> TimeUnitType:
        ...

    @base_unit_scale.setter
    def base_unit_scale(self, value: TimeUnitType):
        ...

    @property
    def minor_grid_lines_format(self) -> IChartLinesFormat:
        ...

    @property
    def major_grid_lines_format(self) -> IChartLinesFormat:
        ...

    @property
    def show_minor_grid_lines(self) -> bool:
        ...

    @property
    def show_major_grid_lines(self) -> bool:
        ...

    @property
    def format(self) -> IAxisFormat:
        ...

    @property
    def title(self) -> IChartTitle:
        ...

    @property
    def cross_type(self) -> CrossesType:
        ...

    @cross_type.setter
    def cross_type(self, value: CrossesType):
        ...

    @property
    def position(self) -> AxisPositionType:
        ...

    @position.setter
    def position(self, value: AxisPositionType):
        ...

    @property
    def has_title(self) -> bool:
        ...

    @has_title.setter
    def has_title(self, value: bool):
        ...

    @property
    def number_format(self) -> string:
        ...

    @number_format.setter
    def number_format(self, value: string):
        ...

    @property
    def is_number_format_linked_to_source(self) -> bool:
        ...

    @is_number_format_linked_to_source.setter
    def is_number_format_linked_to_source(self, value: bool):
        ...

    @property
    def tick_label_rotation_angle(self) -> float:
        ...

    @tick_label_rotation_angle.setter
    def tick_label_rotation_angle(self, value: float):
        ...

    @property
    def tick_label_spacing(self) -> int:
        ...

    @tick_label_spacing.setter
    def tick_label_spacing(self, value: int):
        ...

    @property
    def is_automatic_tick_label_spacing(self) -> bool:
        ...

    @is_automatic_tick_label_spacing.setter
    def is_automatic_tick_label_spacing(self, value: bool):
        ...

    @property
    def tick_marks_spacing(self) -> int:
        ...

    @tick_marks_spacing.setter
    def tick_marks_spacing(self, value: int):
        ...

    @property
    def is_automatic_tick_marks_spacing(self) -> bool:
        ...

    @is_automatic_tick_marks_spacing.setter
    def is_automatic_tick_marks_spacing(self, value: bool):
        ...

    @property
    def label_offset(self) -> int:
        ...

    @label_offset.setter
    def label_offset(self, value: int):
        ...

    @property
    def category_axis_type(self) -> CategoryAxisType:
        ...

    @category_axis_type.setter
    def category_axis_type(self, value: CategoryAxisType):
        ...

    @property
    def aggregation_type(self) -> AxisAggregationType:
        ...

    @aggregation_type.setter
    def aggregation_type(self, value: AxisAggregationType):
        ...

    @property
    def bin_width(self) -> float:
        ...

    @bin_width.setter
    def bin_width(self, value: float):
        ...

    @property
    def number_of_bins(self) -> int:
        ...

    @number_of_bins.setter
    def number_of_bins(self, value: int):
        ...

    @property
    def is_overflow_bin(self) -> bool:
        ...

    @is_overflow_bin.setter
    def is_overflow_bin(self, value: bool):
        ...

    @property
    def is_automatic_overflow_bin(self) -> bool:
        ...

    @is_automatic_overflow_bin.setter
    def is_automatic_overflow_bin(self, value: bool):
        ...

    @property
    def overflow_bin(self) -> float:
        ...

    @overflow_bin.setter
    def overflow_bin(self, value: float):
        ...

    @property
    def is_underflow_bin(self) -> bool:
        ...

    @is_underflow_bin.setter
    def is_underflow_bin(self, value: bool):
        ...

    @property
    def is_automatic_underflow_bin(self) -> bool:
        ...

    @is_automatic_underflow_bin.setter
    def is_automatic_underflow_bin(self, value: bool):
        ...

    @property
    def underflow_bin(self) -> float:
        ...

    @underflow_bin.setter
    def underflow_bin(self, value: float):
        ...

    @property
    def as_i_formatted_text_container(self) -> IFormattedTextContainer:
        ...

    @property
    def text_format(self) -> IChartTextFormat:
        ...

    @property
    def as_i_chart_component(self) -> IChartComponent:
        ...

    @property
    def chart(self) -> IChart:
        ...

    @property
    def as_i_slide_component(self) -> ISlideComponent:
        ...

    @property
    def slide(self) -> IBaseSlide:
        ...

    @property
    def as_i_presentation_component(self) -> IPresentationComponent:
        ...

    @property
    def presentation(self) -> IPresentation:
        ...

    ...

class IAxisFormat:
    @property
    def fill(self) -> IFillFormat:
        ...

    @property
    def line(self) -> ILineFormat:
        ...

    @property
    def effect(self) -> IEffectFormat:
        ...

    ...

class IBaseChartValue:
    @property
    def data_source_type(self) -> DataSourceType:
        ...

    @data_source_type.setter
    def data_source_type(self, value: DataSourceType):
        ...

    @property
    def data(self) -> any:
        ...

    @data.setter
    def data(self, value: any):
        ...

    ...

class IChart:
    @overload
    def get_thumbnail(self) -> aspose.pydrawing.Bitmap:
        ...

    @overload
    def get_thumbnail(self, bounds: ShapeThumbnailBounds, scale_x: float, scale_y: float) -> aspose.pydrawing.Bitmap:
        ...

    @overload
    def get_image(self) -> IImage:
        ...

    @overload
    def get_image(self, bounds: ShapeThumbnailBounds, scale_x: float, scale_y: float) -> IImage:
        ...

    @overload
    def write_as_svg(self, stream: System.IO.Stream) -> None:
        ...

    @overload
    def write_as_svg(self, stream: System.IO.Stream, svg_options: aspose.slides.export.ISVGOptions) -> None:
        ...

    def validate_chart_layout(self) -> None:
        ...

    def add_placeholder(self, placeholder_to_copy_from: IPlaceholder) -> IPlaceholder:
        ...

    def remove_placeholder(self) -> None:
        ...

    def get_base_placeholder(self) -> IShape:
        ...

    def create_theme_effective(self) -> aspose.slides.theme.IThemeEffectiveData:
        ...

    @property
    def plot_visible_cells_only(self) -> bool:
        ...

    @plot_visible_cells_only.setter
    def plot_visible_cells_only(self, value: bool):
        ...

    @property
    def display_blanks_as(self) -> DisplayBlanksAsType:
        ...

    @display_blanks_as.setter
    def display_blanks_as(self, value: DisplayBlanksAsType):
        ...

    @property
    def chart_data(self) -> IChartData:
        ...

    @property
    def has_title(self) -> bool:
        ...

    @has_title.setter
    def has_title(self, value: bool):
        ...

    @property
    def chart_title(self) -> IChartTitle:
        ...

    @property
    def has_data_table(self) -> bool:
        ...

    @has_data_table.setter
    def has_data_table(self, value: bool):
        ...

    @property
    def has_legend(self) -> bool:
        ...

    @has_legend.setter
    def has_legend(self, value: bool):
        ...

    @property
    def legend(self) -> ILegend:
        ...

    @property
    def chart_data_table(self) -> IDataTable:
        ...

    @property
    def style(self) -> StyleType:
        ...

    @style.setter
    def style(self, value: StyleType):
        ...

    @property
    def type(self) -> ChartType:
        ...

    @type.setter
    def type(self, value: ChartType):
        ...

    @property
    def plot_area(self) -> IChartPlotArea:
        ...

    @property
    def rotation_3d(self) -> IRotation3D:
        ...

    @property
    def back_wall(self) -> IChartWall:
        ...

    @property
    def side_wall(self) -> IChartWall:
        ...

    @property
    def floor(self) -> IChartWall:
        ...

    @property
    def user_shapes(self) -> IGroupShape:
        ...

    @property
    def axes(self) -> IAxesManager:
        ...

    @property
    def show_data_labels_over_maximum(self) -> bool:
        ...

    @show_data_labels_over_maximum.setter
    def show_data_labels_over_maximum(self, value: bool):
        ...

    @property
    def has_rounded_corners(self) -> bool:
        ...

    @has_rounded_corners.setter
    def has_rounded_corners(self, value: bool):
        ...

    @property
    def as_i_graphical_object(self) -> IGraphicalObject:
        ...

    @property
    def as_i_formatted_text_container(self) -> IFormattedTextContainer:
        ...

    @property
    def as_i_override_themeable(self) -> aspose.slides.theme.IOverrideThemeable:
        ...

    @property
    def shape_lock(self) -> IGraphicalObjectLock:
        ...

    @property
    def graphical_object_lock(self) -> IGraphicalObjectLock:
        ...

    @property
    def as_i_shape(self) -> IShape:
        ...

    @property
    def is_text_holder(self) -> bool:
        ...

    @property
    def placeholder(self) -> IPlaceholder:
        ...

    @property
    def custom_data(self) -> ICustomData:
        ...

    @property
    def raw_frame(self) -> IShapeFrame:
        ...

    @raw_frame.setter
    def raw_frame(self, value: IShapeFrame):
        ...

    @property
    def frame(self) -> IShapeFrame:
        ...

    @frame.setter
    def frame(self, value: IShapeFrame):
        ...

    @property
    def line_format(self) -> ILineFormat:
        ...

    @property
    def three_d_format(self) -> IThreeDFormat:
        ...

    @property
    def effect_format(self) -> IEffectFormat:
        ...

    @property
    def fill_format(self) -> IFillFormat:
        ...

    @property
    def hidden(self) -> bool:
        ...

    @hidden.setter
    def hidden(self, value: bool):
        ...

    @property
    def z_order_position(self) -> int:
        ...

    @property
    def connection_site_count(self) -> int:
        ...

    @property
    def rotation(self) -> float:
        ...

    @rotation.setter
    def rotation(self, value: float):
        ...

    @property
    def x(self) -> float:
        ...

    @x.setter
    def x(self, value: float):
        ...

    @property
    def y(self) -> float:
        ...

    @y.setter
    def y(self, value: float):
        ...

    @property
    def width(self) -> float:
        ...

    @width.setter
    def width(self, value: float):
        ...

    @property
    def height(self) -> float:
        ...

    @height.setter
    def height(self, value: float):
        ...

    @property
    def alternative_text(self) -> string:
        ...

    @alternative_text.setter
    def alternative_text(self, value: string):
        ...

    @property
    def alternative_text_title(self) -> string:
        ...

    @alternative_text_title.setter
    def alternative_text_title(self, value: string):
        ...

    @property
    def name(self) -> string:
        ...

    @name.setter
    def name(self, value: string):
        ...

    @property
    def is_decorative(self) -> bool:
        ...

    @is_decorative.setter
    def is_decorative(self, value: bool):
        ...

    @property
    def unique_id(self) -> int:
        ...

    @property
    def office_interop_shape_id(self) -> int:
        ...

    @property
    def is_grouped(self) -> bool:
        ...

    @property
    def black_white_mode(self) -> BlackWhiteMode:
        ...

    @black_white_mode.setter
    def black_white_mode(self, value: BlackWhiteMode):
        ...

    @property
    def parent_group(self) -> IGroupShape:
        ...

    @property
    def as_i_hyperlink_container(self) -> IHyperlinkContainer:
        ...

    @property
    def slide(self) -> IBaseSlide:
        ...

    @property
    def as_i_presentation_component(self) -> IPresentationComponent:
        ...

    @property
    def presentation(self) -> IPresentation:
        ...

    @property
    def hyperlink_click(self) -> IHyperlink:
        ...

    @hyperlink_click.setter
    def hyperlink_click(self, value: IHyperlink):
        ...

    @property
    def hyperlink_mouse_over(self) -> IHyperlink:
        ...

    @hyperlink_mouse_over.setter
    def hyperlink_mouse_over(self, value: IHyperlink):
        ...

    @property
    def hyperlink_manager(self) -> IHyperlinkManager:
        ...

    @property
    def text_format(self) -> IChartTextFormat:
        ...

    @property
    def as_i_chart_component(self) -> IChartComponent:
        ...

    @property
    def chart(self) -> IChart:
        ...

    @property
    def theme_manager(self) -> aspose.slides.theme.IOverrideThemeManager:
        ...

    @property
    def as_i_themeable(self) -> aspose.slides.theme.IThemeable:
        ...

    ...

class IChartCategory:
    def remove(self) -> None:
        ...

    @property
    def use_cell(self) -> bool:
        ...

    @property
    def as_cell(self) -> IChartDataCell:
        ...

    @as_cell.setter
    def as_cell(self, value: IChartDataCell):
        ...

    @property
    def as_literal(self) -> any:
        ...

    @as_literal.setter
    def as_literal(self, value: any):
        ...

    @property
    def value(self) -> any:
        ...

    @value.setter
    def value(self, value: any):
        ...

    @property
    def grouping_levels(self) -> IChartCategoryLevelsManager:
        ...

    ...

class IChartCategoryCollection:
    @overload
    def add(self, chart_data_cell: IChartDataCell) -> IChartCategory:
        ...

    @overload
    def add(self, value: any) -> IChartCategory:
        ...

    def index_of(self, value: IChartCategory) -> int:
        ...

    def remove(self, value: IChartCategory) -> None:
        ...

    def remove_at(self, index: int) -> None:
        ...

    def clear(self) -> None:
        ...

    @property
    def use_cells(self) -> bool:
        ...

    @use_cells.setter
    def use_cells(self, value: bool):
        ...

    @property
    def grouping_level_count(self) -> int:
        ...

    @property
    def as_i_collection(self) -> list:
        ...

    @property
    def as_i_enumerable(self) -> collections.abc.Iterable:
        ...

    def __getitem__(self, key: int) -> IChartCategory
        ...

    ...

class IChartCategoryLevelsManager:
    def set_grouping_item(self, level: int, value: any) -> None:
        ...

    def delete_grouping_item(self, level: int) -> None:
        ...

    def __getitem__(self, key: int) -> IChartDataCell
        ...

    ...

class IChartCellCollection:
    @overload
    def add(self, chart_data_cell: IChartDataCell) -> None:
        ...

    @overload
    def add(self, value: any) -> None:
        ...

    def get_cells_address(self) -> string:
        ...

    def get_concatenated_values_from_cells(self) -> string:
        ...

    def remove_at(self, index: int) -> None:
        ...

    @property
    def count(self) -> int:
        ...

    @property
    def as_i_enumerable(self) -> collections.abc.Iterable:
        ...

    def __getitem__(self, key: int) -> IChartDataCell
        ...

    ...

class IChartComponent:
    @property
    def chart(self) -> IChart:
        ...

    @property
    def as_i_slide_component(self) -> ISlideComponent:
        ...

    @property
    def slide(self) -> IBaseSlide:
        ...

    @property
    def as_i_presentation_component(self) -> IPresentationComponent:
        ...

    @property
    def presentation(self) -> IPresentation:
        ...

    ...

class IChartData:
    @overload
    def set_external_workbook(self, workbook_path: string) -> None:
        ...

    @overload
    def set_external_workbook(self, workbook_path: string, update_chart_data: bool) -> None:
        ...

    def set_range(self, formula: string) -> None:
        ...

    def get_range(self) -> string:
        ...

    def switch_row_column(self) -> None:
        ...

    @property
    def chart_data_workbook(self) -> IChartDataWorkbook:
        ...

    @property
    def series(self) -> IChartSeriesCollection:
        ...

    @property
    def series_groups(self) -> IChartSeriesGroupCollection:
        ...

    @property
    def categories(self) -> IChartCategoryCollection:
        ...

    @property
    def use_secondary_categories(self) -> bool:
        ...

    @use_secondary_categories.setter
    def use_secondary_categories(self, value: bool):
        ...

    @property
    def secondary_categories(self) -> IChartCategoryCollection:
        ...

    @property
    def data_source_type(self) -> ChartDataSourceType:
        ...

    @property
    def external_workbook_path(self) -> string:
        ...

    ...

class IChartDataCell:
    def calculate(self, update_values: bool) -> None:
        ...

    @property
    def row(self) -> int:
        ...

    @property
    def column(self) -> int:
        ...

    @property
    def value(self) -> any:
        ...

    @value.setter
    def value(self, value: any):
        ...

    @property
    def formula(self) -> string:
        ...

    @formula.setter
    def formula(self, value: string):
        ...

    @property
    def r1c1_formula(self) -> string:
        ...

    @r1c1_formula.setter
    def r1c1_formula(self, value: string):
        ...

    @property
    def chart_data_worksheet(self) -> IChartDataWorksheet:
        ...

    @property
    def is_hidden(self) -> bool:
        ...

    @property
    def custom_number_format(self) -> string:
        ...

    @custom_number_format.setter
    def custom_number_format(self, value: string):
        ...

    @property
    def preset_number_format(self) -> int:
        ...

    @preset_number_format.setter
    def preset_number_format(self, value: int):
        ...

    ...

class IChartDataPoint:
    def remove(self) -> None:
        ...

    def get_automatic_data_point_color(self) -> aspose.pydrawing.Color:
        ...

    @property
    def x_value(self) -> IStringOrDoubleChartValue:
        ...

    @property
    def y_value(self) -> IDoubleChartValue:
        ...

    @property
    def bubble_size(self) -> IDoubleChartValue:
        ...

    @property
    def value(self) -> IDoubleChartValue:
        ...

    @property
    def size_value(self) -> IDoubleChartValue:
        ...

    @property
    def color_value(self) -> IDoubleChartValue:
        ...

    @property
    def error_bars_custom_values(self) -> IErrorBarsCustomValues:
        ...

    @property
    def label(self) -> IDataLabel:
        ...

    @property
    def is_bubble_3d(self) -> bool:
        ...

    @is_bubble_3d.setter
    def is_bubble_3d(self, value: bool):
        ...

    @property
    def explosion(self) -> int:
        ...

    @explosion.setter
    def explosion(self, value: int):
        ...

    @property
    def format(self) -> IFormat:
        ...

    @format.setter
    def format(self, value: IFormat):
        ...

    @property
    def marker(self) -> IMarker:
        ...

    @property
    def related_legend_entry(self) -> ILegendEntryProperties:
        ...

    @property
    def set_as_total(self) -> bool:
        ...

    @set_as_total.setter
    def set_as_total(self, value: bool):
        ...

    @property
    def invert_if_negative(self) -> bool:
        ...

    @invert_if_negative.setter
    def invert_if_negative(self, value: bool):
        ...

    @property
    def data_point_levels(self) -> IChartDataPointLevelsManager:
        ...

    @property
    def index(self) -> int:
        ...

    @property
    def as_i_actual_layout(self) -> IActualLayout:
        ...

    @property
    def actual_x(self) -> float:
        ...

    @property
    def actual_y(self) -> float:
        ...

    @property
    def actual_width(self) -> float:
        ...

    @property
    def actual_height(self) -> float:
        ...

    ...

class IChartDataPointCollection:
    @overload
    def add_data_point_for_stock_series(self, value: IChartDataCell) -> IChartDataPoint:
        ...

    @overload
    def add_data_point_for_stock_series(self, value: float) -> IChartDataPoint:
        ...

    @overload
    def add_data_point_for_line_series(self, value: IChartDataCell) -> IChartDataPoint:
        ...

    @overload
    def add_data_point_for_line_series(self, value: float) -> IChartDataPoint:
        ...

    @overload
    def add_data_point_for_scatter_series(self, x_value: IChartDataCell, y_value: IChartDataCell) -> IChartDataPoint:
        ...

    @overload
    def add_data_point_for_scatter_series(self, x_value: float, y_value: IChartDataCell) -> IChartDataPoint:
        ...

    @overload
    def add_data_point_for_scatter_series(self, x_value: string, y_value: IChartDataCell) -> IChartDataPoint:
        ...

    @overload
    def add_data_point_for_scatter_series(self, x_value: IChartDataCell, y_value: float) -> IChartDataPoint:
        ...

    @overload
    def add_data_point_for_scatter_series(self, x_value: float, y_value: float) -> IChartDataPoint:
        ...

    @overload
    def add_data_point_for_scatter_series(self, x_value: string, y_value: float) -> IChartDataPoint:
        ...

    @overload
    def add_data_point_for_radar_series(self, value: IChartDataCell) -> IChartDataPoint:
        ...

    @overload
    def add_data_point_for_radar_series(self, value: float) -> IChartDataPoint:
        ...

    @overload
    def add_data_point_for_bar_series(self, value: IChartDataCell) -> IChartDataPoint:
        ...

    @overload
    def add_data_point_for_bar_series(self, value: float) -> IChartDataPoint:
        ...

    @overload
    def add_data_point_for_area_series(self, value: IChartDataCell) -> IChartDataPoint:
        ...

    @overload
    def add_data_point_for_area_series(self, value: float) -> IChartDataPoint:
        ...

    @overload
    def add_data_point_for_pie_series(self, value: IChartDataCell) -> IChartDataPoint:
        ...

    @overload
    def add_data_point_for_pie_series(self, value: float) -> IChartDataPoint:
        ...

    @overload
    def add_data_point_for_doughnut_series(self, value: IChartDataCell) -> IChartDataPoint:
        ...

    @overload
    def add_data_point_for_doughnut_series(self, value: float) -> IChartDataPoint:
        ...

    @overload
    def add_data_point_for_bubble_series(self, x_value: IChartDataCell, y_value: IChartDataCell, bubble_size: IChartDataCell) -> IChartDataPoint:
        ...

    @overload
    def add_data_point_for_bubble_series(self, x_value: float, y_value: IChartDataCell, bubble_size: IChartDataCell) -> IChartDataPoint:
        ...

    @overload
    def add_data_point_for_bubble_series(self, x_value: string, y_value: IChartDataCell, bubble_size: IChartDataCell) -> IChartDataPoint:
        ...

    @overload
    def add_data_point_for_bubble_series(self, x_value: IChartDataCell, y_value: float, bubble_size: IChartDataCell) -> IChartDataPoint:
        ...

    @overload
    def add_data_point_for_bubble_series(self, x_value: float, y_value: float, bubble_size: IChartDataCell) -> IChartDataPoint:
        ...

    @overload
    def add_data_point_for_bubble_series(self, x_value: string, y_value: float, bubble_size: IChartDataCell) -> IChartDataPoint:
        ...

    @overload
    def add_data_point_for_bubble_series(self, x_value: IChartDataCell, y_value: IChartDataCell, bubble_size: float) -> IChartDataPoint:
        ...

    @overload
    def add_data_point_for_bubble_series(self, x_value: float, y_value: IChartDataCell, bubble_size: float) -> IChartDataPoint:
        ...

    @overload
    def add_data_point_for_bubble_series(self, x_value: string, y_value: IChartDataCell, bubble_size: float) -> IChartDataPoint:
        ...

    @overload
    def add_data_point_for_bubble_series(self, x_value: IChartDataCell, y_value: float, bubble_size: float) -> IChartDataPoint:
        ...

    @overload
    def add_data_point_for_bubble_series(self, x_value: float, y_value: float, bubble_size: float) -> IChartDataPoint:
        ...

    @overload
    def add_data_point_for_bubble_series(self, x_value: string, y_value: float, bubble_size: float) -> IChartDataPoint:
        ...

    @overload
    def add_data_point_for_surface_series(self, value: IChartDataCell) -> IChartDataPoint:
        ...

    @overload
    def add_data_point_for_surface_series(self, value: float) -> IChartDataPoint:
        ...

    def get_or_create_data_point_by_idx(self, index: int) -> IChartDataPoint:
        ...

    def add_data_point_for_sunburst_series(self, size_value: IChartDataCell) -> IChartDataPoint:
        ...

    def add_data_point_for_waterfall_series(self, value: IChartDataCell) -> IChartDataPoint:
        ...

    def add_data_point_for_box_and_whisker_series(self, value: IChartDataCell) -> IChartDataPoint:
        ...

    def add_data_point_for_treemap_series(self, size_value: IChartDataCell) -> IChartDataPoint:
        ...

    def add_data_point_for_histogram_series(self, value: IChartDataCell) -> IChartDataPoint:
        ...

    def add_data_point_for_funnel_series(self, value: IChartDataCell) -> IChartDataPoint:
        ...

    def add_data_point_for_map_series(self, value: IChartDataCell) -> IChartDataPoint:
        ...

    def clear(self) -> None:
        ...

    def remove(self, value: IChartDataPoint) -> None:
        ...

    def remove_at(self, index: int) -> None:
        ...

    @property
    def data_source_type_for_x_values(self) -> DataSourceType:
        ...

    @data_source_type_for_x_values.setter
    def data_source_type_for_x_values(self, value: DataSourceType):
        ...

    @property
    def data_source_type_for_y_values(self) -> DataSourceType:
        ...

    @data_source_type_for_y_values.setter
    def data_source_type_for_y_values(self, value: DataSourceType):
        ...

    @property
    def data_source_type_for_bubble_sizes(self) -> DataSourceType:
        ...

    @data_source_type_for_bubble_sizes.setter
    def data_source_type_for_bubble_sizes(self, value: DataSourceType):
        ...

    @property
    def data_source_type_for_values(self) -> DataSourceType:
        ...

    @data_source_type_for_values.setter
    def data_source_type_for_values(self, value: DataSourceType):
        ...

    @property
    def data_source_type_for_error_bars_custom_values(self) -> IDataSourceTypeForErrorBarsCustomValues:
        ...

    @property
    def as_i_collection(self) -> list:
        ...

    @property
    def as_i_enumerable(self) -> collections.abc.Iterable:
        ...

    def __getitem__(self, key: int) -> IChartDataPoint
        ...

    ...

class IChartDataPointLevel:
    @property
    def format(self) -> IFormat:
        ...

    @property
    def label(self) -> IDataLabel:
        ...

    ...

class IChartDataPointLevelsManager:
    @property
    def count(self) -> int:
        ...

    def __getitem__(self, key: int) -> IChartDataPointLevel
        ...

    ...

class IChartDataWorkbook:
    @overload
    def get_cell(self, worksheet_name: string, row: int, column: int) -> IChartDataCell:
        ...

    @overload
    def get_cell(self, worksheet_index: int, row: int, column: int) -> IChartDataCell:
        ...

    @overload
    def get_cell(self, worksheet_index: int, cell_name: string) -> IChartDataCell:
        ...

    @overload
    def get_cell(self, worksheet_index: int, cell_name: string, value: any) -> IChartDataCell:
        ...

    @overload
    def get_cell(self, worksheet_index: int, row: int, column: int, value: any) -> IChartDataCell:
        ...

    def calculate_formulas(self) -> None:
        ...

    def get_cell_collection(self, formula: string, skip_hidden_cells: bool) -> IChartCellCollection:
        ...

    def clear(self, sheet_index: int) -> None:
        ...

    @property
    def worksheets(self) -> IChartDataWorksheetCollection:
        ...

    ...

class IChartDataWorksheet:
    @property
    def name(self) -> string:
        ...

    @property
    def index(self) -> int:
        ...

    ...

class IChartDataWorksheetCollection:
    @property
    def as_i_collection(self) -> list:
        ...

    @property
    def as_i_enumerable(self) -> collections.abc.Iterable:
        ...

    def __getitem__(self, key: int) -> IChartDataWorksheet
        ...

    ...

class IChartLinesFormat:
    @property
    def line(self) -> ILineFormat:
        ...

    @property
    def effect(self) -> IEffectFormat:
        ...

    ...

class IChartParagraphFormat:
    @property
    def alignment(self) -> TextAlignment:
        ...

    @alignment.setter
    def alignment(self, value: TextAlignment):
        ...

    @property
    def space_within(self) -> float:
        ...

    @space_within.setter
    def space_within(self, value: float):
        ...

    @property
    def space_before(self) -> float:
        ...

    @space_before.setter
    def space_before(self, value: float):
        ...

    @property
    def space_after(self) -> float:
        ...

    @space_after.setter
    def space_after(self, value: float):
        ...

    @property
    def east_asian_line_break(self) -> NullableBool:
        ...

    @east_asian_line_break.setter
    def east_asian_line_break(self, value: NullableBool):
        ...

    @property
    def right_to_left(self) -> NullableBool:
        ...

    @right_to_left.setter
    def right_to_left(self, value: NullableBool):
        ...

    @property
    def latin_line_break(self) -> NullableBool:
        ...

    @latin_line_break.setter
    def latin_line_break(self, value: NullableBool):
        ...

    @property
    def hanging_punctuation(self) -> NullableBool:
        ...

    @hanging_punctuation.setter
    def hanging_punctuation(self, value: NullableBool):
        ...

    @property
    def margin_left(self) -> float:
        ...

    @margin_left.setter
    def margin_left(self, value: float):
        ...

    @property
    def margin_right(self) -> float:
        ...

    @margin_right.setter
    def margin_right(self, value: float):
        ...

    @property
    def indent(self) -> float:
        ...

    @indent.setter
    def indent(self, value: float):
        ...

    @property
    def default_tab_size(self) -> float:
        ...

    @default_tab_size.setter
    def default_tab_size(self, value: float):
        ...

    @property
    def tabs(self) -> ITabCollection:
        ...

    @property
    def font_alignment(self) -> FontAlignment:
        ...

    @font_alignment.setter
    def font_alignment(self, value: FontAlignment):
        ...

    ...

class IChartPlotArea:
    @property
    def format(self) -> IFormat:
        ...

    @property
    def as_i_layoutable(self) -> ILayoutable:
        ...

    @property
    def as_i_actual_layout(self) -> IActualLayout:
        ...

    @property
    def layout_target_type(self) -> LayoutTargetType:
        ...

    @layout_target_type.setter
    def layout_target_type(self, value: LayoutTargetType):
        ...

    @property
    def x(self) -> float:
        ...

    @x.setter
    def x(self, value: float):
        ...

    @property
    def y(self) -> float:
        ...

    @y.setter
    def y(self, value: float):
        ...

    @property
    def width(self) -> float:
        ...

    @width.setter
    def width(self, value: float):
        ...

    @property
    def height(self) -> float:
        ...

    @height.setter
    def height(self, value: float):
        ...

    @property
    def right(self) -> float:
        ...

    @property
    def bottom(self) -> float:
        ...

    @property
    def as_i_chart_component(self) -> IChartComponent:
        ...

    @property
    def chart(self) -> IChart:
        ...

    @property
    def as_i_slide_component(self) -> ISlideComponent:
        ...

    @property
    def slide(self) -> IBaseSlide:
        ...

    @property
    def as_i_presentation_component(self) -> IPresentationComponent:
        ...

    @property
    def presentation(self) -> IPresentation:
        ...

    @property
    def actual_x(self) -> float:
        ...

    @property
    def actual_y(self) -> float:
        ...

    @property
    def actual_width(self) -> float:
        ...

    @property
    def actual_height(self) -> float:
        ...

    ...

class IChartPortionFormat:
    @property
    def as_i_base_portion_format(self) -> IBasePortionFormat:
        ...

    @property
    def line_format(self) -> ILineFormat:
        ...

    @property
    def fill_format(self) -> IFillFormat:
        ...

    @property
    def effect_format(self) -> IEffectFormat:
        ...

    @property
    def highlight_color(self) -> IColorFormat:
        ...

    @property
    def underline_line_format(self) -> ILineFormat:
        ...

    @property
    def underline_fill_format(self) -> IFillFormat:
        ...

    @property
    def font_bold(self) -> NullableBool:
        ...

    @font_bold.setter
    def font_bold(self, value: NullableBool):
        ...

    @property
    def font_italic(self) -> NullableBool:
        ...

    @font_italic.setter
    def font_italic(self, value: NullableBool):
        ...

    @property
    def kumimoji(self) -> NullableBool:
        ...

    @kumimoji.setter
    def kumimoji(self, value: NullableBool):
        ...

    @property
    def normalise_height(self) -> NullableBool:
        ...

    @normalise_height.setter
    def normalise_height(self, value: NullableBool):
        ...

    @property
    def proof_disabled(self) -> NullableBool:
        ...

    @proof_disabled.setter
    def proof_disabled(self, value: NullableBool):
        ...

    @property
    def font_underline(self) -> TextUnderlineType:
        ...

    @font_underline.setter
    def font_underline(self, value: TextUnderlineType):
        ...

    @property
    def text_cap_type(self) -> TextCapType:
        ...

    @text_cap_type.setter
    def text_cap_type(self, value: TextCapType):
        ...

    @property
    def strikethrough_type(self) -> TextStrikethroughType:
        ...

    @strikethrough_type.setter
    def strikethrough_type(self, value: TextStrikethroughType):
        ...

    @property
    def is_hard_underline_line(self) -> NullableBool:
        ...

    @is_hard_underline_line.setter
    def is_hard_underline_line(self, value: NullableBool):
        ...

    @property
    def is_hard_underline_fill(self) -> NullableBool:
        ...

    @is_hard_underline_fill.setter
    def is_hard_underline_fill(self, value: NullableBool):
        ...

    @property
    def font_height(self) -> float:
        ...

    @font_height.setter
    def font_height(self, value: float):
        ...

    @property
    def latin_font(self) -> IFontData:
        ...

    @latin_font.setter
    def latin_font(self, value: IFontData):
        ...

    @property
    def east_asian_font(self) -> IFontData:
        ...

    @east_asian_font.setter
    def east_asian_font(self, value: IFontData):
        ...

    @property
    def complex_script_font(self) -> IFontData:
        ...

    @complex_script_font.setter
    def complex_script_font(self, value: IFontData):
        ...

    @property
    def symbol_font(self) -> IFontData:
        ...

    @symbol_font.setter
    def symbol_font(self, value: IFontData):
        ...

    @property
    def escapement(self) -> float:
        ...

    @escapement.setter
    def escapement(self, value: float):
        ...

    @property
    def kerning_minimal_size(self) -> float:
        ...

    @kerning_minimal_size.setter
    def kerning_minimal_size(self, value: float):
        ...

    @property
    def language_id(self) -> string:
        ...

    @language_id.setter
    def language_id(self, value: string):
        ...

    @property
    def alternative_language_id(self) -> string:
        ...

    @alternative_language_id.setter
    def alternative_language_id(self, value: string):
        ...

    @property
    def spacing(self) -> float:
        ...

    @spacing.setter
    def spacing(self, value: float):
        ...

    ...

class IChartSeries:
    def get_automatic_series_color(self) -> aspose.pydrawing.Color:
        ...

    @property
    def explosion(self) -> int:
        ...

    @explosion.setter
    def explosion(self, value: int):
        ...

    @property
    def smooth(self) -> bool:
        ...

    @smooth.setter
    def smooth(self, value: bool):
        ...

    @property
    def marker(self) -> IMarker:
        ...

    @property
    def bar_3d_shape(self) -> ChartShapeType:
        ...

    @bar_3d_shape.setter
    def bar_3d_shape(self, value: ChartShapeType):
        ...

    @property
    def name(self) -> IStringChartValue:
        ...

    @property
    def data_points(self) -> IChartDataPointCollection:
        ...

    @property
    def type(self) -> ChartType:
        ...

    @type.setter
    def type(self, value: ChartType):
        ...

    @property
    def parent_series_group(self) -> IChartSeriesGroup:
        ...

    @property
    def format(self) -> IFormat:
        ...

    @property
    def order(self) -> int:
        ...

    @order.setter
    def order(self, value: int):
        ...

    @property
    def labels(self) -> IDataLabelCollection:
        ...

    @property
    def trend_lines(self) -> ITrendlineCollection:
        ...

    @property
    def error_bars_x_format(self) -> IErrorBarsFormat:
        ...

    @property
    def error_bars_y_format(self) -> IErrorBarsFormat:
        ...

    @property
    def plot_on_second_axis(self) -> bool:
        ...

    @plot_on_second_axis.setter
    def plot_on_second_axis(self, value: bool):
        ...

    @property
    def number_format_of_values(self) -> string:
        ...

    @number_format_of_values.setter
    def number_format_of_values(self, value: string):
        ...

    @property
    def number_format_of_x_values(self) -> string:
        ...

    @number_format_of_x_values.setter
    def number_format_of_x_values(self, value: string):
        ...

    @property
    def number_format_of_y_values(self) -> string:
        ...

    @number_format_of_y_values.setter
    def number_format_of_y_values(self, value: string):
        ...

    @property
    def number_format_of_bubble_sizes(self) -> string:
        ...

    @number_format_of_bubble_sizes.setter
    def number_format_of_bubble_sizes(self, value: string):
        ...

    @property
    def invert_if_negative(self) -> bool:
        ...

    @invert_if_negative.setter
    def invert_if_negative(self, value: bool):
        ...

    @property
    def inverted_solid_fill_color(self) -> IColorFormat:
        ...

    @property
    def related_legend_entry(self) -> ILegendEntryProperties:
        ...

    @property
    def show_inner_points(self) -> bool:
        ...

    @show_inner_points.setter
    def show_inner_points(self, value: bool):
        ...

    @property
    def show_outlier_points(self) -> bool:
        ...

    @show_outlier_points.setter
    def show_outlier_points(self, value: bool):
        ...

    @property
    def show_mean_markers(self) -> bool:
        ...

    @show_mean_markers.setter
    def show_mean_markers(self, value: bool):
        ...

    @property
    def show_mean_line(self) -> bool:
        ...

    @show_mean_line.setter
    def show_mean_line(self, value: bool):
        ...

    @property
    def quartile_method(self) -> QuartileMethodType:
        ...

    @quartile_method.setter
    def quartile_method(self, value: QuartileMethodType):
        ...

    @property
    def show_connector_lines(self) -> bool:
        ...

    @show_connector_lines.setter
    def show_connector_lines(self, value: bool):
        ...

    @property
    def parent_label_layout(self) -> ParentLabelLayoutType:
        ...

    @parent_label_layout.setter
    def parent_label_layout(self, value: ParentLabelLayoutType):
        ...

    @property
    def bubble_size_scale(self) -> int:
        ...

    @property
    def has_up_down_bars(self) -> bool:
        ...

    @property
    def gap_width(self) -> int:
        ...

    @property
    def gap_depth(self) -> int:
        ...

    @property
    def is_color_varied(self) -> bool:
        ...

    @property
    def has_series_lines(self) -> bool:
        ...

    @property
    def overlap(self) -> int:
        ...

    @property
    def second_pie_size(self) -> int:
        ...

    @property
    def pie_split_position(self) -> float:
        ...

    @property
    def pie_split_by(self) -> PieSplitType:
        ...

    @property
    def doughnut_hole_size(self) -> int:
        ...

    @property
    def first_slice_angle(self) -> int:
        ...

    @property
    def pie_split_custom_points(self) -> IPieSplitCustomPointCollection:
        ...

    @property
    def bubble_size_representation(self) -> BubbleSizeRepresentationType:
        ...

    @property
    def as_i_chart_component(self) -> IChartComponent:
        ...

    @property
    def chart(self) -> IChart:
        ...

    @property
    def as_i_slide_component(self) -> ISlideComponent:
        ...

    @property
    def slide(self) -> IBaseSlide:
        ...

    @property
    def as_i_presentation_component(self) -> IPresentationComponent:
        ...

    @property
    def presentation(self) -> IPresentation:
        ...

    ...

class IChartSeriesCollection:
    @overload
    def add(self, type: ChartType) -> IChartSeries:
        ...

    @overload
    def add(self, cell_with_series_name: IChartDataCell, type: ChartType) -> IChartSeries:
        ...

    @overload
    def add(self, cells_with_series_name: IChartCellCollection, type: ChartType) -> IChartSeries:
        ...

    @overload
    def add(self, name: string, type: ChartType) -> IChartSeries:
        ...

    def insert(self, index: int, type: ChartType) -> IChartSeries:
        ...

    def index_of(self, value: IChartSeries) -> int:
        ...

    def remove(self, value: IChartSeries) -> None:
        ...

    def remove_at(self, index: int) -> None:
        ...

    def clear(self) -> None:
        ...

    @property
    def as_i_collection(self) -> list:
        ...

    @property
    def as_i_enumerable(self) -> collections.abc.Iterable:
        ...

    def __getitem__(self, key: int) -> IChartSeries
        ...

    ...

class IChartSeriesGroup:
    @property
    def type(self) -> CombinableSeriesTypesGroup:
        ...

    @property
    def plot_on_second_axis(self) -> bool:
        ...

    @property
    def series(self) -> IChartSeriesReadonlyCollection:
        ...

    @property
    def up_down_bars(self) -> IUpDownBarsManager:
        ...

    @property
    def gap_width(self) -> int:
        ...

    @gap_width.setter
    def gap_width(self, value: int):
        ...

    @property
    def gap_depth(self) -> int:
        ...

    @gap_depth.setter
    def gap_depth(self, value: int):
        ...

    @property
    def first_slice_angle(self) -> int:
        ...

    @first_slice_angle.setter
    def first_slice_angle(self, value: int):
        ...

    @property
    def is_color_varied(self) -> bool:
        ...

    @is_color_varied.setter
    def is_color_varied(self, value: bool):
        ...

    @property
    def has_series_lines(self) -> bool:
        ...

    @has_series_lines.setter
    def has_series_lines(self, value: bool):
        ...

    @property
    def overlap(self) -> int:
        ...

    @overlap.setter
    def overlap(self, value: int):
        ...

    @property
    def second_pie_size(self) -> int:
        ...

    @second_pie_size.setter
    def second_pie_size(self, value: int):
        ...

    @property
    def pie_split_position(self) -> float:
        ...

    @pie_split_position.setter
    def pie_split_position(self, value: float):
        ...

    @property
    def pie_split_by(self) -> PieSplitType:
        ...

    @pie_split_by.setter
    def pie_split_by(self, value: PieSplitType):
        ...

    @property
    def pie_split_custom_points(self) -> IPieSplitCustomPointCollection:
        ...

    @property
    def doughnut_hole_size(self) -> int:
        ...

    @doughnut_hole_size.setter
    def doughnut_hole_size(self, value: int):
        ...

    @property
    def bubble_size_scale(self) -> int:
        ...

    @bubble_size_scale.setter
    def bubble_size_scale(self, value: int):
        ...

    @property
    def hi_low_lines_format(self) -> IChartLinesFormat:
        ...

    @property
    def bubble_size_representation(self) -> BubbleSizeRepresentationType:
        ...

    @bubble_size_representation.setter
    def bubble_size_representation(self, value: BubbleSizeRepresentationType):
        ...

    @property
    def as_i_chart_component(self) -> IChartComponent:
        ...

    @property
    def chart(self) -> IChart:
        ...

    @property
    def as_i_slide_component(self) -> ISlideComponent:
        ...

    @property
    def slide(self) -> IBaseSlide:
        ...

    @property
    def as_i_presentation_component(self) -> IPresentationComponent:
        ...

    @property
    def presentation(self) -> IPresentation:
        ...

    def __getitem__(self, key: int) -> IChartSeries
        ...

    ...

class IChartSeriesGroupCollection:
    @property
    def as_i_collection(self) -> list:
        ...

    @property
    def as_i_enumerable(self) -> collections.abc.Iterable:
        ...

    def __getitem__(self, key: int) -> IChartSeriesGroup
        ...

    ...

class IChartSeriesReadonlyCollection:
    @property
    def as_i_collection(self) -> list:
        ...

    @property
    def as_i_enumerable(self) -> collections.abc.Iterable:
        ...

    def __getitem__(self, key: int) -> IChartSeries
        ...

    ...

class IChartTextBlockFormat:
    @property
    def anchoring_type(self) -> TextAnchorType:
        ...

    @anchoring_type.setter
    def anchoring_type(self, value: TextAnchorType):
        ...

    @property
    def center_text(self) -> NullableBool:
        ...

    @center_text.setter
    def center_text(self, value: NullableBool):
        ...

    @property
    def text_vertical_type(self) -> TextVerticalType:
        ...

    @text_vertical_type.setter
    def text_vertical_type(self, value: TextVerticalType):
        ...

    @property
    def margin_left(self) -> float:
        ...

    @margin_left.setter
    def margin_left(self, value: float):
        ...

    @property
    def margin_right(self) -> float:
        ...

    @margin_right.setter
    def margin_right(self, value: float):
        ...

    @property
    def margin_top(self) -> float:
        ...

    @margin_top.setter
    def margin_top(self, value: float):
        ...

    @property
    def margin_bottom(self) -> float:
        ...

    @margin_bottom.setter
    def margin_bottom(self, value: float):
        ...

    @property
    def wrap_text(self) -> NullableBool:
        ...

    @wrap_text.setter
    def wrap_text(self, value: NullableBool):
        ...

    @property
    def autofit_type(self) -> TextAutofitType:
        ...

    @autofit_type.setter
    def autofit_type(self, value: TextAutofitType):
        ...

    @property
    def rotation_angle(self) -> float:
        ...

    @rotation_angle.setter
    def rotation_angle(self, value: float):
        ...

    ...

class IChartTextFormat:
    def copy_to(self, dest_text_frame: ITextFrame) -> None:
        ...

    def copy_from(self, source_text_frame: ITextFrame) -> None:
        ...

    @property
    def text_block_format(self) -> IChartTextBlockFormat:
        ...

    @property
    def paragraph_format(self) -> IChartParagraphFormat:
        ...

    @property
    def portion_format(self) -> IChartPortionFormat:
        ...

    ...

class IChartTitle:
    def add_text_frame_for_overriding(self, text: string) -> ITextFrame:
        ...

    @property
    def overlay(self) -> bool:
        ...

    @overlay.setter
    def overlay(self, value: bool):
        ...

    @property
    def format(self) -> IFormat:
        ...

    @property
    def as_i_layoutable(self) -> ILayoutable:
        ...

    @property
    def as_i_overridable_text(self) -> IOverridableText:
        ...

    @property
    def x(self) -> float:
        ...

    @x.setter
    def x(self, value: float):
        ...

    @property
    def y(self) -> float:
        ...

    @y.setter
    def y(self, value: float):
        ...

    @property
    def width(self) -> float:
        ...

    @width.setter
    def width(self, value: float):
        ...

    @property
    def height(self) -> float:
        ...

    @height.setter
    def height(self, value: float):
        ...

    @property
    def right(self) -> float:
        ...

    @property
    def bottom(self) -> float:
        ...

    @property
    def chart(self) -> IChart:
        ...

    @property
    def as_i_slide_component(self) -> ISlideComponent:
        ...

    @property
    def slide(self) -> IBaseSlide:
        ...

    @property
    def as_i_presentation_component(self) -> IPresentationComponent:
        ...

    @property
    def presentation(self) -> IPresentation:
        ...

    @property
    def text_frame_for_overriding(self) -> ITextFrame:
        ...

    @property
    def as_i_formatted_text_container(self) -> IFormattedTextContainer:
        ...

    @property
    def text_format(self) -> IChartTextFormat:
        ...

    ...

class IChartWall:
    @property
    def thickness(self) -> int:
        ...

    @thickness.setter
    def thickness(self, value: int):
        ...

    @property
    def format(self) -> IFormat:
        ...

    @property
    def picture_type(self) -> PictureType:
        ...

    @picture_type.setter
    def picture_type(self, value: PictureType):
        ...

    ...

class IDataLabel:
    def hide(self) -> None:
        ...

    def get_actual_label_text(self) -> string:
        ...

    def add_text_frame_for_overriding(self, text: string) -> ITextFrame:
        ...

    @property
    def is_visible(self) -> bool:
        ...

    @property
    def data_label_format(self) -> IDataLabelFormat:
        ...

    @property
    def value_from_cell(self) -> IChartDataCell:
        ...

    @value_from_cell.setter
    def value_from_cell(self, value: IChartDataCell):
        ...

    @property
    def as_i_layoutable(self) -> ILayoutable:
        ...

    @property
    def as_i_overridable_text(self) -> IOverridableText:
        ...

    @property
    def as_i_actual_layout(self) -> IActualLayout:
        ...

    @property
    def x(self) -> float:
        ...

    @x.setter
    def x(self, value: float):
        ...

    @property
    def y(self) -> float:
        ...

    @y.setter
    def y(self, value: float):
        ...

    @property
    def width(self) -> float:
        ...

    @width.setter
    def width(self, value: float):
        ...

    @property
    def height(self) -> float:
        ...

    @height.setter
    def height(self, value: float):
        ...

    @property
    def right(self) -> float:
        ...

    @property
    def bottom(self) -> float:
        ...

    @property
    def chart(self) -> IChart:
        ...

    @property
    def as_i_slide_component(self) -> ISlideComponent:
        ...

    @property
    def slide(self) -> IBaseSlide:
        ...

    @property
    def as_i_presentation_component(self) -> IPresentationComponent:
        ...

    @property
    def presentation(self) -> IPresentation:
        ...

    @property
    def text_frame_for_overriding(self) -> ITextFrame:
        ...

    @property
    def as_i_formatted_text_container(self) -> IFormattedTextContainer:
        ...

    @property
    def text_format(self) -> IChartTextFormat:
        ...

    @property
    def actual_x(self) -> float:
        ...

    @property
    def actual_y(self) -> float:
        ...

    @property
    def actual_width(self) -> float:
        ...

    @property
    def actual_height(self) -> float:
        ...

    ...

class IDataLabelCollection:
    def hide(self) -> None:
        ...

    def index_of(self, value: IDataLabel) -> int:
        ...

    @property
    def default_data_label_format(self) -> IDataLabelFormat:
        ...

    @property
    def leader_lines_format(self) -> IChartLinesFormat:
        ...

    @property
    def is_visible(self) -> bool:
        ...

    @property
    def count_of_visible_data_labels(self) -> int:
        ...

    @property
    def count(self) -> int:
        ...

    @property
    def parent_series(self) -> IChartSeries:
        ...

    @property
    def as_i_chart_component(self) -> IChartComponent:
        ...

    @property
    def as_i_enumerable(self) -> collections.abc.Iterable:
        ...

    @property
    def chart(self) -> IChart:
        ...

    @property
    def as_i_slide_component(self) -> ISlideComponent:
        ...

    @property
    def slide(self) -> IBaseSlide:
        ...

    @property
    def as_i_presentation_component(self) -> IPresentationComponent:
        ...

    @property
    def presentation(self) -> IPresentation:
        ...

    def __getitem__(self, key: int) -> IDataLabel
        ...

    ...

class IDataLabelFormat:
    @property
    def is_number_format_linked_to_source(self) -> bool:
        ...

    @is_number_format_linked_to_source.setter
    def is_number_format_linked_to_source(self, value: bool):
        ...

    @property
    def number_format(self) -> string:
        ...

    @number_format.setter
    def number_format(self, value: string):
        ...

    @property
    def format(self) -> IFormat:
        ...

    @property
    def position(self) -> LegendDataLabelPosition:
        ...

    @position.setter
    def position(self, value: LegendDataLabelPosition):
        ...

    @property
    def show_legend_key(self) -> bool:
        ...

    @show_legend_key.setter
    def show_legend_key(self, value: bool):
        ...

    @property
    def show_value(self) -> bool:
        ...

    @show_value.setter
    def show_value(self, value: bool):
        ...

    @property
    def show_category_name(self) -> bool:
        ...

    @show_category_name.setter
    def show_category_name(self, value: bool):
        ...

    @property
    def show_series_name(self) -> bool:
        ...

    @show_series_name.setter
    def show_series_name(self, value: bool):
        ...

    @property
    def show_percentage(self) -> bool:
        ...

    @show_percentage.setter
    def show_percentage(self, value: bool):
        ...

    @property
    def show_bubble_size(self) -> bool:
        ...

    @show_bubble_size.setter
    def show_bubble_size(self, value: bool):
        ...

    @property
    def show_leader_lines(self) -> bool:
        ...

    @show_leader_lines.setter
    def show_leader_lines(self, value: bool):
        ...

    @property
    def show_label_as_data_callout(self) -> bool:
        ...

    @show_label_as_data_callout.setter
    def show_label_as_data_callout(self, value: bool):
        ...

    @property
    def show_label_value_from_cell(self) -> bool:
        ...

    @show_label_value_from_cell.setter
    def show_label_value_from_cell(self, value: bool):
        ...

    @property
    def separator(self) -> string:
        ...

    @separator.setter
    def separator(self, value: string):
        ...

    @property
    def as_i_formatted_text_container(self) -> IFormattedTextContainer:
        ...

    @property
    def text_format(self) -> IChartTextFormat:
        ...

    @property
    def as_i_chart_component(self) -> IChartComponent:
        ...

    @property
    def chart(self) -> IChart:
        ...

    @property
    def as_i_slide_component(self) -> ISlideComponent:
        ...

    @property
    def slide(self) -> IBaseSlide:
        ...

    @property
    def as_i_presentation_component(self) -> IPresentationComponent:
        ...

    @property
    def presentation(self) -> IPresentation:
        ...

    ...

class IDataSourceTypeForErrorBarsCustomValues:
    @property
    def data_source_type_for_x_minus_values(self) -> DataSourceType:
        ...

    @data_source_type_for_x_minus_values.setter
    def data_source_type_for_x_minus_values(self, value: DataSourceType):
        ...

    @property
    def data_source_type_for_x_plus_values(self) -> DataSourceType:
        ...

    @data_source_type_for_x_plus_values.setter
    def data_source_type_for_x_plus_values(self, value: DataSourceType):
        ...

    @property
    def data_source_type_for_y_minus_values(self) -> DataSourceType:
        ...

    @data_source_type_for_y_minus_values.setter
    def data_source_type_for_y_minus_values(self, value: DataSourceType):
        ...

    @property
    def data_source_type_for_y_plus_values(self) -> DataSourceType:
        ...

    @data_source_type_for_y_plus_values.setter
    def data_source_type_for_y_plus_values(self, value: DataSourceType):
        ...

    ...

class IDataTable:
    @property
    def format(self) -> IFormat:
        ...

    @property
    def has_border_horizontal(self) -> bool:
        ...

    @has_border_horizontal.setter
    def has_border_horizontal(self, value: bool):
        ...

    @property
    def has_border_outline(self) -> bool:
        ...

    @has_border_outline.setter
    def has_border_outline(self, value: bool):
        ...

    @property
    def has_border_vertical(self) -> bool:
        ...

    @has_border_vertical.setter
    def has_border_vertical(self, value: bool):
        ...

    @property
    def show_legend_key(self) -> bool:
        ...

    @show_legend_key.setter
    def show_legend_key(self, value: bool):
        ...

    @property
    def as_i_formatted_text_container(self) -> IFormattedTextContainer:
        ...

    @property
    def text_format(self) -> IChartTextFormat:
        ...

    @property
    def as_i_chart_component(self) -> IChartComponent:
        ...

    @property
    def chart(self) -> IChart:
        ...

    @property
    def as_i_slide_component(self) -> ISlideComponent:
        ...

    @property
    def slide(self) -> IBaseSlide:
        ...

    @property
    def as_i_presentation_component(self) -> IPresentationComponent:
        ...

    @property
    def presentation(self) -> IPresentation:
        ...

    ...

class IDoubleChartValue:
    def to_double(self) -> float:
        ...

    @property
    def as_literal_double(self) -> float:
        ...

    @as_literal_double.setter
    def as_literal_double(self, value: float):
        ...

    @property
    def as_i_single_cell_chart_value(self) -> ISingleCellChartValue:
        ...

    @property
    def as_cell(self) -> IChartDataCell:
        ...

    @as_cell.setter
    def as_cell(self, value: IChartDataCell):
        ...

    @property
    def as_i_base_chart_value(self) -> IBaseChartValue:
        ...

    @property
    def data_source_type(self) -> DataSourceType:
        ...

    @data_source_type.setter
    def data_source_type(self, value: DataSourceType):
        ...

    @property
    def data(self) -> any:
        ...

    @data.setter
    def data(self, value: any):
        ...

    ...

class IErrorBarsCustomValues:
    @property
    def x_minus(self) -> IDoubleChartValue:
        ...

    @property
    def y_minus(self) -> IDoubleChartValue:
        ...

    @property
    def x_plus(self) -> IDoubleChartValue:
        ...

    @property
    def y_plus(self) -> IDoubleChartValue:
        ...

    ...

class IErrorBarsFormat:
    @property
    def type(self) -> ErrorBarType:
        ...

    @type.setter
    def type(self, value: ErrorBarType):
        ...

    @property
    def value_type(self) -> ErrorBarValueType:
        ...

    @value_type.setter
    def value_type(self, value: ErrorBarValueType):
        ...

    @property
    def has_end_cap(self) -> bool:
        ...

    @has_end_cap.setter
    def has_end_cap(self, value: bool):
        ...

    @property
    def value(self) -> float:
        ...

    @value.setter
    def value(self, value: float):
        ...

    @property
    def format(self) -> IFormat:
        ...

    @format.setter
    def format(self, value: IFormat):
        ...

    @property
    def is_visible(self) -> bool:
        ...

    @is_visible.setter
    def is_visible(self, value: bool):
        ...

    @property
    def as_i_chart_component(self) -> IChartComponent:
        ...

    @property
    def chart(self) -> IChart:
        ...

    @property
    def as_i_slide_component(self) -> ISlideComponent:
        ...

    @property
    def slide(self) -> IBaseSlide:
        ...

    @property
    def as_i_presentation_component(self) -> IPresentationComponent:
        ...

    @property
    def presentation(self) -> IPresentation:
        ...

    ...

class IFormat:
    @property
    def fill(self) -> IFillFormat:
        ...

    @property
    def line(self) -> ILineFormat:
        ...

    @property
    def effect(self) -> IEffectFormat:
        ...

    @property
    def effect_3d(self) -> IThreeDFormat:
        ...

    ...

class IFormattedTextContainer:
    @property
    def text_format(self) -> IChartTextFormat:
        ...

    @property
    def as_i_chart_component(self) -> IChartComponent:
        ...

    @property
    def chart(self) -> IChart:
        ...

    @property
    def as_i_slide_component(self) -> ISlideComponent:
        ...

    @property
    def slide(self) -> IBaseSlide:
        ...

    @property
    def as_i_presentation_component(self) -> IPresentationComponent:
        ...

    @property
    def presentation(self) -> IPresentation:
        ...

    ...

class ILayoutable:
    @property
    def x(self) -> float:
        ...

    @x.setter
    def x(self, value: float):
        ...

    @property
    def y(self) -> float:
        ...

    @y.setter
    def y(self, value: float):
        ...

    @property
    def width(self) -> float:
        ...

    @width.setter
    def width(self, value: float):
        ...

    @property
    def height(self) -> float:
        ...

    @height.setter
    def height(self, value: float):
        ...

    @property
    def right(self) -> float:
        ...

    @property
    def bottom(self) -> float:
        ...

    @property
    def as_i_chart_component(self) -> IChartComponent:
        ...

    @property
    def chart(self) -> IChart:
        ...

    @property
    def as_i_slide_component(self) -> ISlideComponent:
        ...

    @property
    def slide(self) -> IBaseSlide:
        ...

    @property
    def as_i_presentation_component(self) -> IPresentationComponent:
        ...

    @property
    def presentation(self) -> IPresentation:
        ...

    ...

class ILegend:
    @property
    def overlay(self) -> bool:
        ...

    @overlay.setter
    def overlay(self, value: bool):
        ...

    @property
    def position(self) -> LegendPositionType:
        ...

    @position.setter
    def position(self, value: LegendPositionType):
        ...

    @property
    def format(self) -> IFormat:
        ...

    @property
    def entries(self) -> ILegendEntryCollection:
        ...

    @property
    def as_i_layoutable(self) -> ILayoutable:
        ...

    @property
    def as_i_formatted_text_container(self) -> IFormattedTextContainer:
        ...

    @property
    def x(self) -> float:
        ...

    @x.setter
    def x(self, value: float):
        ...

    @property
    def y(self) -> float:
        ...

    @y.setter
    def y(self, value: float):
        ...

    @property
    def width(self) -> float:
        ...

    @width.setter
    def width(self, value: float):
        ...

    @property
    def height(self) -> float:
        ...

    @height.setter
    def height(self, value: float):
        ...

    @property
    def right(self) -> float:
        ...

    @property
    def bottom(self) -> float:
        ...

    @property
    def chart(self) -> IChart:
        ...

    @property
    def as_i_slide_component(self) -> ISlideComponent:
        ...

    @property
    def slide(self) -> IBaseSlide:
        ...

    @property
    def as_i_presentation_component(self) -> IPresentationComponent:
        ...

    @property
    def presentation(self) -> IPresentation:
        ...

    @property
    def text_format(self) -> IChartTextFormat:
        ...

    ...

class ILegendEntryCollection:
    @property
    def count(self) -> int:
        ...

    def __getitem__(self, key: int) -> ILegendEntryProperties
        ...

    ...

class ILegendEntryProperties:
    @property
    def hide(self) -> bool:
        ...

    @hide.setter
    def hide(self, value: bool):
        ...

    @property
    def as_i_formatted_text_container(self) -> IFormattedTextContainer:
        ...

    @property
    def text_format(self) -> IChartTextFormat:
        ...

    @property
    def as_i_chart_component(self) -> IChartComponent:
        ...

    @property
    def chart(self) -> IChart:
        ...

    @property
    def as_i_slide_component(self) -> ISlideComponent:
        ...

    @property
    def slide(self) -> IBaseSlide:
        ...

    @property
    def as_i_presentation_component(self) -> IPresentationComponent:
        ...

    @property
    def presentation(self) -> IPresentation:
        ...

    ...

class IMarker:
    @property
    def symbol(self) -> MarkerStyleType:
        ...

    @symbol.setter
    def symbol(self, value: MarkerStyleType):
        ...

    @property
    def format(self) -> IFormat:
        ...

    @property
    def size(self) -> int:
        ...

    @size.setter
    def size(self, value: int):
        ...

    ...

class IMultipleCellChartValue:
    @property
    def as_cells(self) -> IChartCellCollection:
        ...

    @as_cells.setter
    def as_cells(self, value: IChartCellCollection):
        ...

    @property
    def as_i_base_chart_value(self) -> IBaseChartValue:
        ...

    @property
    def data_source_type(self) -> DataSourceType:
        ...

    @data_source_type.setter
    def data_source_type(self, value: DataSourceType):
        ...

    @property
    def data(self) -> any:
        ...

    @data.setter
    def data(self, value: any):
        ...

    ...

class IOverridableText:
    def add_text_frame_for_overriding(self, text: string) -> ITextFrame:
        ...

    @property
    def text_frame_for_overriding(self) -> ITextFrame:
        ...

    @property
    def as_i_formatted_text_container(self) -> IFormattedTextContainer:
        ...

    @property
    def text_format(self) -> IChartTextFormat:
        ...

    @property
    def as_i_chart_component(self) -> IChartComponent:
        ...

    @property
    def chart(self) -> IChart:
        ...

    @property
    def as_i_slide_component(self) -> ISlideComponent:
        ...

    @property
    def slide(self) -> IBaseSlide:
        ...

    @property
    def as_i_presentation_component(self) -> IPresentationComponent:
        ...

    @property
    def presentation(self) -> IPresentation:
        ...

    ...

class IPieSplitCustomPointCollection:
    def add(self, data_point_index: int) -> None:
        ...

    @property
    def as_i_enumerable(self) -> collections.abc.Iterable:
        ...

    def __getitem__(self, key: int) -> IChartDataPoint
        ...

    ...

class IRotation3D:
    @property
    def rotation_x(self) -> int:
        ...

    @rotation_x.setter
    def rotation_x(self, value: int):
        ...

    @property
    def rotation_y(self) -> int:
        ...

    @rotation_y.setter
    def rotation_y(self, value: int):
        ...

    @property
    def perspective(self) -> int:
        ...

    @perspective.setter
    def perspective(self, value: int):
        ...

    @property
    def right_angle_axes(self) -> bool:
        ...

    @right_angle_axes.setter
    def right_angle_axes(self, value: bool):
        ...

    @property
    def depth_percents(self) -> int:
        ...

    @depth_percents.setter
    def depth_percents(self, value: int):
        ...

    @property
    def height_percents(self) -> int:
        ...

    @height_percents.setter
    def height_percents(self, value: int):
        ...

    ...

class ISingleCellChartValue:
    @property
    def as_cell(self) -> IChartDataCell:
        ...

    @as_cell.setter
    def as_cell(self, value: IChartDataCell):
        ...

    @property
    def as_i_base_chart_value(self) -> IBaseChartValue:
        ...

    @property
    def data_source_type(self) -> DataSourceType:
        ...

    @data_source_type.setter
    def data_source_type(self, value: DataSourceType):
        ...

    @property
    def data(self) -> any:
        ...

    @data.setter
    def data(self, value: any):
        ...

    ...

class IStringChartValue:
    def to_string(self) -> string:
        ...

    def set_from_one_cell(self, cell: IChartDataCell) -> None:
        ...

    def get_cells_address_in_workbook(self) -> string:
        ...

    @property
    def as_literal_string(self) -> string:
        ...

    @as_literal_string.setter
    def as_literal_string(self, value: string):
        ...

    @property
    def as_i_multiple_cell_chart_value(self) -> IMultipleCellChartValue:
        ...

    @property
    def as_cells(self) -> IChartCellCollection:
        ...

    @as_cells.setter
    def as_cells(self, value: IChartCellCollection):
        ...

    @property
    def as_i_base_chart_value(self) -> IBaseChartValue:
        ...

    @property
    def data_source_type(self) -> DataSourceType:
        ...

    @data_source_type.setter
    def data_source_type(self, value: DataSourceType):
        ...

    @property
    def data(self) -> any:
        ...

    @data.setter
    def data(self, value: any):
        ...

    ...

class IStringOrDoubleChartValue:
    def to_double(self) -> float:
        ...

    @property
    def as_literal_string(self) -> string:
        ...

    @as_literal_string.setter
    def as_literal_string(self, value: string):
        ...

    @property
    def as_literal_double(self) -> float:
        ...

    @as_literal_double.setter
    def as_literal_double(self, value: float):
        ...

    @property
    def as_i_single_cell_chart_value(self) -> ISingleCellChartValue:
        ...

    @property
    def as_cell(self) -> IChartDataCell:
        ...

    @as_cell.setter
    def as_cell(self, value: IChartDataCell):
        ...

    @property
    def as_i_base_chart_value(self) -> IBaseChartValue:
        ...

    @property
    def data_source_type(self) -> DataSourceType:
        ...

    @data_source_type.setter
    def data_source_type(self, value: DataSourceType):
        ...

    @property
    def data(self) -> any:
        ...

    @data.setter
    def data(self, value: any):
        ...

    ...

class ITrendline:
    def add_text_frame_for_overriding(self, text: string) -> ITextFrame:
        ...

    @property
    def trendline_name(self) -> string:
        ...

    @trendline_name.setter
    def trendline_name(self, value: string):
        ...

    @property
    def trendline_type(self) -> TrendlineType:
        ...

    @trendline_type.setter
    def trendline_type(self, value: TrendlineType):
        ...

    @property
    def format(self) -> IFormat:
        ...

    @format.setter
    def format(self, value: IFormat):
        ...

    @property
    def backward(self) -> float:
        ...

    @backward.setter
    def backward(self, value: float):
        ...

    @property
    def forward(self) -> float:
        ...

    @forward.setter
    def forward(self, value: float):
        ...

    @property
    def intercept(self) -> float:
        ...

    @intercept.setter
    def intercept(self, value: float):
        ...

    @property
    def display_equation(self) -> bool:
        ...

    @display_equation.setter
    def display_equation(self, value: bool):
        ...

    @property
    def order(self) -> int:
        ...

    @order.setter
    def order(self, value: int):
        ...

    @property
    def period(self) -> int:
        ...

    @period.setter
    def period(self, value: int):
        ...

    @property
    def display_r_squared_value(self) -> bool:
        ...

    @display_r_squared_value.setter
    def display_r_squared_value(self, value: bool):
        ...

    @property
    def related_legend_entry(self) -> ILegendEntryProperties:
        ...

    @property
    def as_i_overridable_text(self) -> IOverridableText:
        ...

    @property
    def text_frame_for_overriding(self) -> ITextFrame:
        ...

    @property
    def as_i_formatted_text_container(self) -> IFormattedTextContainer:
        ...

    @property
    def text_format(self) -> IChartTextFormat:
        ...

    @property
    def as_i_chart_component(self) -> IChartComponent:
        ...

    @property
    def chart(self) -> IChart:
        ...

    @property
    def as_i_slide_component(self) -> ISlideComponent:
        ...

    @property
    def slide(self) -> IBaseSlide:
        ...

    @property
    def as_i_presentation_component(self) -> IPresentationComponent:
        ...

    @property
    def presentation(self) -> IPresentation:
        ...

    ...

class ITrendlineCollection:
    def add(self, trendline_type: TrendlineType) -> ITrendline:
        ...

    def remove(self, value: ITrendline) -> None:
        ...

    @property
    def count(self) -> int:
        ...

    @property
    def as_i_enumerable(self) -> collections.abc.Iterable:
        ...

    def __getitem__(self, key: int) -> ITrendline
        ...

    ...

class IUpDownBarsManager:
    @property
    def up_bars_format(self) -> IFormat:
        ...

    @property
    def down_bars_format(self) -> IFormat:
        ...

    @property
    def has_up_down_bars(self) -> bool:
        ...

    @has_up_down_bars.setter
    def has_up_down_bars(self, value: bool):
        ...

    @property
    def gap_width(self) -> int:
        ...

    @gap_width.setter
    def gap_width(self, value: int):
        ...

    ...

class Legend:
    '''Represents chart's legend properties.'''
    @property
    def x(self) -> float:
        ...

    @x.setter
    def x(self, value: float):
        ...

    @property
    def y(self) -> float:
        ...

    @y.setter
    def y(self, value: float):
        ...

    @property
    def width(self) -> float:
        ...

    @width.setter
    def width(self, value: float):
        ...

    @property
    def height(self) -> float:
        ...

    @height.setter
    def height(self, value: float):
        ...

    @property
    def right(self) -> float:
        ...

    @property
    def bottom(self) -> float:
        ...

    @property
    def overlay(self) -> bool:
        ...

    @overlay.setter
    def overlay(self, value: bool):
        ...

    @property
    def text_format(self) -> IChartTextFormat:
        ...

    @property
    def position(self) -> LegendPositionType:
        ...

    @position.setter
    def position(self, value: LegendPositionType):
        ...

    @property
    def format(self) -> IFormat:
        ...

    @property
    def chart(self) -> IChart:
        ...

    @property
    def entries(self) -> ILegendEntryCollection:
        ...

    @property
    def as_i_layoutable(self) -> ILayoutable:
        ...

    @property
    def as_i_formatted_text_container(self) -> IFormattedTextContainer:
        ...

    @property
    def as_i_slide_component(self) -> ISlideComponent:
        ...

    @property
    def slide(self) -> IBaseSlide:
        ...

    @property
    def as_i_presentation_component(self) -> IPresentationComponent:
        ...

    @property
    def presentation(self) -> IPresentation:
        ...

    ...

class LegendEntryCollection:
    '''Represents legends collection.'''
    @property
    def count(self) -> int:
        ...

    def __getitem__(self, key: int) -> ILegendEntryProperties
        '''Gets properties of the legend entry corresponding to Chart.ChartData.Series[0].DataPoints[index]
                    in case of chart type from this list:
                      ChartType.BarOfPie,
                      ChartType.ExplodedPie,
                      ChartType.ExplodedPie3D,
                      ChartType.Pie,
                      ChartType.Pie3D,
                      ChartType.PieOfPie;
                    or corresponding to Chart.ChartData.Series[index] for other chart types.'''
        ...

    ...

class LegendEntryProperties:
    '''Represents legend properties of a chart.'''
    @property
    def text_format(self) -> IChartTextFormat:
        ...

    @property
    def hide(self) -> bool:
        ...

    @hide.setter
    def hide(self, value: bool):
        ...

    @property
    def chart(self) -> IChart:
        ...

    @property
    def as_i_formatted_text_container(self) -> IFormattedTextContainer:
        ...

    @property
    def as_i_chart_component(self) -> IChartComponent:
        ...

    @property
    def as_i_slide_component(self) -> ISlideComponent:
        ...

    @property
    def slide(self) -> IBaseSlide:
        ...

    @property
    def as_i_presentation_component(self) -> IPresentationComponent:
        ...

    @property
    def presentation(self) -> IPresentation:
        ...

    ...

class Marker:
    '''Represents marker of a chert.'''
    @property
    def symbol(self) -> MarkerStyleType:
        ...

    @symbol.setter
    def symbol(self, value: MarkerStyleType):
        ...

    @property
    def format(self) -> IFormat:
        ...

    @property
    def size(self) -> int:
        ...

    @size.setter
    def size(self, value: int):
        ...

    ...

class PieSplitCustomPointCollection:
    '''Represents a collection of points for splitting point in a bar-of-pie or pie-of-pie chart with a custom split.'''
    def add(self, data_point_index: int) -> None:
        '''Adds data point by its index in parent series points collection.
        :param data_point_index: Index of data point in parent series points collection.'''
        ...

    @property
    def is_synchronized(self) -> bool:
        ...

    @property
    def sync_root(self) -> any:
        ...

    @property
    def as_i_enumerable(self) -> collections.abc.Iterable:
        ...

    def __getitem__(self, key: int) -> IChartDataPoint
        '''Returns chart data point for specified index.'''
        ...

    ...

class Rotation3D:
    '''Represents 3D rotation of a chart.'''
    @property
    def rotation_x(self) -> int:
        ...

    @rotation_x.setter
    def rotation_x(self, value: int):
        ...

    @property
    def rotation_y(self) -> int:
        ...

    @rotation_y.setter
    def rotation_y(self, value: int):
        ...

    @property
    def perspective(self) -> int:
        ...

    @perspective.setter
    def perspective(self, value: int):
        ...

    @property
    def right_angle_axes(self) -> bool:
        ...

    @right_angle_axes.setter
    def right_angle_axes(self, value: bool):
        ...

    @property
    def depth_percents(self) -> int:
        ...

    @depth_percents.setter
    def depth_percents(self, value: int):
        ...

    @property
    def height_percents(self) -> int:
        ...

    @height_percents.setter
    def height_percents(self, value: int):
        ...

    ...

class StringChartValue(BaseChartValue):
    '''Represent string value which can be stored in pptx presentation document in two ways:
                1) in cell/cells of workbook related to chart;
                2) as literal value.'''
    def set_from_one_cell(self, cell: IChartDataCell) -> None:
        '''Sets value from specified cell.
        :param cell: Cell.'''
        ...

    def get_cells_address_in_workbook(self) -> string:
        '''If DataSourceType property is DataSourceType.Worksheet then this method returns address
                    of the cells in workbook which represent the string data. Otherwise return
                    empty string.'''
        ...

    @property
    def data_source_type(self) -> DataSourceType:
        ...

    @data_source_type.setter
    def data_source_type(self, value: DataSourceType):
        ...

    @property
    def data(self) -> any:
        ...

    @data.setter
    def data(self, value: any):
        ...

    @property
    def as_cells(self) -> IChartCellCollection:
        ...

    @as_cells.setter
    def as_cells(self, value: IChartCellCollection):
        ...

    @property
    def as_literal_string(self) -> string:
        ...

    @as_literal_string.setter
    def as_literal_string(self, value: string):
        ...

    @property
    def as_i_multiple_cell_chart_value(self) -> IMultipleCellChartValue:
        ...

    @property
    def as_i_base_chart_value(self) -> IBaseChartValue:
        ...

    ...

class StringOrDoubleChartValue(BaseChartValue):
    '''Represent string or double value which can be stored in pptx presentation document in two ways:
                1) in cell/cells of workbook related to chart;
                2) as literal value.'''
    def to_double(self) -> float:
        '''Converts to double.
        :returns: Double value.'''
        ...

    @property
    def data_source_type(self) -> DataSourceType:
        ...

    @data_source_type.setter
    def data_source_type(self, value: DataSourceType):
        ...

    @property
    def data(self) -> any:
        ...

    @data.setter
    def data(self, value: any):
        ...

    @property
    def as_cell(self) -> IChartDataCell:
        ...

    @as_cell.setter
    def as_cell(self, value: IChartDataCell):
        ...

    @property
    def as_literal_string(self) -> string:
        ...

    @as_literal_string.setter
    def as_literal_string(self, value: string):
        ...

    @property
    def as_literal_double(self) -> float:
        ...

    @as_literal_double.setter
    def as_literal_double(self, value: float):
        ...

    @property
    def as_i_single_cell_chart_value(self) -> ISingleCellChartValue:
        ...

    @property
    def as_i_base_chart_value(self) -> IBaseChartValue:
        ...

    ...

class Trendline:
    '''Class represents trend line of chart series'''
    def add_text_frame_for_overriding(self, text: string) -> ITextFrame:
        '''Initialize TextFrameForOverriding with the text in paramener "text".
                    If TextFrameForOverriding is already initialized then simply changes its text.
        :param text: Text for a new TextFrameForOverriding.'''
        ...

    @property
    def trendline_name(self) -> string:
        ...

    @trendline_name.setter
    def trendline_name(self, value: string):
        ...

    @property
    def trendline_type(self) -> TrendlineType:
        ...

    @trendline_type.setter
    def trendline_type(self, value: TrendlineType):
        ...

    @property
    def format(self) -> IFormat:
        ...

    @format.setter
    def format(self, value: IFormat):
        ...

    @property
    def backward(self) -> float:
        ...

    @backward.setter
    def backward(self, value: float):
        ...

    @property
    def forward(self) -> float:
        ...

    @forward.setter
    def forward(self, value: float):
        ...

    @property
    def intercept(self) -> float:
        ...

    @intercept.setter
    def intercept(self, value: float):
        ...

    @property
    def display_equation(self) -> bool:
        ...

    @display_equation.setter
    def display_equation(self, value: bool):
        ...

    @property
    def order(self) -> int:
        ...

    @order.setter
    def order(self, value: int):
        ...

    @property
    def period(self) -> int:
        ...

    @period.setter
    def period(self, value: int):
        ...

    @property
    def display_r_squared_value(self) -> bool:
        ...

    @display_r_squared_value.setter
    def display_r_squared_value(self, value: bool):
        ...

    @property
    def related_legend_entry(self) -> ILegendEntryProperties:
        ...

    @property
    def text_frame_for_overriding(self) -> ITextFrame:
        ...

    @property
    def text_format(self) -> IChartTextFormat:
        ...

    @property
    def chart(self) -> IChart:
        ...

    @property
    def as_i_overridable_text(self) -> IOverridableText:
        ...

    @property
    def as_i_formatted_text_container(self) -> IFormattedTextContainer:
        ...

    @property
    def as_i_chart_component(self) -> IChartComponent:
        ...

    @property
    def as_i_slide_component(self) -> ISlideComponent:
        ...

    @property
    def slide(self) -> IBaseSlide:
        ...

    @property
    def as_i_presentation_component(self) -> IPresentationComponent:
        ...

    @property
    def presentation(self) -> IPresentation:
        ...

    ...

class TrendlineCollection:
    '''Represents a collection of Trendline'''
    def add(self, trendline_type: TrendlineType) -> ITrendline:
        '''Adds the new Trendline at the end of a collection and return it.'''
        ...

    def remove(self, value: ITrendline) -> None:
        '''Removes the specified value.'''
        ...

    @property
    def count(self) -> int:
        ...

    @property
    def as_i_enumerable(self) -> collections.abc.Iterable:
        ...

    def __getitem__(self, key: int) -> ITrendline
        '''Gets the element at the specified index.
                    Read-only :py:class:`aspose.slides.charts.Trendline`.'''
        ...

    ...

class UpDownBarsManager:
    '''Provide access to up/down bars of Line- or Stock-chart.'''
    @property
    def up_bars_format(self) -> IFormat:
        ...

    @property
    def down_bars_format(self) -> IFormat:
        ...

    @property
    def has_up_down_bars(self) -> bool:
        ...

    @has_up_down_bars.setter
    def has_up_down_bars(self, value: bool):
        ...

    @property
    def gap_width(self) -> int:
        ...

    @gap_width.setter
    def gap_width(self, value: int):
        ...

    ...

class AxisAggregationType:
    @classmethod
    @property
    def BY_CATEGORY(cls) -> AxisAggregationType:
        ...

    @classmethod
    @property
    def AUTOMATIC(cls) -> AxisAggregationType:
        ...

    @classmethod
    @property
    def BY_BIN_WIDTH(cls) -> AxisAggregationType:
        ...

    @classmethod
    @property
    def BY_NUMBER_OF_BINS(cls) -> AxisAggregationType:
        ...

    ...

class AxisPositionType:
    @classmethod
    @property
    def BOTTOM(cls) -> AxisPositionType:
        ...

    @classmethod
    @property
    def LEFT(cls) -> AxisPositionType:
        ...

    @classmethod
    @property
    def RIGHT(cls) -> AxisPositionType:
        ...

    @classmethod
    @property
    def TOP(cls) -> AxisPositionType:
        ...

    ...

class BubbleSizeRepresentationType:
    @classmethod
    @property
    def AREA(cls) -> BubbleSizeRepresentationType:
        ...

    @classmethod
    @property
    def WIDTH(cls) -> BubbleSizeRepresentationType:
        ...

    ...

class CategoryAxisType:
    @classmethod
    @property
    def TEXT(cls) -> CategoryAxisType:
        ...

    @classmethod
    @property
    def DATE(cls) -> CategoryAxisType:
        ...

    ...

class ChartDataSourceType:
    @classmethod
    @property
    def INTERNAL_WORKBOOK(cls) -> ChartDataSourceType:
        ...

    @classmethod
    @property
    def EXTERNAL_WORKBOOK(cls) -> ChartDataSourceType:
        ...

    ...

class ChartShapeType:
    @classmethod
    @property
    def NOT_DEFINED(cls) -> ChartShapeType:
        ...

    @classmethod
    @property
    def BOX(cls) -> ChartShapeType:
        ...

    @classmethod
    @property
    def CONE(cls) -> ChartShapeType:
        ...

    @classmethod
    @property
    def CONE_TO_MAX(cls) -> ChartShapeType:
        ...

    @classmethod
    @property
    def CYLINDER(cls) -> ChartShapeType:
        ...

    @classmethod
    @property
    def PYRAMID(cls) -> ChartShapeType:
        ...

    @classmethod
    @property
    def PYRAMID_TO_MAXIMUM(cls) -> ChartShapeType:
        ...

    ...

class ChartType:
    @classmethod
    @property
    def CLUSTERED_COLUMN(cls) -> ChartType:
        ...

    @classmethod
    @property
    def STACKED_COLUMN(cls) -> ChartType:
        ...

    @classmethod
    @property
    def PERCENTS_STACKED_COLUMN(cls) -> ChartType:
        ...

    @classmethod
    @property
    def CLUSTERED_COLUMN_3D(cls) -> ChartType:
        ...

    @classmethod
    @property
    def STACKED_COLUMN_3D(cls) -> ChartType:
        ...

    @classmethod
    @property
    def PERCENTS_STACKED_COLUMN_3D(cls) -> ChartType:
        ...

    @classmethod
    @property
    def COLUMN_3D(cls) -> ChartType:
        ...

    @classmethod
    @property
    def CLUSTERED_CYLINDER(cls) -> ChartType:
        ...

    @classmethod
    @property
    def STACKED_CYLINDER(cls) -> ChartType:
        ...

    @classmethod
    @property
    def PERCENTS_STACKED_CYLINDER(cls) -> ChartType:
        ...

    @classmethod
    @property
    def CYLINDER_3D(cls) -> ChartType:
        ...

    @classmethod
    @property
    def CLUSTERED_CONE(cls) -> ChartType:
        ...

    @classmethod
    @property
    def STACKED_CONE(cls) -> ChartType:
        ...

    @classmethod
    @property
    def PERCENTS_STACKED_CONE(cls) -> ChartType:
        ...

    @classmethod
    @property
    def CONE_3D(cls) -> ChartType:
        ...

    @classmethod
    @property
    def CLUSTERED_PYRAMID(cls) -> ChartType:
        ...

    @classmethod
    @property
    def STACKED_PYRAMID(cls) -> ChartType:
        ...

    @classmethod
    @property
    def PERCENTS_STACKED_PYRAMID(cls) -> ChartType:
        ...

    @classmethod
    @property
    def PYRAMID_3D(cls) -> ChartType:
        ...

    @classmethod
    @property
    def LINE(cls) -> ChartType:
        ...

    @classmethod
    @property
    def STACKED_LINE(cls) -> ChartType:
        ...

    @classmethod
    @property
    def PERCENTS_STACKED_LINE(cls) -> ChartType:
        ...

    @classmethod
    @property
    def LINE_WITH_MARKERS(cls) -> ChartType:
        ...

    @classmethod
    @property
    def STACKED_LINE_WITH_MARKERS(cls) -> ChartType:
        ...

    @classmethod
    @property
    def PERCENTS_STACKED_LINE_WITH_MARKERS(cls) -> ChartType:
        ...

    @classmethod
    @property
    def LINE_3D(cls) -> ChartType:
        ...

    @classmethod
    @property
    def PIE(cls) -> ChartType:
        ...

    @classmethod
    @property
    def PIE_3D(cls) -> ChartType:
        ...

    @classmethod
    @property
    def PIE_OF_PIE(cls) -> ChartType:
        ...

    @classmethod
    @property
    def EXPLODED_PIE(cls) -> ChartType:
        ...

    @classmethod
    @property
    def EXPLODED_PIE_3D(cls) -> ChartType:
        ...

    @classmethod
    @property
    def BAR_OF_PIE(cls) -> ChartType:
        ...

    @classmethod
    @property
    def PERCENTS_STACKED_BAR(cls) -> ChartType:
        ...

    @classmethod
    @property
    def CLUSTERED_BAR_3D(cls) -> ChartType:
        ...

    @classmethod
    @property
    def CLUSTERED_BAR(cls) -> ChartType:
        ...

    @classmethod
    @property
    def STACKED_BAR(cls) -> ChartType:
        ...

    @classmethod
    @property
    def STACKED_BAR_3D(cls) -> ChartType:
        ...

    @classmethod
    @property
    def PERCENTS_STACKED_BAR_3D(cls) -> ChartType:
        ...

    @classmethod
    @property
    def CLUSTERED_HORIZONTAL_CYLINDER(cls) -> ChartType:
        ...

    @classmethod
    @property
    def STACKED_HORIZONTAL_CYLINDER(cls) -> ChartType:
        ...

    @classmethod
    @property
    def PERCENTS_STACKED_HORIZONTAL_CYLINDER(cls) -> ChartType:
        ...

    @classmethod
    @property
    def CLUSTERED_HORIZONTAL_CONE(cls) -> ChartType:
        ...

    @classmethod
    @property
    def STACKED_HORIZONTAL_CONE(cls) -> ChartType:
        ...

    @classmethod
    @property
    def PERCENTS_STACKED_HORIZONTAL_CONE(cls) -> ChartType:
        ...

    @classmethod
    @property
    def CLUSTERED_HORIZONTAL_PYRAMID(cls) -> ChartType:
        ...

    @classmethod
    @property
    def STACKED_HORIZONTAL_PYRAMID(cls) -> ChartType:
        ...

    @classmethod
    @property
    def PERCENTS_STACKED_HORIZONTAL_PYRAMID(cls) -> ChartType:
        ...

    @classmethod
    @property
    def AREA(cls) -> ChartType:
        ...

    @classmethod
    @property
    def STACKED_AREA(cls) -> ChartType:
        ...

    @classmethod
    @property
    def PERCENTS_STACKED_AREA(cls) -> ChartType:
        ...

    @classmethod
    @property
    def AREA_3D(cls) -> ChartType:
        ...

    @classmethod
    @property
    def STACKED_AREA_3D(cls) -> ChartType:
        ...

    @classmethod
    @property
    def PERCENTS_STACKED_AREA_3D(cls) -> ChartType:
        ...

    @classmethod
    @property
    def SCATTER_WITH_MARKERS(cls) -> ChartType:
        ...

    @classmethod
    @property
    def SCATTER_WITH_SMOOTH_LINES_AND_MARKERS(cls) -> ChartType:
        ...

    @classmethod
    @property
    def SCATTER_WITH_SMOOTH_LINES(cls) -> ChartType:
        ...

    @classmethod
    @property
    def SCATTER_WITH_STRAIGHT_LINES_AND_MARKERS(cls) -> ChartType:
        ...

    @classmethod
    @property
    def SCATTER_WITH_STRAIGHT_LINES(cls) -> ChartType:
        ...

    @classmethod
    @property
    def HIGH_LOW_CLOSE(cls) -> ChartType:
        ...

    @classmethod
    @property
    def OPEN_HIGH_LOW_CLOSE(cls) -> ChartType:
        ...

    @classmethod
    @property
    def VOLUME_HIGH_LOW_CLOSE(cls) -> ChartType:
        ...

    @classmethod
    @property
    def VOLUME_OPEN_HIGH_LOW_CLOSE(cls) -> ChartType:
        ...

    @classmethod
    @property
    def SURFACE_3D(cls) -> ChartType:
        ...

    @classmethod
    @property
    def WIREFRAME_SURFACE_3D(cls) -> ChartType:
        ...

    @classmethod
    @property
    def CONTOUR(cls) -> ChartType:
        ...

    @classmethod
    @property
    def WIREFRAME_CONTOUR(cls) -> ChartType:
        ...

    @classmethod
    @property
    def DOUGHNUT(cls) -> ChartType:
        ...

    @classmethod
    @property
    def EXPLODED_DOUGHNUT(cls) -> ChartType:
        ...

    @classmethod
    @property
    def BUBBLE(cls) -> ChartType:
        ...

    @classmethod
    @property
    def BUBBLE_WITH_3D(cls) -> ChartType:
        ...

    @classmethod
    @property
    def RADAR(cls) -> ChartType:
        ...

    @classmethod
    @property
    def RADAR_WITH_MARKERS(cls) -> ChartType:
        ...

    @classmethod
    @property
    def FILLED_RADAR(cls) -> ChartType:
        ...

    @classmethod
    @property
    def SERIES_OF_MIXED_TYPES(cls) -> ChartType:
        ...

    @classmethod
    @property
    def TREEMAP(cls) -> ChartType:
        ...

    @classmethod
    @property
    def SUNBURST(cls) -> ChartType:
        ...

    @classmethod
    @property
    def HISTOGRAM(cls) -> ChartType:
        ...

    @classmethod
    @property
    def PARETO_LINE(cls) -> ChartType:
        ...

    @classmethod
    @property
    def BOX_AND_WHISKER(cls) -> ChartType:
        ...

    @classmethod
    @property
    def WATERFALL(cls) -> ChartType:
        ...

    @classmethod
    @property
    def FUNNEL(cls) -> ChartType:
        ...

    @classmethod
    @property
    def MAP(cls) -> ChartType:
        ...

    ...

class CombinableSeriesTypesGroup:
    @classmethod
    @property
    def AREA_CHART_AREA(cls) -> CombinableSeriesTypesGroup:
        ...

    @classmethod
    @property
    def AREA_CHART_PERCENTS_STACKED_AREA(cls) -> CombinableSeriesTypesGroup:
        ...

    @classmethod
    @property
    def AREA_CHART_STACKED_AREA(cls) -> CombinableSeriesTypesGroup:
        ...

    @classmethod
    @property
    def AREA_CHART_AREA_3D(cls) -> CombinableSeriesTypesGroup:
        ...

    @classmethod
    @property
    def AREA_CHART_STACKED_AREA_3D(cls) -> CombinableSeriesTypesGroup:
        ...

    @classmethod
    @property
    def AREA_CHART_PERCENTS_STACKED_AREA_3D(cls) -> CombinableSeriesTypesGroup:
        ...

    @classmethod
    @property
    def LINE_CHART_LINE(cls) -> CombinableSeriesTypesGroup:
        ...

    @classmethod
    @property
    def LINE_CHART_STACKED_LINE(cls) -> CombinableSeriesTypesGroup:
        ...

    @classmethod
    @property
    def LINE_CHART_PERCENTS_STACKED_LINE(cls) -> CombinableSeriesTypesGroup:
        ...

    @classmethod
    @property
    def LINE_3D_CHART(cls) -> CombinableSeriesTypesGroup:
        ...

    @classmethod
    @property
    def STOCK_HIGH_LOW_CLOSE(cls) -> CombinableSeriesTypesGroup:
        ...

    @classmethod
    @property
    def STOCK_OPEN_HIGH_LOW_CLOSE(cls) -> CombinableSeriesTypesGroup:
        ...

    @classmethod
    @property
    def STOCK_VOLUME_HIGH_LOW_CLOSE(cls) -> CombinableSeriesTypesGroup:
        ...

    @classmethod
    @property
    def STOCK_VOLUME_OPEN_HIGH_LOW_CLOSE(cls) -> CombinableSeriesTypesGroup:
        ...

    @classmethod
    @property
    def RADAR_CHART(cls) -> CombinableSeriesTypesGroup:
        ...

    @classmethod
    @property
    def FILLED_RADAR_CHART(cls) -> CombinableSeriesTypesGroup:
        ...

    @classmethod
    @property
    def SCATTER_STRAIGHT_MARKER(cls) -> CombinableSeriesTypesGroup:
        ...

    @classmethod
    @property
    def SCATTER_SMOOTH_MARKER(cls) -> CombinableSeriesTypesGroup:
        ...

    @classmethod
    @property
    def PIE_CHART(cls) -> CombinableSeriesTypesGroup:
        ...

    @classmethod
    @property
    def PIE_3D_CHART(cls) -> CombinableSeriesTypesGroup:
        ...

    @classmethod
    @property
    def DOUGHNUT_CHART(cls) -> CombinableSeriesTypesGroup:
        ...

    @classmethod
    @property
    def BAR_CHART_VERT_CLUSTERED(cls) -> CombinableSeriesTypesGroup:
        ...

    @classmethod
    @property
    def BAR_CHART_VERT_STACKED(cls) -> CombinableSeriesTypesGroup:
        ...

    @classmethod
    @property
    def BAR_CHART_VERT_PERCENTS_STACKED(cls) -> CombinableSeriesTypesGroup:
        ...

    @classmethod
    @property
    def BAR_CHART_HORIZ_CLUSTERED(cls) -> CombinableSeriesTypesGroup:
        ...

    @classmethod
    @property
    def BAR_CHART_HORIZ_STACKED(cls) -> CombinableSeriesTypesGroup:
        ...

    @classmethod
    @property
    def BAR_CHART_HORIZ_PERCENTS_STACKED(cls) -> CombinableSeriesTypesGroup:
        ...

    @classmethod
    @property
    def BAR_3D_CHART_VERT(cls) -> CombinableSeriesTypesGroup:
        ...

    @classmethod
    @property
    def BAR_3D_CHART_VERT_CLUSTERED(cls) -> CombinableSeriesTypesGroup:
        ...

    @classmethod
    @property
    def BAR_3D_CHART_VERT_PERCENTS_STACKED_COLUMN_3D(cls) -> CombinableSeriesTypesGroup:
        ...

    @classmethod
    @property
    def BAR_3D_CHART_VERT_PERCENTS_STACKED_CONE(cls) -> CombinableSeriesTypesGroup:
        ...

    @classmethod
    @property
    def BAR_3D_CHART_VERT_PERCENTS_STACKED_CYLINDER(cls) -> CombinableSeriesTypesGroup:
        ...

    @classmethod
    @property
    def BAR_3D_CHART_VERT_PERCENTS_STACKED_PYRAMID(cls) -> CombinableSeriesTypesGroup:
        ...

    @classmethod
    @property
    def BAR_3D_CHART_VERT_STACKED_COLUMN_3D(cls) -> CombinableSeriesTypesGroup:
        ...

    @classmethod
    @property
    def BAR_3D_CHART_VERT_STACKED_CONE(cls) -> CombinableSeriesTypesGroup:
        ...

    @classmethod
    @property
    def BAR_3D_CHART_VERT_STACKED_CYLINDER(cls) -> CombinableSeriesTypesGroup:
        ...

    @classmethod
    @property
    def BAR_3D_CHART_VERT_STACKED_PYRAMID(cls) -> CombinableSeriesTypesGroup:
        ...

    @classmethod
    @property
    def BAR_3D_CHART_HORIZ_CLUSTERED(cls) -> CombinableSeriesTypesGroup:
        ...

    @classmethod
    @property
    def BAR_3D_CHART_HORIZ_STACKED_BAR_3D(cls) -> CombinableSeriesTypesGroup:
        ...

    @classmethod
    @property
    def BAR_3D_CHART_HORIZ_STACKED_CONE(cls) -> CombinableSeriesTypesGroup:
        ...

    @classmethod
    @property
    def BAR_3D_CHART_HORIZ_STACKED_CYLINDER(cls) -> CombinableSeriesTypesGroup:
        ...

    @classmethod
    @property
    def BAR_3D_CHART_HORIZ_STACKED_PYRAMID(cls) -> CombinableSeriesTypesGroup:
        ...

    @classmethod
    @property
    def BAR_3D_CHART_HORIZ_PERCENTS_STACKED_BAR_3D(cls) -> CombinableSeriesTypesGroup:
        ...

    @classmethod
    @property
    def BAR_3D_CHART_HORIZ_PERCENTS_STACKED_CONE(cls) -> CombinableSeriesTypesGroup:
        ...

    @classmethod
    @property
    def BAR_3D_CHART_HORIZ_PERCENTS_STACKED_CYLINDER(cls) -> CombinableSeriesTypesGroup:
        ...

    @classmethod
    @property
    def BAR_3D_CHART_HORIZ_PERCENTS_STACKED_PYRAMID(cls) -> CombinableSeriesTypesGroup:
        ...

    @classmethod
    @property
    def BAR_OF_PIE_CHART(cls) -> CombinableSeriesTypesGroup:
        ...

    @classmethod
    @property
    def PIE_OF_PIE_CHART(cls) -> CombinableSeriesTypesGroup:
        ...

    @classmethod
    @property
    def SURFACE_CHART_CONTOUR(cls) -> CombinableSeriesTypesGroup:
        ...

    @classmethod
    @property
    def SURFACE_CHART_WIREFRAME_CONTOUR(cls) -> CombinableSeriesTypesGroup:
        ...

    @classmethod
    @property
    def SURFACE_CHART_SURFACE_3D(cls) -> CombinableSeriesTypesGroup:
        ...

    @classmethod
    @property
    def SURFACE_CHART_WIREFRAME_SURFACE_3D(cls) -> CombinableSeriesTypesGroup:
        ...

    @classmethod
    @property
    def BUBBLE_CHART(cls) -> CombinableSeriesTypesGroup:
        ...

    @classmethod
    @property
    def HISTOGRAM_CHART(cls) -> CombinableSeriesTypesGroup:
        ...

    @classmethod
    @property
    def PARETO_LINE_CHART(cls) -> CombinableSeriesTypesGroup:
        ...

    @classmethod
    @property
    def BOX_AND_WHISKER_CHART(cls) -> CombinableSeriesTypesGroup:
        ...

    @classmethod
    @property
    def WATERFALL_CHART(cls) -> CombinableSeriesTypesGroup:
        ...

    @classmethod
    @property
    def FUNNEL_CHART(cls) -> CombinableSeriesTypesGroup:
        ...

    @classmethod
    @property
    def TREEMAP_CHART(cls) -> CombinableSeriesTypesGroup:
        ...

    @classmethod
    @property
    def MAP_CHART(cls) -> CombinableSeriesTypesGroup:
        ...

    @classmethod
    @property
    def SUNBURST_CHART(cls) -> CombinableSeriesTypesGroup:
        ...

    ...

class CrossesType:
    @classmethod
    @property
    def AXIS_CROSSES_AT_ZERO(cls) -> CrossesType:
        ...

    @classmethod
    @property
    def MAXIMUM(cls) -> CrossesType:
        ...

    @classmethod
    @property
    def CUSTOM(cls) -> CrossesType:
        ...

    ...

class DataSourceType:
    @classmethod
    @property
    def WORKSHEET(cls) -> DataSourceType:
        ...

    @classmethod
    @property
    def STRING_LITERALS(cls) -> DataSourceType:
        ...

    @classmethod
    @property
    def DOUBLE_LITERALS(cls) -> DataSourceType:
        ...

    ...

class DisplayBlanksAsType:
    @classmethod
    @property
    def GAP(cls) -> DisplayBlanksAsType:
        ...

    @classmethod
    @property
    def SPAN(cls) -> DisplayBlanksAsType:
        ...

    @classmethod
    @property
    def ZERO(cls) -> DisplayBlanksAsType:
        ...

    ...

class DisplayUnitType:
    @classmethod
    @property
    def NONE(cls) -> DisplayUnitType:
        ...

    @classmethod
    @property
    def HUNDREDS(cls) -> DisplayUnitType:
        ...

    @classmethod
    @property
    def THOUSANDS(cls) -> DisplayUnitType:
        ...

    @classmethod
    @property
    def TEN_THOUSANDS(cls) -> DisplayUnitType:
        ...

    @classmethod
    @property
    def HUNDRED_THOUSANDS(cls) -> DisplayUnitType:
        ...

    @classmethod
    @property
    def MILLIONS(cls) -> DisplayUnitType:
        ...

    @classmethod
    @property
    def TEN_MILLIONS(cls) -> DisplayUnitType:
        ...

    @classmethod
    @property
    def HUNDRED_MILLIONS(cls) -> DisplayUnitType:
        ...

    @classmethod
    @property
    def BILLIONS(cls) -> DisplayUnitType:
        ...

    @classmethod
    @property
    def TRILLIONS(cls) -> DisplayUnitType:
        ...

    @classmethod
    @property
    def CUSTOM_VALUE(cls) -> DisplayUnitType:
        ...

    ...

class ErrorBarType:
    @classmethod
    @property
    def BOTH(cls) -> ErrorBarType:
        ...

    @classmethod
    @property
    def MINUS(cls) -> ErrorBarType:
        ...

    @classmethod
    @property
    def PLUS(cls) -> ErrorBarType:
        ...

    ...

class ErrorBarValueType:
    @classmethod
    @property
    def CUSTOM(cls) -> ErrorBarValueType:
        ...

    @classmethod
    @property
    def FIXED(cls) -> ErrorBarValueType:
        ...

    @classmethod
    @property
    def PERCENTAGE(cls) -> ErrorBarValueType:
        ...

    @classmethod
    @property
    def STANDARD_DEVIATION(cls) -> ErrorBarValueType:
        ...

    @classmethod
    @property
    def STANDARD_ERROR(cls) -> ErrorBarValueType:
        ...

    ...

class LayoutTargetType:
    @classmethod
    @property
    def INNER(cls) -> LayoutTargetType:
        ...

    @classmethod
    @property
    def OUTER(cls) -> LayoutTargetType:
        ...

    ...

class LegendDataLabelPosition:
    @classmethod
    @property
    def NOT_DEFINED(cls) -> LegendDataLabelPosition:
        ...

    @classmethod
    @property
    def BOTTOM(cls) -> LegendDataLabelPosition:
        ...

    @classmethod
    @property
    def BEST_FIT(cls) -> LegendDataLabelPosition:
        ...

    @classmethod
    @property
    def CENTER(cls) -> LegendDataLabelPosition:
        ...

    @classmethod
    @property
    def INSIDE_BASE(cls) -> LegendDataLabelPosition:
        ...

    @classmethod
    @property
    def INSIDE_END(cls) -> LegendDataLabelPosition:
        ...

    @classmethod
    @property
    def LEFT(cls) -> LegendDataLabelPosition:
        ...

    @classmethod
    @property
    def OUTSIDE_END(cls) -> LegendDataLabelPosition:
        ...

    @classmethod
    @property
    def RIGHT(cls) -> LegendDataLabelPosition:
        ...

    @classmethod
    @property
    def TOP(cls) -> LegendDataLabelPosition:
        ...

    ...

class LegendPositionType:
    @classmethod
    @property
    def BOTTOM(cls) -> LegendPositionType:
        ...

    @classmethod
    @property
    def LEFT(cls) -> LegendPositionType:
        ...

    @classmethod
    @property
    def RIGHT(cls) -> LegendPositionType:
        ...

    @classmethod
    @property
    def TOP(cls) -> LegendPositionType:
        ...

    @classmethod
    @property
    def TOP_RIGHT(cls) -> LegendPositionType:
        ...

    ...

class MarkerStyleType:
    @classmethod
    @property
    def NOT_DEFINED(cls) -> MarkerStyleType:
        ...

    @classmethod
    @property
    def CIRCLE(cls) -> MarkerStyleType:
        ...

    @classmethod
    @property
    def DASH(cls) -> MarkerStyleType:
        ...

    @classmethod
    @property
    def DIAMOND(cls) -> MarkerStyleType:
        ...

    @classmethod
    @property
    def DOT(cls) -> MarkerStyleType:
        ...

    @classmethod
    @property
    def NONE(cls) -> MarkerStyleType:
        ...

    @classmethod
    @property
    def PICTURE(cls) -> MarkerStyleType:
        ...

    @classmethod
    @property
    def PLUS(cls) -> MarkerStyleType:
        ...

    @classmethod
    @property
    def SQUARE(cls) -> MarkerStyleType:
        ...

    @classmethod
    @property
    def STAR(cls) -> MarkerStyleType:
        ...

    @classmethod
    @property
    def TRIANGLE(cls) -> MarkerStyleType:
        ...

    @classmethod
    @property
    def X(cls) -> MarkerStyleType:
        ...

    ...

class ParentLabelLayoutType:
    @classmethod
    @property
    def BANNER(cls) -> ParentLabelLayoutType:
        ...

    @classmethod
    @property
    def NONE(cls) -> ParentLabelLayoutType:
        ...

    @classmethod
    @property
    def OVERLAPPING(cls) -> ParentLabelLayoutType:
        ...

    ...

class PictureType:
    @classmethod
    @property
    def NOT_DEFINED(cls) -> PictureType:
        ...

    @classmethod
    @property
    def STACK(cls) -> PictureType:
        ...

    @classmethod
    @property
    def STACK_SCALE(cls) -> PictureType:
        ...

    @classmethod
    @property
    def STRETCH(cls) -> PictureType:
        ...

    ...

class PieSplitType:
    @classmethod
    @property
    def DEFAULT(cls) -> PieSplitType:
        ...

    @classmethod
    @property
    def CUSTOM(cls) -> PieSplitType:
        ...

    @classmethod
    @property
    def BY_PERCENTAGE(cls) -> PieSplitType:
        ...

    @classmethod
    @property
    def BY_POS(cls) -> PieSplitType:
        ...

    @classmethod
    @property
    def BY_VALUE(cls) -> PieSplitType:
        ...

    ...

class QuartileMethodType:
    @classmethod
    @property
    def EXCLUSIVE(cls) -> QuartileMethodType:
        ...

    @classmethod
    @property
    def INCLUSIVE(cls) -> QuartileMethodType:
        ...

    ...

class StyleType:
    @classmethod
    @property
    def STYLE1(cls) -> StyleType:
        ...

    @classmethod
    @property
    def STYLE2(cls) -> StyleType:
        ...

    @classmethod
    @property
    def STYLE3(cls) -> StyleType:
        ...

    @classmethod
    @property
    def STYLE4(cls) -> StyleType:
        ...

    @classmethod
    @property
    def STYLE5(cls) -> StyleType:
        ...

    @classmethod
    @property
    def STYLE6(cls) -> StyleType:
        ...

    @classmethod
    @property
    def STYLE7(cls) -> StyleType:
        ...

    @classmethod
    @property
    def STYLE8(cls) -> StyleType:
        ...

    @classmethod
    @property
    def STYLE9(cls) -> StyleType:
        ...

    @classmethod
    @property
    def STYLE10(cls) -> StyleType:
        ...

    @classmethod
    @property
    def STYLE11(cls) -> StyleType:
        ...

    @classmethod
    @property
    def STYLE12(cls) -> StyleType:
        ...

    @classmethod
    @property
    def STYLE13(cls) -> StyleType:
        ...

    @classmethod
    @property
    def STYLE14(cls) -> StyleType:
        ...

    @classmethod
    @property
    def STYLE15(cls) -> StyleType:
        ...

    @classmethod
    @property
    def STYLE16(cls) -> StyleType:
        ...

    @classmethod
    @property
    def STYLE17(cls) -> StyleType:
        ...

    @classmethod
    @property
    def STYLE18(cls) -> StyleType:
        ...

    @classmethod
    @property
    def STYLE19(cls) -> StyleType:
        ...

    @classmethod
    @property
    def STYLE20(cls) -> StyleType:
        ...

    @classmethod
    @property
    def STYLE21(cls) -> StyleType:
        ...

    @classmethod
    @property
    def STYLE22(cls) -> StyleType:
        ...

    @classmethod
    @property
    def STYLE23(cls) -> StyleType:
        ...

    @classmethod
    @property
    def STYLE24(cls) -> StyleType:
        ...

    @classmethod
    @property
    def STYLE25(cls) -> StyleType:
        ...

    @classmethod
    @property
    def STYLE26(cls) -> StyleType:
        ...

    @classmethod
    @property
    def STYLE27(cls) -> StyleType:
        ...

    @classmethod
    @property
    def STYLE28(cls) -> StyleType:
        ...

    @classmethod
    @property
    def STYLE29(cls) -> StyleType:
        ...

    @classmethod
    @property
    def STYLE30(cls) -> StyleType:
        ...

    @classmethod
    @property
    def STYLE31(cls) -> StyleType:
        ...

    @classmethod
    @property
    def STYLE32(cls) -> StyleType:
        ...

    @classmethod
    @property
    def STYLE33(cls) -> StyleType:
        ...

    @classmethod
    @property
    def STYLE34(cls) -> StyleType:
        ...

    @classmethod
    @property
    def STYLE35(cls) -> StyleType:
        ...

    @classmethod
    @property
    def STYLE36(cls) -> StyleType:
        ...

    @classmethod
    @property
    def STYLE37(cls) -> StyleType:
        ...

    @classmethod
    @property
    def STYLE38(cls) -> StyleType:
        ...

    @classmethod
    @property
    def STYLE39(cls) -> StyleType:
        ...

    @classmethod
    @property
    def STYLE40(cls) -> StyleType:
        ...

    @classmethod
    @property
    def STYLE41(cls) -> StyleType:
        ...

    @classmethod
    @property
    def STYLE42(cls) -> StyleType:
        ...

    @classmethod
    @property
    def STYLE43(cls) -> StyleType:
        ...

    @classmethod
    @property
    def STYLE44(cls) -> StyleType:
        ...

    @classmethod
    @property
    def STYLE45(cls) -> StyleType:
        ...

    @classmethod
    @property
    def STYLE46(cls) -> StyleType:
        ...

    @classmethod
    @property
    def STYLE47(cls) -> StyleType:
        ...

    @classmethod
    @property
    def STYLE48(cls) -> StyleType:
        ...

    ...

class TickLabelPositionType:
    @classmethod
    @property
    def HIGH(cls) -> TickLabelPositionType:
        ...

    @classmethod
    @property
    def LOW(cls) -> TickLabelPositionType:
        ...

    @classmethod
    @property
    def NEXT_TO(cls) -> TickLabelPositionType:
        ...

    @classmethod
    @property
    def NONE(cls) -> TickLabelPositionType:
        ...

    ...

class TickMarkType:
    @classmethod
    @property
    def CROSS(cls) -> TickMarkType:
        ...

    @classmethod
    @property
    def INSIDE(cls) -> TickMarkType:
        ...

    @classmethod
    @property
    def NONE(cls) -> TickMarkType:
        ...

    @classmethod
    @property
    def OUTSIDE(cls) -> TickMarkType:
        ...

    ...

class TimeUnitType:
    @classmethod
    @property
    def NONE(cls) -> TimeUnitType:
        ...

    @classmethod
    @property
    def DAYS(cls) -> TimeUnitType:
        ...

    @classmethod
    @property
    def MONTHS(cls) -> TimeUnitType:
        ...

    @classmethod
    @property
    def YEARS(cls) -> TimeUnitType:
        ...

    ...

class TrendlineType:
    @classmethod
    @property
    def EXPONENTIAL(cls) -> TrendlineType:
        ...

    @classmethod
    @property
    def LINEAR(cls) -> TrendlineType:
        ...

    @classmethod
    @property
    def LOGARITHMIC(cls) -> TrendlineType:
        ...

    @classmethod
    @property
    def MOVING_AVERAGE(cls) -> TrendlineType:
        ...

    @classmethod
    @property
    def POLYNOMIAL(cls) -> TrendlineType:
        ...

    @classmethod
    @property
    def POWER(cls) -> TrendlineType:
        ...

    ...

